2020-01-08      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* updated all copyright dates for 2020.

2020-01-08      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/bnf/mc-1.bnf:  backported from trunk.
	* gm2/bnf/mc-2.bnf:  backported from trunk.
	* gm2/bnf/mc-3.bnf:  backported from trunk.
	* gm2/bnf/mc-4.bnf:  backported from trunk.
	* gm2/bnf/mc-5.bnf:  backported from trunk.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  fixed string
          format (printf) \n \t interpretation.  Backported fix
	  from trunk.
	* gm2/gm2-compiler/M2Quads.mod::  fixed string
          format (printf) \n \t interpretation.  Backported fix
	  from trunk.
	* gm2/gm2-compiler/SymbolTable.def::  fixed string
          format (printf) \n \t interpretation.  Backported fix
	  from trunk.
	* gm2/gm2-compiler/SymbolTable.mod::  fixed string
          format (printf) \n \t interpretation.  Backported fix
	  from trunk.
	* gm2/gm2-libs/FormatStrings.def::  fixed string
          format (printf) \n \t interpretation.  Backported fix
	  from trunk.
	* gm2/gm2-libs/FormatStrings.mod::  fixed string
          format (printf) \n \t interpretation.  Backported fix
          from trunk.
	* gm2/mc-boot/GASCII.c:  regenerated.
	* gm2/mc-boot/GASCII.h:  regenerated.
	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GArgs.h:  regenerated.
	* gm2/mc-boot/GAssertion.c:  regenerated.
	* gm2/mc-boot/GAssertion.h:  regenerated.
	* gm2/mc-boot/GBreak.c:  regenerated.
	* gm2/mc-boot/GBreak.h:  regenerated.
	* gm2/mc-boot/GCOROUTINES.h:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GCmdArgs.h:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDebug.h:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated.
	* gm2/mc-boot/GEnvironment.c:  regenerated.
	* gm2/mc-boot/GEnvironment.h:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFIO.h:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.h:  regenerated.
	* gm2/mc-boot/GFpuIO.c:  regenerated.
	* gm2/mc-boot/GFpuIO.h:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIO.h:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GIndexing.h:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.h:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GM2RTS.h:  regenerated.
	* gm2/mc-boot/GMemUtils.c:  regenerated.
	* gm2/mc-boot/GMemUtils.h:  regenerated.
	* gm2/mc-boot/GNumberIO.c:  regenerated.
	* gm2/mc-boot/GNumberIO.h:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.h:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.h:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GRTint.h:  regenerated.
	* gm2/mc-boot/GSArgs.c:  regenerated.
	* gm2/mc-boot/GSArgs.h:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/GSFIO.h:  regenerated.
	* gm2/mc-boot/GSYSTEM.h:  regenerated.
	* gm2/mc-boot/GSelective.h:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStdIO.h:  regenerated.
	* gm2/mc-boot/GStorage.c:  regenerated.
	* gm2/mc-boot/GStorage.h:  regenerated.
	* gm2/mc-boot/GStrCase.c:  regenerated.
	* gm2/mc-boot/GStrCase.h:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStrIO.h:  regenerated.
	* gm2/mc-boot/GStrLib.c:  regenerated.
	* gm2/mc-boot/GStrLib.h:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GStringConvert.h:  regenerated.
	* gm2/mc-boot/GSysExceptions.h:  regenerated.
	* gm2/mc-boot/GSysStorage.c:  regenerated.
	* gm2/mc-boot/GSysStorage.h:  regenerated.
	* gm2/mc-boot/GTimeString.c:  regenerated.
	* gm2/mc-boot/GTimeString.h:  regenerated.
	* gm2/mc-boot/GUnixArgs.h:  regenerated.
	* gm2/mc-boot/Galists.c:  regenerated.
	* gm2/mc-boot/Galists.h:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/Gdtoa.h:  regenerated.
	* gm2/mc-boot/Gerrno.h:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Gldtoa.h:  regenerated.
	* gm2/mc-boot/Glibc.h:  regenerated.
	* gm2/mc-boot/Glibm.h:  regenerated.
	* gm2/mc-boot/Glists.c:  regenerated.
	* gm2/mc-boot/Glists.h:  regenerated.
	* gm2/mc-boot/GmcComment.c:  regenerated.
	* gm2/mc-boot/GmcComment.h:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcComp.h:  regenerated.
	* gm2/mc-boot/GmcDebug.c:  regenerated.
	* gm2/mc-boot/GmcDebug.h:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcError.h:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcFileName.h:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcMetaError.h:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcOptions.h:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPretty.h:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.h:  regenerated.
	* gm2/mc-boot/GmcQuiet.c:  regenerated.
	* gm2/mc-boot/GmcQuiet.h:  regenerated.
	* gm2/mc-boot/GmcReserved.c:  regenerated.
	* gm2/mc-boot/GmcReserved.h:  regenerated.
	* gm2/mc-boot/GmcSearch.c:  regenerated.
	* gm2/mc-boot/GmcSearch.h:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStack.h:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/GmcStream.h:  regenerated.
	* gm2/mc-boot/Gmcflex.h:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp1.h:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp2.h:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp3.h:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp4.h:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/Gmcp5.h:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GnameKey.h:  regenerated.
	* gm2/mc-boot/Gpth.h:  regenerated.
	* gm2/mc-boot/GsymbolKey.c:  regenerated.
	* gm2/mc-boot/GsymbolKey.h:  regenerated.
	* gm2/mc-boot/Gtermios.h:  regenerated.
	* gm2/mc-boot/Gtop.c:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gvarargs.h:  regenerated.
	* gm2/mc-boot/Gwlists.c:  regenerated.
	* gm2/mc-boot/Gwlists.h:  regenerated.
	* gm2/mc-boot/Gwrapc.h:  regenerated.
	* gm2/mc/Indexing.def:  backported from trunk.
	* gm2/mc/alists.def:  backported from trunk.
	* gm2/mc/alists.mod:  backported from trunk.
	* gm2/mc/decl.def:  backported from trunk.
	* gm2/mc/decl.mod:  back ported from trunk and also added
	  calls to __builtin_unreachable after a fatal exception is raised.
	* gm2/mc/keyc.def:  backported from trunk.
	* gm2/mc/keyc.mod:  backported from trunk.
	* gm2/mc/lists.def:  backported from trunk.
	* gm2/mc/m2flex.def:  backported from trunk.
	* gm2/mc/mc.flex:  backported from trunk.
	* gm2/mc/mcComment.def:  backported from trunk.
	* gm2/mc/mcComment.mod:  backported from trunk.
	* gm2/mc/mcComp.def:  backported from trunk.
	* gm2/mc/mcComp.mod:  backported from trunk.
	* gm2/mc/mcDebug.def:  backported from trunk.
	* gm2/mc/mcError.def:  backported from trunk.
	* gm2/mc/mcError.mod:  backported from trunk.
	* gm2/mc/mcFileName.def:  backported from trunk.
	* gm2/mc/mcLexBuf.def:  backported from trunk.
	* gm2/mc/mcLexBuf.mod:  backported from trunk.
	* gm2/mc/mcMetaError.def:  backported from trunk.
	* gm2/mc/mcOptions.def:  backported from trunk.
	* gm2/mc/mcOptions.mod:  backported from trunk.
	* gm2/mc/mcPreprocess.def:  backported from trunk.
	* gm2/mc/mcPretty.def:  backported from trunk.
	* gm2/mc/mcPrintf.def:  backported from trunk.
	* gm2/mc/mcQuiet.def:  backported from trunk.
	* gm2/mc/mcReserved.def:  backported from trunk.
	* gm2/mc/mcSearch.def:  backported from trunk.
	* gm2/mc/mcStack.def:  backported from trunk.
	* gm2/mc/mcStream.def:  backported from trunk.
	* gm2/mc/mcStream.mod:  backported from trunk.
	* gm2/mc/mcflex.def:  backported from trunk.
	* gm2/mc/mcp1.def:  backported from trunk.
	* gm2/mc/mcp2.def:  backported from trunk.
	* gm2/mc/mcp3.def:  backported from trunk.
	* gm2/mc/mcp4.def:  backported from trunk.
	* gm2/mc/mcp5.def:  backported from trunk.
	* gm2/mc/nameKey.def:  backported from trunk.
	* gm2/mc/nameKey.mod:  backported from trunk.
	* gm2/mc/symbolKey.def:  backported from trunk.
	* gm2/mc/symbolKey.mod:  backported from trunk.
	* gm2/mc/top.mod:  backported from trunk.
	* gm2/mc/varargs.def:  backported from trunk.
	* gm2/mc/varargs.mod:  backported from trunk.
	* gm2/mc/wlists.def:  backported from trunk.
	* gm2/mc/wlists.mod:  backported from trunk.

2019-11-05      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (gm2/gm2-libs/gm2-libs-target.h)
          removed.   (gm2/gm2-libs-iso/%.o) replaced gm2-libs-target
          with gm2-libs-host.h.  (gm2/gm2-libs/gm2-libs-host.h)
          pass --libdir, --libexecdir to configure.
          (build-libs-min) removed.
          (archive-libs-min) removed.
          (build-libs) removed.
          (archive-libs) removed.
          (build-compiler) removed.
          (gm2/gm2-libs/libgm2.a) removed.
          (build-libs-iso) removed.
          (archive-libs-iso) removed.
          (build-libs-ulm) removed.
          (archive-libs-ulm) removed.
          (build-libs-pim) removed.
          (archive-libs-pim) removed.
          (build-libs-coroutines) removed.

2019-11-04      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (gm2.all.cross) added
          plugin/m2rte$(exeext).so as a dependency.
	* gm2/gm2-libs/config-host.in:  (AC_CHECK_HEADERS)
          quote all header files.
	* gm2/Make-lang.in:  (gm2.all.cross) added
          $(GM2_LINK_TOOLS) as dependencies.

2019-10-30      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  pruned old comments.  (GM2_DIRS)
	  removed.  All directory targets are tested before being created.
	* gm2/config-lang.in:  directory creation moved into configure.
          (fixes a bug reported by Matthias Klose) where make install
	  would relink cc1gm2.

2019-10-29      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (gm2/gm2-gcc/%.o) added target dependencies.
          (gm2/gm2-compiler-boot/m2flex.o) added target dependencies.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)libc.o) explicit rule.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)mcrts.o) explicit rule.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)UnixArgs.o) explicit rule.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)Selective.o) explicit rule.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)termios.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)SysExceptions.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)ldtoa.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)dtoa.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)wrapc.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)SYSTEM.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)errno.o) explicit rule.
          (gm2/gm2-pge/boot/$(SRC_PREFIX)pth.o) explicit rule.
	* testsuite/gm2/iso/run/pass/unbounded.mod:  added many
          more asserts.
	* gm2/Make-lang.in:  (gm2/gm2-gcc/%.o) added MCDEPS LIBDEPS.
          (gm2/gm2-pge-boot/$(SRC_PREFIX)%.o) place C file into
          gm2/gm2-pge-boot.  (gm2/gm2-pge-boot/%.o) place C file into
          gm2/gm2-pge-boot.
	* gm2/Make-lang.in:  (gm2.install-plugin) removed dependancy to
          plygin/m2rte$(exeext).so.

2019-10-23      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GEnvironment.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GNumberIO.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTco.h:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStrCase.c:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStrLib.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GSysStorage.c:  regenerated.
	* gm2/mc-boot/GTimeString.c:  regenerated.
	* gm2/mc-boot/Galists.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Glists.c:  regenerated.
	* gm2/mc-boot/GmcComment.c:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcDebug.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcQuiet.c:  regenerated.
	* gm2/mc-boot/GmcSearch.c:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GsymbolKey.c:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gwlists.c:  regenerated.
	* gm2/mc/decl.mod:  (forceCompoundStatement) New boolean.
          (doCompoundStmt) check whether a compound statement should be
          forced.  (doElsifC) check whether a compound statement should
          be forced.
	* testsuite/gm2/errors/fail/gm2.exp:  (-Wunused-variable) added.

2019-10-22      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-gcc/m2expr.c:  (append_digit) use temporary
          variables to hold the intermediate results before testing
          if they are less than the rhs.
	* append_m2_digit:  (append_digit) use temporary
          variables to hold the intermediate results before testing
          if they are less than the rhs.
	* gm2/gm2-libs-ch/dtoa.c:  (calcmaxsig) use memmove rather
	  than strncpy.  (calcsign) use memmove rather
          than strncpy.
	* gm2/mc-boot-ch/Gdtoa.c:  (calcmaxsig) use memmove rather
	  than strncpy.  (calcsign) use memmove rather
          than strncpy.
	* libgm2/libpim/dtoa.c:  (calcmaxsig) use memmove rather
	  than strncpy.  (calcsign) use memmove rather
          than strncpy.

2019-10-10      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/m2.flex:  use time_t rather than long as the
          parameter type casted to 0.
	* gm2/lang.opt:  frange, findex, fwholediv re-enabled.
	* gm2/gm2-lang.c:  frange, findex, fwholediv re-enabled.
	* gm2/gm2-libs/Builtins.def:  added boilerplate.
          (longjmp) removed.  (setjmp) removed.
	  Associated testsuite tests archived.

2019-09-21      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/mc/decl.mod:  huge amount of changes as the
          varient record for intrinsics were being used
          inconsistently.
	* gm2/mc-boot:  regenerated.

2019-09-18      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-libs/FIO.mod:  bugfix via valgrind, off by one
          error corrected.
	* (mc) regenerated.

2019-09-04      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/tools-src/def2texi.py:  replaced print((x)) with
	  print(x).

2019-09-04      Matthias Klose  <doko@cs.tu-berlin.de>

	* gm2/examples/gravity/testsim.py:  python2 to 3 conversion.
	* gm2/examples/gravity/testsim2.py:  python2 to 3 conversion.
	* gm2/examples/pge/examples/boxes.py:  python2 to 3 conversion.
	* gm2/examples/pge/examples/exampleBoxes.py:  python2 to 3 conversion.
	* gm2/examples/pge/examples/triangle.py:  python2 to 3 conversion.
	* gm2/examples/pge/fig.py:  python2 to 3 conversion.
	* gm2/examples/pge/max2code.py:  python2 to 3 conversion.
	* gm2/examples/pge/mxmmaxima.py:  python2 to 3 conversion.
	* gm2/examples/pge/mxmout.py:  python2 to 3 conversion.
	* gm2/examples/pge/mxmparser.py:  python2 to 3 conversion.
	* gm2/examples/pge/mxmtree.py:  python2 to 3 conversion.
	* gm2/examples/pge/pge.py:  python2 to 3 conversion.
	* gm2/examples/pge/pgeplayback.py:  python2 to 3 conversion.
	* gm2/examples/pge/pgepygame.py:  python2 to 3 conversion.
	* gm2/examples/pge/t.py:  python2 to 3 conversion.
	* gm2/examples/server/client.py:  python2 to 3 conversion.
	* gm2/examples/swig/dual/testdual.py:  python2 to 3 conversion.
	* gm2/examples/swig/exceptions/stresstiny.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/exceptions/testtiny.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/full-strlib/testcopy.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/full-strlib/testequ.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/full-strlib/testlen.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/full-strlib/testnum.py:  python2 to 3
	  conversion.
	* gm2/examples/swig/strlen/testlen.py:  python2 to 3 conversion.
	* gm2/examples/swig/strlib/testlen.py:  python2 to 3 conversion.
	* gm2/examples/swig/tiny/testtiny.py:  python2 to 3 conversion.
	* gm2/tools-src/array2index.py:  python2 to 3 conversion.
	* gm2/tools-src/def2texi.py:  python2 to 3 conversion.
	* gm2/tools-src/gensum.py:  python2 to 3 conversion.
	* gm2/tools-src/tidydates.py:  python2 to 3 conversion.
	* gm2/www/tools/texi2tr/src/navigation.py:  python2 to 3 conversion.
	* gm2/www/tools/texi2tr/src/outputdev.py:  python2 to 3 conversion.
	* gm2/www/tools/texi2tr/src/texi2tr.py:  python2 to 3 conversion.
	* gm2/Make-lang.in:  use python3 rather than python2.
	* gm2/examples/gravity/Makefile.in:  use python3 rather than
	  python2.
	* gm2/examples/gravity/README:  reference python3.
	* gm2/examples/pge/Makefile.in:  use python3 rather than python2.
	* gm2/examples/pge/debugthis:  use python3 rather than python2.
	* gm2/examples/pge/max2code:  use python3 rather than python2.
	* gm2/examples/pge/runfig:  use python3 rather than python2.
	* gm2/examples/pge/runthis:  use python3 rather than python2.
	* gm2/examples/swig/dual/Makefile.in:  use python3 rather than
	  python2.
	* gm2/examples/swig/exceptions/Makefile.in:  use python3 rather
	  than python2.
	* gm2/examples/swig/full-strlib/Makefile.in:  use python3 rather
          than python2.
	* gm2/examples/swig/strio/Makefile.in:  use python3 rather than
	  python2.
	* gm2/examples/swig/strlen/Makefile:  use python3 rather than
	  python2.
	* gm2/examples/swig/strlib/Makefile.in:  use python3 rather than
	  python2.
	* gm2/examples/swig/tiny/Makefile.in:  use python3 rather than
	  python2.
	* gm2/www/Makefile.in:  use python3 rather than python2.
	* gm2/examples/gravity/testsim.py:  python2 to 3 conversion.
	* gm2/examples/gravity/testsim2.py:  python2 to 3 conversion.
	* gm2/examples/pge/examples/boxes.py:  python2 to 3 conversion.
	* gm2/examples/pge/examples/exampleBoxes.py:  python2 to 3
	  conversion.
	* gm2/examples/pge/examples/triangle.py:  python2 to 3
	  conversion.
	* gm2/examples/pge/fig.py:  python2 to 3 conversion.
	* gm2/examples/pge/max2code.py:  python2 to 3 conversion.
	* gm2/examples/pge/pge.py:  python2 to 3 conversion.
	* gm2/examples/pge/pgeplayback.py:  python2 to 3 conversion.
	* gm2/examples/pge/pgepygame.py:  python2 to 3 conversion.
	* gm2/examples/pge/t.py:  python2 to 3 conversion.
	* gm2/examples/server/client.py:  python2 to 3 conversion.
	* gm2/examples/swig/full-strlib/testequ.py:  python2 to 3
	  conversion.
	* gm2/tools-src/array2index.py:  python2 to 3 conversion.
	* gm2/tools-src/def2texi.py:  python2 to 3 conversion.
	* gm2/tools-src/gensum.py:  python2 to 3 conversion.
	* gm2/tools-src/tidydates.py:  python2 to 3 conversion.
	* gm2/www/tools/texi2tr/src/navigation.py:  python2 to 3
	  conversion.
	* gm2/www/tools/texi2tr/src/outputdev.py:  python2 to 3
	  conversion.
	* gm2/www/tools/texi2tr/src/texi2tr.py:  python2 to 3
	  conversion.
	* gm2/tools-src/def2texi.py:  python2 to 3 conversion.

2019-09-04      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/examples/pge/pge2d.py:  removed.
	* gm2/Make-lang.in:  convert source build rules to use
          $(STAMP).  (gm2/gm2version.c) rewritten for $(STAMP).
          (gm2.pod) rewritten for $(STAMP).
          (gm2/gm2-libs.texi) rewritten for $(STAMP).
          (gm2/gm2-ebnf.texi) rewritten for $(STAMP).
          (gm2/SYSTEM-pim.texi) rewritten for $(STAMP).
          (gm2/SYSTEM-iso.texi) rewritten for $(STAMP).
          (gm2/Builtins.texi) rewritten for $(STAMP).
          (gm2/version.texi) rewritten for $(STAMP).
          (gm2/gm2-libs-boot/pthdummy.o) removed $(MCDEPS).

2019-08-22      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  added $(srcdir) to prevent
          race hazard in building from gm2/gm2-pge-boot/*c
	  files.

2019-08-20      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  use -p parameter for mkdir.

2019-08-20      Matthias Klose  <doko@cs.tu-berlin.de>

	* gm2/Make-lang.in:  added dependancies for subdir
          creation.

2019-08-20      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/tools-src/buildsyntax:  removed function keyword
          to be sh complient rather than bash.
	* gm2/tools-src/makeSystem:  removed function keyword
          to be sh complient rather than bash.
	* gm2/tools-src/makeconfigure:  removed function keyword
          to be sh complient rather than bash.
	* gm2/tools-src/makeversion:  removed function keyword
          to be sh complient rather than bash.  Also use = rather
          than ==.

2019-08-16      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (gm2/pge) added -lgcov.
          (gm2/pg) added -lgcov.  (gm2/ppg)
          added -lgcov.  (gm2/boot-bin/mc) added -lgcov.

2019-08-13      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (check-gm2) removed, use inbuilt
          version.  (lang_checks) include check-gm2.
	* testsuite/gm2/calling-c/datatypes/unbounded/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/examples/callingC/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/exceptions/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/extensions/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/imports/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/linking/libarchive/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/pim/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/gm2/types/run/pass/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.
	* testsuite/lib/gm2.exp:
          use rootme and rootme/gm2 rather than tmpdir.

2019-08-13      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/lang-specs.h:  added %d to the temporary
          assembly file.

2019-08-12      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* New branch gcc_9_2_0_gm2
	* gm2/configure.in:  changed release number to 1.9.2.
	* gm2/gm2-libs/config-host.in:  changed release number to 1.9.2.
	* gm2/version.c:  changed release number to 1.9.2.
	* gm2/NEWS:  added reference to 1.9.2.
	* gm2/patches/gcc/9.2.0/01-patches:  New file.
	* gm2/patches/gcc/9.2.0/02-patches:  New file.
	* gm2/patches/gcc/9.2.0/03-patches:  New file.
	* gm2/patches/gcc/9.2.0/04-patches:  New file.
	* gm2/patches/gcc/9.2.0/05-patches:  New file.
	* gm2/patches/gcc/9.2.0/06-patches:  New file.
	* gm2/patches/gcc/9.2.0/07-patches:  New file.
	* gm2/patches/gcc/9.2.0/08-patches:  New file.
	* gm2/patches/gcc/9.2.0/09-patches:  New file.
	* gm2/patches/gcc/9.2.0/10-patches:  New file.
	* gm2/patches/gcc/9.2.0/11-patches:  New file.
	* gm2/patches/gcc/9.2.0/12-patches:  New file.
	* gm2/patches/gcc/9.2.0/13-patches:  New file.
	* gm2/patches/gcc/9.2.0/14-patches:  New file.
	* gm2/patches/gcc/9.2.0/15-patches:  New file.

2019-08-05      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-libs-iso/SYSTEM.mod:  (RotateVal)
          added extra comment.  RotateCount is truncated to
	  modulus set size.
	* gm2/gm2-libs/SYSTEM.mod:  (RotateVal)
          added extra comment.  RotateCount is truncated to
	  modulus set size.

2019-08-02      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* testsuite/gm2/sets/run/pass/simple.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple2.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple3.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple4.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple5.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple6.mod:  New file.
	* testsuite/gm2/sets/run/pass/simple7.mod:  New file.
	* testsuite/gm2/sets/run/pass/setarith2.mod:  New file.
	* testsuite/gm2/sets/run/pass/setarith3.mod:  New file.
	* testsuite/gm2/sets/run/pass/setarith4.mod:  New file.
	* testsuite/gm2/sets/run/pass/setarith.mod:  New file.
 	* testsuite/gm2/sets/run/pass/setrotate2.mod:  New file.
	* testsuite/gm2/sets/run/pass/setrotate3.mod:  New file.
	* testsuite/gm2/sets/run/pass/setrotate4.mod:  New file.
	* testsuite/gm2/sets/run/pass/setrotate.mod:  New file.
	* testsuite/gm2/sets/run/pass/setshift2.mod:  New file.
	* testsuite/gm2/sets/run/pass/setshift.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetarith2.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetarith3.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetarith4.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetarith.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetrotate2.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetrotate3.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetrotate4.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetrotate.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetshift2.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisetshift.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple2.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple3.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple4.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple5.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple6.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple7.mod:  New file.
	* testsuite/gm2/sets/run/pass/multisimple.mod:  New file.

2019-07-10      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  (gm2.common-install) removed gm2m
          from being installed in bin and rewritten the install
          shell script.  Tools are installed without transformed
          names into libexecsubdir.  Compiler is installed with
          transformed name into bin.
          Many parallel build fixes backported from trunk and
	  dependancies fixed.

2019-07-09      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* testsuite/lib/gm2.exp:  pass -fno-diagnostics-show-caret,
          -fno-diagnostics-show-line-numbers and
          -fdiagnostics-color=never to gm2 when running dejagnu.

2019-07-09      Matthias Klose  <doko@cs.tu-berlin.de>

	* gm2/patches/gcc/9.1.0/11-patches:  New file.
          Provides langhook patches for Fortran, Go, D, Brig.

2019-07-09      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  backported gm2/Make-file.in from
          trunk.  Many changes which allow for parallel builds.
          Many dependancies added and rules rewritten.

2019-05-10      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/NEWS:  updated with information about 1.9.1.
	* gm2/configure.in:  changed release number to 1.9.1.
	* gm2/gm2-libs/config-host.in:  changed release number to 1.9.1.
	* gm2/version.c:  changed release number to 1.9.1.

2019-05-09      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2Options.def:  (SetWall) new procedure.
	* gm2/gm2-compiler/M2Options.mod:  (SetWall) implement by setting
	  UnusedVariableChecking, UnusedParameterChecking,
          PedanticParamNames, StudentChecking, PedanticCast to value.
	* gm2/gm2-lang.c:  introduce new case clause for -Wall.
	* gm2/lang.opt:  enable -Wall for Modula-2.
	* gm2/gm2.texi:  document availability of -Wall.
	* gm2/gm2-compiler/M2Quads.mod:  corrected error message format
	  specifier.
	* gm2/gm2-compiler/M2Quads.mod:
          (CheckUninitializedVariablesAreUsed) improved warning message.

2019-05-08      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/patches/gcc/9.1.0:  new directory and contents
	* gm2/patches/gcc/9.1.0/01-patches:  New file.
	* gm2/patches/gcc/9.1.0/02-patches:  New file.
	* gm2/patches/gcc/9.1.0/03-patches:  New file.
	* gm2/patches/gcc/9.1.0/04-patches:  New file.
	* gm2/patches/gcc/9.1.0/05-patches:  New file.
	* gm2/patches/gcc/9.1.0/06-patches:  New file.
	* gm2/patches/gcc/9.1.0/07-patches:  New file.
	* gm2/patches/gcc/9.1.0/08-patches:  New file.
	* gm2/patches/gcc/9.1.0/09-patches:  New file.
	* gm2/patches/gcc/9.1.0/10-patches:  New file.
	* gcc_9_1_0_gm2:  branch.
	* gm2/gm2-compiler/M2Options.def:  UnusedVariableChecking
          and UnusedParameterChecking declared and exported.
          (SetReturnCheck) added comment.  (SetNilCheck) added comment.
          (SetUnusedVariableChecking) New procedure.
          (SetUnusedParameterChecking) New procedure.
	* gm2/gm2-compiler/M2Options.mod:  (SetUnusedVariableChecking)
	  Implement new procedure.  (SetUnusedParameterChecking)
          Implement new procedure.  Initialize UnusedVariableChecking
          and UnusedParameterChecking
	* gm2/gm2-compiler/M2Quads.mod:
          (CheckUninitializedVariablesAreUsed) use the option variables
          UnusedParameterChecking and UnusedVariableChecking when
          performing semantic checks.
	* gm2/gm2-gcc/m2options.h:  (SetUnusedVariableChecking) added
          prototype.  (SetUnusedParameterChecking) added prototype.
	* gm2/gm2-lang.c:  handle Wunused_variable and Wunused_parameter.
	* gm2/gm2.texi:  add Wunused_variable and Wunused_parameter to
          the list of options with a description of their behaviour.
	* gm2/lang-options.h:  corrected GPL comment.  Added
          Wunused_variable and Wunused_parameter options.
	* gm2/lang.opt:  added Wunused_variable and Wunused_parameter
          options.
	* gm2/lang.opt:  removed description.

2019-05-07      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2ColorString.mod:  (quoteClose)
          reimplemented so that the existing color is shutdown
	  before end quote.
	* gm2/gm2-compiler/M2MetaError.mod:  shutdown color
	  within a quote.
	* gm2/gm2-compiler/M2Quads.mod:  many error messages
          using WriteFormat are replaced with MetaError
	  counterparts.  Both simplifying and cleaning up code.

2019-05-04      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2ALU.mod:  changed all calls WriteFormat
	  to use MetaError instead.
	* gm2/gm2-compiler/M2Comp.mod:  use M2MetaError primtives
          instead of M2Error to allow for colorization.
	* gm2/gm2-compiler/M2GenGCC.mod:   use M2MetaError primtives
          instead of M2Error to allow for colorization.
	* gm2/gm2-compiler/M2MetaError.def:  corrected comment spec.
	  Added {%F} spec.
	* gm2/gm2-compiler/M2MetaError.mod:  (filename) New procedure.
	  (op) call filename.
	* gm2/gm2-compiler/P0SymBuild.mod:  use M2MetaError primtives
          instead of M2Error to allow for colorization.  Improve
          incorrect begin block/end block error messages for modules
          and procedures.
	* gm2/gm2-compiler/P1SymBuild.mod:  use M2MetaError primtives
          instead of M2Error to allow for colorization.  Rewritten
          many error messages to take advantage of color and keyword
          rendering.
	* gm2/gm2-compiler/SymbolTable.def:  (MakeErrorS)  New procedure
          function.
	* gm2/gm2-compiler/SymbolTable.mod:  (MakeErrorS)  Implement
          new procedure function.  Replace some calls to WriteFormat1
	  with MetaError1.

2019-05-03      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/gm2-mode.el:  added BITSET to the list of data types.
	* gm2/gm2-compiler/M2Error.mod:  added ability to create notes.
	* gm2/gm2-compiler/M2LexBuf.mod:  removed Assert on
          currenttoken#eoftok as the first token might be an eof.
	* gm2/gm2-compiler/M2MetaError.def:  MetaErrorN1, MetaErrorN2
	  (New procedures defined).
	* gm2/gm2-compiler/M2MetaError.mod:  MetaErrorN1, MetaErrorN2
          (New procedures implemented).
	* gm2/gm2-compiler/M2Printf.mod:  reformatted using GNU coding
          standards.
	* gm2/gm2-compiler/M2Quads.mod:  use (MetaError0) and (MetaError1)
          rather than ErrorString.  Change keyword in error messages to
          use appropriate tags.
	* gm2/gm2-compiler/M2Students.mod:  corrected format specifiers.
	* gm2/gm2-compiler/P0SymBuild.mod:  use MetaError primitives
          rather than M2Error primitives.
	* gm2/gm2-libs/FormatStrings.mod:  corrected many formatting
          bugs.
	* gm2/pimlib/run/pass/format.mod:  new test program.
	* gm2/gm2-compiler/M2Students.mod:  corrected format specifier
	  so that the symbol is quoted.

2019-04-29      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  corrected front end name.
	* gm2/bnf/gm2m.bnf:  updated the GPL address.  Removed
          unnecessary forward declarations.  Adjusted comment for GNU
	  coding standards.
	* gm2/gm2-compiler/M2LexBuf.mod:  improved diagnostic routines.
	* gm2/gm2-compiler/M2Students.mod:  replaced M2Error string based
          routines with new M2MetaError routines (which generate GCC notes).
	* gm2/gm2-compiler/P2SymBuild.mod:  (MakeVar) call
	  CheckForVariableThatLooksLikeKeyword.
	* gm2/mc-boot/GDynamicStrings.c:  (rebuilt).
	* gm2/mc-boot/GFIO.c:  (rebuilt).
	* gm2/mc-boot/GNumberIO.c:  (rebuilt).
	* gm2/mc-boot/GRTExceptions.c:  (rebuilt).
	* gm2/mc-boot/GRTint.c:  (rebuilt).
	* gm2/mc-boot/GStringConvert.c:  (rebuilt).
	* gm2/mc-boot/Galists.c:  (rebuilt).
	* gm2/mc-boot/Gdecl.c:  (rebuilt).
	* gm2/mc-boot/Gkeyc.c:  (rebuilt).
	* gm2/mc-boot/GmcComment.c:  (rebuilt).
	* gm2/mc-boot/GmcComp.c:  (rebuilt).
	* gm2/mc-boot/GmcError.c:  (rebuilt).
	* gm2/mc-boot/GmcLexBuf.c:  (rebuilt).
	* gm2/mc-boot/GmcStream.c:  (rebuilt).
	* gm2/mc-boot/Gmcp1.c:  (rebuilt).
	* gm2/mc-boot/Gmcp2.c:  (rebuilt).
	* gm2/mc-boot/Gmcp3.c:  (rebuilt).
	* gm2/mc-boot/Gmcp4.c:  (rebuilt).
	* gm2/mc-boot/Gmcp5.c:  (rebuilt).
	* gm2/mc-boot/GnameKey.c:  (rebuilt).
	* gm2/mc-boot/GsymbolKey.c:  (rebuilt).
	* gm2/mc-boot/Gtop.c:  (rebuilt).
	* gm2/mc-boot/Gvarargs.c:  (rebuilt).
	* gm2/mc-boot/Gwlists.c:  (rebuilt).
	* gm2/mc/decl.mod:  detect dangling else for nested if statements.
	  Fixes a bug reported by Derek Wyss (gm2m fails to pass a module).
	* testsuite/gm2/pim/pass/ABSBug.mod:  added line break.
	* gm2/gm2-compiler/M2MetaError.mod:  improved InternalFormat
          error message.
	* gm2/gm2-compiler/M2Students.mod:  (PerformVariableKeywordCheck)
          duplicate string.  (CheckAsciiName)  correct parameter order so
	  that scope and variable name are correct.

2019-04-26      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-libs-ch/Selective.c:  fixed copyright notice.
          Also removed references to p2c and added GCC header
          config and portable include files.  Tidied up comments
	  and made them GNU complient.
	* libgm2/libpim/Selective.c:  fixed copyright notice.
          Tidied up comments and made them GNU complient.
	* gm2/Make-lang.in:  make xlibc.o dependant upon gm2-libs-host.h.
          (stage2/gm2/gm2m$(exeext)) reqritten rule to use $(LINKER).
	  gm2m links with tools.o.
	* gm2/gm2-libs-ch/xlibc.c:  implement xstrdup.
	* gm2/gm2-libs-ch/tools.c:  New file.

2019-04-25      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2MetaError.def:  (MetaErrorT0)
          declare and export.
	* gm2/gm2-compiler/M2MetaError.mod:  (pop) copy
          the error type back to the caller.   (MetaErrorT0)
          new procedure.
	* gm2/gm2-compiler/M2Range.mod:  import (MetaErrorT0)
          and replace MetaErrorT1 with MetaErrorT0.  Ensure that
          all warnings are have the 'W' format specifier.
	  Ensure that all errors use 'E' for consistency.

2019-04-24      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2GenGCC.mod:  (DescribeError)
          corrected symbol numbers.
	* gm2/gm2-compiler/M2MetaError.def:  large number of
          additions new format specifiers 'S', 'T', 'u', 'k'.
	* gm2/gm2-compiler/M2MetaError.mod:  much debugging code
          added and bug fixes for color changes implemented.
          Also implemented the above format specifiers.
	* gm2/gm2-compiler/M2Quads.mod:  (FailParameter) and
	  (WarnParameter) use new format specifiers in M2MetaError.

2019-04-23      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2MetaError.def:  added MetaErrorString0.
	* gm2/gm2-compiler/M2MetaError.mod:  many bug fixes which
          implement coloring when concatenating strings.
	* gm2/gm2-compiler/M2Students.mod:
          (CheckForVariableThatLooksLikeKeyword) New procedure.
          (PerformVariableKeywordCheck) reimplemented to use
          MetaErrorString0.
	* gm2/gm2-compiler/SymbolTable.mod:  reimplemented
	  CheckForSymbols using the MetaError substructure.

2019-04-18      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Makefile.in:  removed purge of p2c components.
	* gm2/gm2-gcc/m2expr.c:  corrected comment formatting.
	* gm2/gm2-internals.texi:  added a line saying this is out of
          date.
	* gm2/gm2builtins.c:  removed.
	* gm2/gm2except.c:  removed.
	* gm2/p2c:  removed directory.
	* gm2/p2crc:  removed.
	* testsuite/gm2/pim/run/pass/integer.mod:  added
	* testsuite/gm2/pim/fail/integer.mod:  added

2019-04-17      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/bnf/m2-2.bnf:  replaced ErrorStringAt with MetaErrorStringT0
	  for GCC colorization.
	* gm2/bnf/m2.bnf:  replaced ErrorStringAt with MetaErrorStringT0
	  for GCC colorization.
	* gm2/gm2-compiler/M2MetaError.def:  added root, chain and color
	  directives.
	* gm2/gm2-compiler/M2MetaError.mod:  added root, chain and color
	  directives.  Applied many fixes.
	* gm2/gm2-compiler/ppg.mod:  added keyword directives to error
          messages.
	* gm2/gm2.texi:  (-fm2-lower-case) added description for option.

2019-04-16      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2ColorString.def:  rewritten.
	* gm2/gm2-compiler/M2ColorString.mod:  rewritten.
	* gm2/gm2-compiler/M2Error.def:  New procedures (NewNote) and (SetColor).
	* gm2/gm2-compiler/M2Error.mod:  New procedures (NewNote) and
          (SetColor) implemented.  Also enable colors in legacy error messages.
	* gm2/gm2-compiler/M2MetaError.def:  added {%O}, {%K} %< and %>.
	* gm2/gm2-compiler/M2MetaError.mod:  implemented {%O}, %< and
          %> and fixed many bugs.
	* gm2/gm2-compiler/SymbolTable.mod:  rewritten undefined symbol error
          messages to use M2MetaError.
	* gm2/Make-lang.in:  make ppg use the -k option.
	* gm2/gm2-compiler/M2GenGCC.mod:  use MetaError and simplify the
          error reporting.
	* gm2/gm2-compiler/M2MetaError.def:  correct comments.
	* gm2/gm2-compiler/M2MetaError.mod:  handle the keyword and
          default all messages to the error color.
	* gm2/gm2-compiler/SymbolTable.mod:  use MetaError and tidied up
	  UndeclaredSymbolError and callees.
	* gm2/gm2-compiler/ppg.mod:  implement the -k option to generate
	  GCC error formatting directives.

2019-04-14      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/CLexBuf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/CLexBuf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/FifoQueue.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/FifoQueue.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/Lists.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Lists.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2ALU.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2ALU.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2AsmUtil.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2AsmUtil.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Base.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Base.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2BasicBlock.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2BasicBlock.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Batch.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Batch.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Bitset.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Bitset.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2CaseList.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2CaseList.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Code.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Code.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Comp.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Comp.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Configure.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Configure.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Const.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Const.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Debug.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Debug.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DebugStack.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DebugStack.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Defaults.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Defaults.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Depth.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Depth.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DriverOptions.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DriverOptions.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Error.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Error.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2FileName.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2FileName.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GCCDeclare.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GenGCC.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GenGCC.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Lex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Lex.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2LexBuf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2LexBuf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2MetaError.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2MetaError.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Optimize.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Optimize.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Options.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Options.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Pass.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Pass.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Preprocess.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Preprocess.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Printf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Printf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quads.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quads.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quiet.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quiet.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Range.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Reserved.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Reserved.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Scope.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Scope.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Search.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Search.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Size.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Size.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackAddress.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackAddress.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackWord.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackWord.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Students.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Students.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Swig.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Swig.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2System.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2System.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/NameKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/NameKey.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/ObjectFiles.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/ObjectFiles.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SyntaxCheck.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P1SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P1SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCSymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCSymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/Sets.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Sets.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolConversion.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolConversion.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolKey.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolTable.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolTable.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/bnflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/bnflex.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/cflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2builtins.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2lcc.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2lgen.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2lorder.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/m2flex.def:  added summary and dates for GPL.
	* gm2/gm2-gcc/m2color.c:  New file.
	* gm2/gm2-gcc/m2color.h:  New file.
	* gm2/gm2-gcc/m2color.def:  New file.
	* gm2/gm2-compiler/M2ColorString.def:  New file.
	* gm2/gm2-compiler/M2ColorString.mod:  New file.
	* gm2/gm2-compiler/M2ColorString.mod:  Changed character to string
	  to handle utf8 quotation.

2019-04-12      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/CLexBuf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/CLexBuf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/FifoQueue.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/FifoQueue.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/Lists.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Lists.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2ALU.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2ALU.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2AsmUtil.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2AsmUtil.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Base.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Base.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2BasicBlock.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2BasicBlock.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Batch.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Batch.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Bitset.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Bitset.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2CaseList.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2CaseList.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Code.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Code.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Comp.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Comp.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Configure.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Configure.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Const.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Const.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Debug.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Debug.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DebugStack.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DebugStack.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Defaults.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Defaults.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Depth.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Depth.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DriverOptions.def:  added summary and dates
	for GPL.
	* gm2/gm2-compiler/M2DriverOptions.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2Error.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Error.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2FileName.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2FileName.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GCCDeclare.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2GenGCC.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GenGCC.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Lex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Lex.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2LexBuf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2LexBuf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2MetaError.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2MetaError.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2Optimize.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Optimize.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Options.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Options.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Pass.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Pass.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Preprocess.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2Preprocess.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2Printf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Printf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quads.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quads.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quiet.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quiet.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Range.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Reserved.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Reserved.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Scope.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Scope.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Search.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Search.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Size.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Size.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackAddress.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2StackAddress.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2StackWord.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2StackWord.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/M2Students.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Students.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Swig.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Swig.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2System.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2System.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/NameKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/NameKey.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/ObjectFiles.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/ObjectFiles.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/P0SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SyntaxCheck.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/P1SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P1SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3SymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCSymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCSymBuild.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/Sets.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Sets.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolConversion.def:  added summary and dates
	for GPL.
	* gm2/gm2-compiler/SymbolConversion.mod:  added summary and dates
	for GPL.
	* gm2/gm2-compiler/SymbolKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolKey.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolTable.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/SymbolTable.mod:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/bnflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/bnflex.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/cflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2builtins.def:  added summary and dates for
	GPL.
	* gm2/gm2-compiler/gm2lcc.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2lgen.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2lorder.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/m2flex.def:  added summary and dates for GPL.
	* gm2/mc/mcComment.mod:  added summary and dates for GPL.
	* gm2/mc/mcError.mod:  added summary and dates for GPL.
	* gm2/mc/mcLexBuf.mod:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GenGCC.mod:  (ConvertTo) improve comment.

2019-04-09      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-libs-min/M2RTS.def:  added summary and dates for GPL.
	* gm2/gm2-libs-min/M2RTS.mod:  added summary and dates for GPL.
	* gm2/gm2-libs-min/SYSTEM.def:  added summary and dates for GPL.
	* gm2/gm2-libs-min/SYSTEM.mod:  added summary and dates for GPL.
	* gm2/gm2-libs-min/libc.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/BitBlockOps.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/BitByteOps.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/BitWordOps.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/BlockOps.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Break.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/CardinalIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Conversions.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/DebugPMD.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/DebugTrace.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Delay.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Display.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/ErrorCode.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/FileSystem.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/FloatingUtilities.def:  added summary and dates
	for GPL.
	* gm2/gm2-libs-pim/InOut.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Keyboard.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/LongIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/NumberConversion.def:  added summary and dates
	for GPL.
	* gm2/gm2-libs-pim/Random.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/RealConversions.def:  added summary and dates
	for GPL.
	* gm2/gm2-libs-pim/RealInOut.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Strings.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Termbase.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/Terminal.def:  added summary and dates for GPL.
	* gm2/gm2-libs-pim/TimeDate.def:  added summary and dates for GPL.
	* gm2/mc/alists.mod:  added summary and dates for GPL.

2019-04-06      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/FifoQueue.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Indexing.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Lists.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2ALU.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2AsmUtil.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Base.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2BasicBlock.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Batch.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Bitset.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2CaseList.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Code.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Comp.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Configure.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Const.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Debug.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DebugStack.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Defaults.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Depth.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2DriverOptions.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Error.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2EvalSym.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2FileName.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GCCDeclare.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2GenGCC.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Lex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2LexBuf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2MetaError.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Optimize.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Options.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Pass.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Preprocess.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Printf.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quads.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Quiet.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Range.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Reserved.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Scope.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Search.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Size.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2StackAddress.def:  added summary and dates	for GPL.
	* gm2/gm2-compiler/M2StackWord.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Students.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Swig.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2System.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/M2Version.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/NameKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/ObjectFiles.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P0SyntaxCheck.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P1Build.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P1SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2Build.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P2SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3Build.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/P3SymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/PCSymBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/PHBuild.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/Sets.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolConversion.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolKey.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/SymbolTable.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/bnflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/cflex.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gccgm2.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2builtins.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/gm2except.def:  added summary and dates for GPL.
	* gm2/gm2-compiler/m2flex.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Args.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Assertion.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Builtins.def:  added summary and dates for GPL.
	* gm2/gm2-libs/CmdArgs.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Debug.def:  added summary and dates for GPL.
	* gm2/gm2-libs/DynamicStrings.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Environment.def:  added summary and dates for GPL.
	* gm2/gm2-libs/FIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/FormatStrings.def:  added summary and dates for GPL.
	* gm2/gm2-libs/FpuIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/IO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Indexing.def:  added summary and dates for GPL.
	* gm2/gm2-libs/LMathLib0.def:  added summary and dates for GPL.
	* gm2/gm2-libs/LegacyReal.def:  added summary and dates for GPL.
	* gm2/gm2-libs/M2RTS.def:  added summary and dates for GPL.
	* gm2/gm2-libs/MathLib0.def:  added summary and dates for GPL.
	* gm2/gm2-libs/MemUtils.def:  added summary and dates for GPL.
	* gm2/gm2-libs/NumberIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/PushBackInput.def:  added summary and dates for GPL.
	* gm2/gm2-libs/RTExceptions.def:  added summary and dates for GPL.
	* gm2/gm2-libs/RTint.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SArgs.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SCmdArgs.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SEnvironment.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SFIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SMathLib0.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SYSTEM.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Scan.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Selective.def:  added summary and dates for GPL.
	* gm2/gm2-libs/StdIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/Storage.def:  added summary and dates for GPL.
	* gm2/gm2-libs/StrIO.def:  added summary and dates for GPL.
	* gm2/gm2-libs/StrLib.def:  added summary and dates for GPL.
	* gm2/gm2-libs/StringConvert.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SysExceptions.def:  added summary and dates for GPL.
	* gm2/gm2-libs/SysStorage.def:  added summary and dates for GPL.
	* gm2/gm2-libs/TimeString.def:  added summary and dates for GPL.
	* gm2/gm2-libs/UnixArgs.def:  added summary and dates for GPL.
	* gm2/gm2-libs/cbuiltin.def:  added summary and dates for GPL.
	* gm2/gm2-libs/cxxabi.def:  added summary and dates for GPL.
	* gm2/gm2-libs/dtoa.def:  added summary and dates for GPL.
	* gm2/gm2-libs/errno.def:  added summary and dates for GPL.
	* gm2/gm2-libs/gdbif.def:  added summary and dates for GPL.
	* gm2/gm2-libs/ldtoa.def:  added summary and dates for GPL.
	* gm2/gm2-libs/libc.def:  added summary and dates for GPL.
	* gm2/gm2-libs/libm.def:  added summary and dates for GPL.
	* gm2/gm2-libs/sckt.def:  added summary and dates for GPL.
	* gm2/gm2-libs/termios.def:  added summary and dates for GPL.
	* gm2/gm2-libs/wrapc.def:  added summary and dates for GPL.
	* gm2/gm2spec.c:  added summary and dates for GPL.
	* gm2/mc-boot/GASCII.c:  rebuilt.
	* gm2/mc-boot/GASCII.h:  rebuilt.
	* gm2/mc-boot/GArgs.c:  rebuilt.
	* gm2/mc-boot/GArgs.h:  rebuilt.
	* gm2/mc-boot/GAssertion.c:  rebuilt.
	* gm2/mc-boot/GAssertion.h:  rebuilt.
	* gm2/mc-boot/GBreak.c:  rebuilt.
	* gm2/mc-boot/GBreak.h:  rebuilt.
	* gm2/mc-boot/GCOROUTINES.h:  rebuilt.
	* gm2/mc-boot/GCmdArgs.c:  rebuilt.
	* gm2/mc-boot/GCmdArgs.h:  rebuilt.
	* gm2/mc-boot/GDebug.c:  rebuilt.
	* gm2/mc-boot/GDebug.h:  rebuilt.
	* gm2/mc-boot/GDynamicStrings.c:  rebuilt.
	* gm2/mc-boot/GDynamicStrings.h:  rebuilt.
	* gm2/mc-boot/GEnvironment.c:  rebuilt.
	* gm2/mc-boot/GEnvironment.h:  rebuilt.
	* gm2/mc-boot/GFIO.c:  rebuilt.
	* gm2/mc-boot/GFIO.h:  rebuilt.
	* gm2/mc-boot/GFormatStrings.c:  rebuilt.
	* gm2/mc-boot/GFormatStrings.h:  rebuilt.
	* gm2/mc-boot/GFpuIO.c:  rebuilt.
	* gm2/mc-boot/GFpuIO.h:  rebuilt.
	* gm2/mc-boot/GIO.c:  rebuilt.
	* gm2/mc-boot/GIO.h:  rebuilt.
	* gm2/mc-boot/GIndexing.c:  rebuilt.
	* gm2/mc-boot/GIndexing.h:  rebuilt.
	* gm2/mc-boot/GM2EXCEPTION.c:  rebuilt.
	* gm2/mc-boot/GM2EXCEPTION.h:  rebuilt.
	* gm2/mc-boot/GM2RTS.c:  rebuilt.
	* gm2/mc-boot/GM2RTS.h:  rebuilt.
	* gm2/mc-boot/GMemUtils.c:  rebuilt.
	* gm2/mc-boot/GMemUtils.h:  rebuilt.
	* gm2/mc-boot/GNumberIO.c:  rebuilt.
	* gm2/mc-boot/GNumberIO.h:  rebuilt.
	* gm2/mc-boot/GPushBackInput.c:  rebuilt.
	* gm2/mc-boot/GPushBackInput.h:  rebuilt.
	* gm2/mc-boot/GRTExceptions.c:  rebuilt.
	* gm2/mc-boot/GRTExceptions.h:  rebuilt.
	* gm2/mc-boot/GRTint.c:  rebuilt.
	* gm2/mc-boot/GRTint.h:  rebuilt.
	* gm2/mc-boot/GSArgs.c:  rebuilt.
	* gm2/mc-boot/GSArgs.h:  rebuilt.
	* gm2/mc-boot/GSFIO.c:  rebuilt.
	* gm2/mc-boot/GSFIO.h:  rebuilt.
	* gm2/mc-boot/GSYSTEM.h:  rebuilt.
	* gm2/mc-boot/GSelective.h:  rebuilt.
	* gm2/mc-boot/GStdIO.c:  rebuilt.
	* gm2/mc-boot/GStdIO.h:  rebuilt.
	* gm2/mc-boot/GStorage.c:  rebuilt.
	* gm2/mc-boot/GStorage.h:  rebuilt.
	* gm2/mc-boot/GStrCase.c:  rebuilt.
	* gm2/mc-boot/GStrCase.h:  rebuilt.
	* gm2/mc-boot/GStrIO.c:  rebuilt.
	* gm2/mc-boot/GStrIO.h:  rebuilt.
	* gm2/mc-boot/GStrLib.c:  rebuilt.
	* gm2/mc-boot/GStrLib.h:  rebuilt.
	* gm2/mc-boot/GStringConvert.c:  rebuilt.
	* gm2/mc-boot/GStringConvert.h:  rebuilt.
	* gm2/mc-boot/GSysExceptions.h:  rebuilt.
	* gm2/mc-boot/GSysStorage.c:  rebuilt.
	* gm2/mc-boot/GSysStorage.h:  rebuilt.
	* gm2/mc-boot/GTimeString.c:  rebuilt.
	* gm2/mc-boot/GTimeString.h:  rebuilt.
	* gm2/mc-boot/GUnixArgs.h:  rebuilt.
	* gm2/mc-boot/Galists.c:  rebuilt.
	* gm2/mc-boot/Galists.h:  rebuilt.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc-boot/Gdecl.h:  rebuilt.
	* gm2/mc-boot/Gdtoa.h:  rebuilt.
	* gm2/mc-boot/Gerrno.h:  rebuilt.
	* gm2/mc-boot/Gkeyc.c:  rebuilt.
	* gm2/mc-boot/Gkeyc.h:  rebuilt.
	* gm2/mc-boot/Gldtoa.h:  rebuilt.
	* gm2/mc-boot/Glibc.h:  rebuilt.
	* gm2/mc-boot/Glibm.h:  rebuilt.
	* gm2/mc-boot/Glists.c:  rebuilt.
	* gm2/mc-boot/Glists.h:  rebuilt.
	* gm2/mc-boot/GmcComment.c:  rebuilt.
	* gm2/mc-boot/GmcComment.h:  rebuilt.
	* gm2/mc-boot/GmcComp.c:  rebuilt.
	* gm2/mc-boot/GmcComp.h:  rebuilt.
	* gm2/mc-boot/GmcDebug.c:  rebuilt.
	* gm2/mc-boot/GmcDebug.h:  rebuilt.
	* gm2/mc-boot/GmcError.c:  rebuilt.
	* gm2/mc-boot/GmcError.h:  rebuilt.
	* gm2/mc-boot/GmcFileName.c:  rebuilt.
	* gm2/mc-boot/GmcFileName.h:  rebuilt.
	* gm2/mc-boot/GmcLexBuf.c:  rebuilt.
	* gm2/mc-boot/GmcLexBuf.h:  rebuilt.
	* gm2/mc-boot/GmcMetaError.c:  rebuilt.
	* gm2/mc-boot/GmcMetaError.h:  rebuilt.
	* gm2/mc-boot/GmcOptions.c:  rebuilt.
	* gm2/mc-boot/GmcOptions.h:  rebuilt.
	* gm2/mc-boot/GmcPreprocess.c:  rebuilt.
	* gm2/mc-boot/GmcPreprocess.h:  rebuilt.
	* gm2/mc-boot/GmcPretty.c:  rebuilt.
	* gm2/mc-boot/GmcPretty.h:  rebuilt.
	* gm2/mc-boot/GmcPrintf.c:  rebuilt.
	* gm2/mc-boot/GmcPrintf.h:  rebuilt.
	* gm2/mc-boot/GmcQuiet.c:  rebuilt.
	* gm2/mc-boot/GmcQuiet.h:  rebuilt.
	* gm2/mc-boot/GmcReserved.c:  rebuilt.
	* gm2/mc-boot/GmcReserved.h:  rebuilt.
	* gm2/mc-boot/GmcSearch.c:  rebuilt.
	* gm2/mc-boot/GmcSearch.h:  rebuilt.
	* gm2/mc-boot/GmcStack.c:  rebuilt.
	* gm2/mc-boot/GmcStack.h:  rebuilt.
	* gm2/mc-boot/GmcStream.c:  rebuilt.
	* gm2/mc-boot/GmcStream.h:  rebuilt.
	* gm2/mc-boot/Gmcflex.h:  rebuilt.
	* gm2/mc-boot/Gmcp1.c:  rebuilt.
	* gm2/mc-boot/Gmcp1.h:  rebuilt.
	* gm2/mc-boot/Gmcp2.c:  rebuilt.
	* gm2/mc-boot/Gmcp2.h:  rebuilt.
	* gm2/mc-boot/Gmcp3.c:  rebuilt.
	* gm2/mc-boot/Gmcp3.h:  rebuilt.
	* gm2/mc-boot/Gmcp4.c:  rebuilt.
	* gm2/mc-boot/Gmcp4.h:  rebuilt.
	* gm2/mc-boot/Gmcp5.c:  rebuilt.
	* gm2/mc-boot/Gmcp5.h:  rebuilt.
	* gm2/mc-boot/GnameKey.c:  rebuilt.
	* gm2/mc-boot/GnameKey.h:  rebuilt.
	* gm2/mc-boot/Gpth.h:  rebuilt.
	* gm2/mc-boot/GsymbolKey.c:  rebuilt.
	* gm2/mc-boot/GsymbolKey.h:  rebuilt.
	* gm2/mc-boot/Gtermios.h:  rebuilt.
	* gm2/mc-boot/Gtop.c:  rebuilt.
	* gm2/mc-boot/Gvarargs.c:  rebuilt.
	* gm2/mc-boot/Gvarargs.h:  rebuilt.
	* gm2/mc-boot/Gwlists.c:  rebuilt.
	* gm2/mc-boot/Gwlists.h:  rebuilt.
	* gm2/mc-boot/Gwrapc.h:  rebuilt.
	* gm2/mc/Indexing.def:  added summary and dates for GPL.
	* gm2/mc/Indexing.mod:  added summary and dates for GPL.
	* gm2/mc/alists.def:  added summary and dates for GPL.
	* gm2/mc/alists.mod:  added summary and dates for GPL.
	* gm2/mc/decl.def:  added summary and dates for GPL.
	* gm2/mc/decl.mod:  added capturing of module comments.
	  Fixed GPL header.
	* gm2/mc/keyc.def:  added summary and dates for GPL.
	* gm2/mc/keyc.mod:  added summary and dates for GPL.
	* gm2/mc/lists.def:  added summary and dates for GPL.
	* gm2/mc/lists.mod:  added summary and dates for GPL.
	* gm2/mc/m2flex.def:  added summary and dates for GPL.
	* gm2/mc/mcComment.def:  added summary and dates for GPL.
	* gm2/mc/mcComp.def:  added summary and dates for GPL.
	* gm2/mc/mcDebug.def:  added summary and dates for GPL.
	* gm2/mc/mcError.def:  added summary and dates for GPL.
	* gm2/mc/mcFileName.def:  added summary and dates for GPL.
	* gm2/mc/mcLexBuf.def:  added summary and dates for GPL.
	* gm2/mc/mcMetaError.def:  added summary and dates for GPL.
	* gm2/mc/mcOptions.def:  added summary and dates for GPL.
	* gm2/mc/mcPreprocess.def:  added summary and dates for GPL.
	* gm2/mc/mcPretty.def:  added summary and dates for GPL.
	* gm2/mc/mcPrintf.def:  added summary and dates for GPL.
	* gm2/mc/mcQuiet.def:  added summary and dates for GPL.
	* gm2/mc/mcReserved.def:  added summary and dates for GPL.
	* gm2/mc/mcSearch.def:  added summary and dates for GPL.
	* gm2/mc/mcStack.def:  added summary and dates for GPL.
	* gm2/mc/mcStream.def:  added summary and dates for GPL.
	* gm2/mc/mcStream.mod:  added summary and dates for GPL.
	* gm2/mc/mcflex.def:  added summary and dates for GPL.
	* gm2/mc/mcp1.def:  added summary and dates for GPL.
	* gm2/mc/mcp2.def:  added summary and dates for GPL.
	* gm2/mc/mcp3.def:  added summary and dates for GPL.
	* gm2/mc/mcp4.def:  added summary and dates for GPL.
	* gm2/mc/mcp5.def:  added summary and dates for GPL.
	* gm2/mc/nameKey.def:  added summary and dates for GPL.
	* gm2/mc/nameKey.mod:  added summary and dates for GPL.
	* gm2/mc/symbolKey.def:  added summary and dates for GPL.
	* gm2/mc/symbolKey.mod:  added summary and dates for GPL.
	* gm2/mc/top.mod:  added summary and dates for GPL.
	* gm2/mc/varargs.def:  added summary and dates for GPL.
	* gm2/mc/varargs.mod:  added summary and dates for GPL.
	* gm2/mc/wlists.def:  added summary and dates for GPL.
	* gm2/mc/wlists.mod:  added summary and dates for GPL.
	* gm2/gm2-libs/ASCII.def:  added summary and dates for GPL.

2019-04-05      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-file.in:  generate mc with GPL3 header.
	* gm2/mc/mcOptions.mod:  corrected bugs with uninitialised
	  string variables and corrected formatting.
	* gm2/mc-boot/GASCII.h:  regenerated with GPL.
	* gm2/mc-boot/GArgs.h:  regenerated with GPL.
	* gm2/mc-boot/GAssertion.h:  regenerated with GPL.
	* gm2/mc-boot/GBreak.h:  regenerated with GPL.
	* gm2/mc-boot/GCOROUTINES.h:  regenerated with GPL.
	* gm2/mc-boot/GCmdArgs.h:  regenerated with GPL.
	* gm2/mc-boot/GDebug.h:  regenerated with GPL.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated with GPL.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated with GPL.
	* gm2/mc-boot/GEnvironment.h:  regenerated with GPL.
	* gm2/mc-boot/GFIO.c:  regenerated with GPL.
	* gm2/mc-boot/GFIO.h:  regenerated with GPL.
	* gm2/mc-boot/GFormatStrings.h:  regenerated with GPL.
	* gm2/mc-boot/GFpuIO.h:  regenerated with GPL.
	* gm2/mc-boot/GIO.h:  regenerated with GPL.
	* gm2/mc-boot/GIndexing.h:  regenerated with GPL.
	* gm2/mc-boot/GM2EXCEPTION.h:  regenerated with GPL.
	* gm2/mc-boot/GM2RTS.c:  regenerated with GPL.
	* gm2/mc-boot/GM2RTS.h:  regenerated with GPL.
	* gm2/mc-boot/GMemUtils.h:  regenerated with GPL.
	* gm2/mc-boot/GNumberIO.c:  regenerated with GPL.
	* gm2/mc-boot/GNumberIO.h:  regenerated with GPL.
	* gm2/mc-boot/GPushBackInput.c:  regenerated with GPL.
	* gm2/mc-boot/GPushBackInput.h:  regenerated with GPL.
	* gm2/mc-boot/GRTExceptions.c:  regenerated with GPL.
	* gm2/mc-boot/GRTExceptions.h:  regenerated with GPL.
	* gm2/mc-boot/GRTint.h:  regenerated with GPL.
	* gm2/mc-boot/GSArgs.h:  regenerated with GPL.
	* gm2/mc-boot/GSFIO.h:  regenerated with GPL.
	* gm2/mc-boot/GSYSTEM.h:  regenerated with GPL.
	* gm2/mc-boot/GSelective.h:  regenerated with GPL.
	* gm2/mc-boot/GStdIO.h:  regenerated with GPL.
	* gm2/mc-boot/GStorage.h:  regenerated with GPL.
	* gm2/mc-boot/GStrCase.h:  regenerated with GPL.
	* gm2/mc-boot/GStrIO.h:  regenerated with GPL.
	* gm2/mc-boot/GStrLib.h:  regenerated with GPL.
	* gm2/mc-boot/GStringConvert.c:  regenerated with GPL.
	* gm2/mc-boot/GStringConvert.h:  regenerated with GPL.
	* gm2/mc-boot/GSysExceptions.h:  regenerated with GPL.
	* gm2/mc-boot/GSysStorage.h:  regenerated with GPL.
	* gm2/mc-boot/GTimeString.h:  regenerated with GPL.
	* gm2/mc-boot/GUnixArgs.h:  regenerated with GPL.
	* gm2/mc-boot/Galists.h:  regenerated with GPL.
	* gm2/mc-boot/Gdecl.c:  regenerated with GPL.
	* gm2/mc-boot/Gdecl.h:  regenerated with GPL.
	* gm2/mc-boot/Gdtoa.h:  regenerated with GPL.
	* gm2/mc-boot/Gerrno.h:  regenerated with GPL.
	* gm2/mc-boot/Gkeyc.h:  regenerated with GPL.
	* gm2/mc-boot/Gldtoa.h:  regenerated with GPL.
	* gm2/mc-boot/Glibc.h:  regenerated with GPL.
	* gm2/mc-boot/Glibm.h:  regenerated with GPL.
	* gm2/mc-boot/Glists.h:  regenerated with GPL.
	* gm2/mc-boot/GmcComment.h:  regenerated with GPL.
	* gm2/mc-boot/GmcComp.h:  regenerated with GPL.
	* gm2/mc-boot/GmcDebug.h:  regenerated with GPL.
	* gm2/mc-boot/GmcError.h:  regenerated with GPL.
	* gm2/mc-boot/GmcFileName.h:  regenerated with GPL.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated with GPL.
	* gm2/mc-boot/GmcMetaError.h:  regenerated with GPL.
	* gm2/mc-boot/GmcOptions.c:  regenerated with GPL.
	* gm2/mc-boot/GmcOptions.h:  regenerated with GPL.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated with GPL.
	* gm2/mc-boot/GmcPretty.h:  regenerated with GPL.
	* gm2/mc-boot/GmcPrintf.h:  regenerated with GPL.
	* gm2/mc-boot/GmcQuiet.h:  regenerated with GPL.
	* gm2/mc-boot/GmcReserved.h:  regenerated with GPL.
	* gm2/mc-boot/GmcSearch.h:  regenerated with GPL.
	* gm2/mc-boot/GmcStack.h:  regenerated with GPL.
	* gm2/mc-boot/GmcStream.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcflex.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcp1.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcp2.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcp3.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcp4.h:  regenerated with GPL.
	* gm2/mc-boot/Gmcp5.h:  regenerated with GPL.
	* gm2/mc-boot/GnameKey.h:  regenerated with GPL.
	* gm2/mc-boot/Gpth.h:  regenerated with GPL.
	* gm2/mc-boot/GsymbolKey.h:  regenerated with GPL.
	* gm2/mc-boot/Gtermios.h:  regenerated with GPL.
	* gm2/mc-boot/Gtop.c:  regenerated with GPL.
	* gm2/mc-boot/Gvarargs.h:  regenerated with GPL.
	* gm2/mc-boot/Gwlists.h:  regenerated with GPL.
	* gm2/mc-boot/Gwrapc.h:  regenerated with GPL.

2019-04-04      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/mc-boot/GASCII.h:  regenerated.
	* gm2/mc-boot/GArgs.h:  regenerated.
	* gm2/mc-boot/GAssertion.h:  regenerated.
	* gm2/mc-boot/GBreak.h:  regenerated.
	* gm2/mc-boot/GCOROUTINES.h:  regenerated.
	* gm2/mc-boot/GCmdArgs.h:  regenerated.
	* gm2/mc-boot/GDebug.h:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated.
	* gm2/mc-boot/GEnvironment.h:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFIO.h:  regenerated.
	* gm2/mc-boot/GFormatStrings.h:  regenerated.
	* gm2/mc-boot/GFpuIO.h:  regenerated.
	* gm2/mc-boot/GIO.h:  regenerated.
	* gm2/mc-boot/GIndexing.h:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.h:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GM2RTS.h:  regenerated.
	* gm2/mc-boot/GMemUtils.h:  regenerated.
	* gm2/mc-boot/GNumberIO.c:  regenerated.
	* gm2/mc-boot/GNumberIO.h:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.h:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.h:  regenerated.
	* gm2/mc-boot/GRTint.h:  regenerated.
	* gm2/mc-boot/GSArgs.h:  regenerated.
	* gm2/mc-boot/GSFIO.h:  regenerated.
	* gm2/mc-boot/GSYSTEM.h:  regenerated.
	* gm2/mc-boot/GSelective.h:  regenerated.
	* gm2/mc-boot/GStdIO.h:  regenerated.
	* gm2/mc-boot/GStorage.h:  regenerated.
	* gm2/mc-boot/GStrCase.h:  regenerated.
	* gm2/mc-boot/GStrIO.h:  regenerated.
	* gm2/mc-boot/GStrLib.h:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GStringConvert.h:  regenerated.
	* gm2/mc-boot/GSysExceptions.h:  regenerated.
	* gm2/mc-boot/GSysStorage.h:  regenerated.
	* gm2/mc-boot/GTimeString.h:  regenerated.
	* gm2/mc-boot/GUnixArgs.h:  regenerated.
	* gm2/mc-boot/Galists.h:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/Gdtoa.h:  regenerated.
	* gm2/mc-boot/Gerrno.h:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Gldtoa.h:  regenerated.
	* gm2/mc-boot/Glibc.h:  regenerated.
	* gm2/mc-boot/Glibm.h:  regenerated.
	* gm2/mc-boot/Glists.h:  regenerated.
	* gm2/mc-boot/GmcComment.h:  regenerated.
	* gm2/mc-boot/GmcComp.h:  regenerated.
	* gm2/mc-boot/GmcDebug.h:  regenerated.
	* gm2/mc-boot/GmcError.h:  regenerated.
	* gm2/mc-boot/GmcFileName.h:  regenerated.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated.
	* gm2/mc-boot/GmcMetaError.h:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcOptions.h:  regenerated.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated.
	* gm2/mc-boot/GmcPretty.h:  regenerated.
	* gm2/mc-boot/GmcPrintf.h:  regenerated.
	* gm2/mc-boot/GmcQuiet.h:  regenerated.
	* gm2/mc-boot/GmcReserved.h:  regenerated.
	* gm2/mc-boot/GmcSearch.h:  regenerated.
	* gm2/mc-boot/GmcStack.h:  regenerated.
	* gm2/mc-boot/GmcStream.h:  regenerated.
	* gm2/mc-boot/Gmcflex.h:  regenerated.
	* gm2/mc-boot/Gmcp1.h:  regenerated.
	* gm2/mc-boot/Gmcp2.h:  regenerated.
	* gm2/mc-boot/Gmcp3.h:  regenerated.
	* gm2/mc-boot/Gmcp4.h:  regenerated.
	* gm2/mc-boot/Gmcp5.h:  regenerated.
	* gm2/mc-boot/GnameKey.h:  regenerated.
	* gm2/mc-boot/Gpth.h:  regenerated.
	* gm2/mc-boot/GsymbolKey.h:  regenerated.
	* gm2/mc-boot/Gtermios.h:  regenerated.
	* gm2/mc-boot/Gtop.c:  regenerated.
	* gm2/mc-boot/Gvarargs.h:  regenerated.
	* gm2/mc-boot/Gwlists.h:  regenerated.
	* gm2/mc-boot/Gwrapc.h:  regenerated.
	* gm2/mc/decl.mod:  regenerated.
	* gm2/mc/mcOptions.def:  added new options to create
	  copyright header in the comments.
	* gm2/mc/mcOptions.mod:  added new options to create
	  copyright header in the comments.

2019-04-03      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2.texi:  changed email address.

2019-03-29      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  walk and
	  declare equivalent nul terminated strings.
	* gm2/gm2-compiler/M2Quads.mod:  (ConvertStringToC) rewritten.
          (ManipulateParameters) always pass conststrings with a nul
	  terminator.
	* gm2/gm2-compiler/SymbolTable.def:
          (GetConstStringNullTerminated) New procedure function.
	* gm2/gm2-compiler/SymbolTable.mod:  (SymConstString)
          provide equivalent nul terminated version of the string.
          (MakeConstLitString) initialise NulTerminated and
          IsNulTerminated fields.  (InitConstString)  New procedure.
	  (GetConstStringNullTerminated)  New procedure function.
	* testsuite/gm2/calling-c/datatypes/unbounded/run/pass/c.def:
	  use ARRAY OF CHAR rather than address.
	* testsuite/gm2/calling-c/datatypes/unbounded/run/pass/gm2.exp:
	  do not explicity use -lpth.
	* testsuite/gm2/calling-c/datatypes/unbounded/run/pass/m.mod:
	  do not use ADR when passing a constant string.
	* testsuite/gm2/dynamic/pass/testbec30.mod:  fixed ARRAY type
	  to CHAR.
	* testsuite/lib/gm2.exp:  added libpth to the list of libraries
	  searched now that libpth is built.

2019-03-26      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2GCCDeclare.mod: import
          IsConstStringRequiresNul.
	  (DeclareStringConstant) call BuildCStringConstant if
          appropriate.
	* gm2/gm2-compiler/M2GenGCC.mod: corrected dates.
	* gm2/gm2-compiler/M2Quads.mod:  (ConvertStringToC) rewritten
          to set RequiresNul in a copy of the symbol.
	* gm2/gm2-compiler/SymbolTable.def:  (PutConstStringRequiresNul)
	  export and declare.  (IsConstStringRequiresNul) export and
          declare.
	* gm2/gm2-compiler/SymbolTable.mod:  (SymConstString)  New field
          NulRequired.  (PutConstString) initialise NulRequired.
          (PutConstStringRequiresNul)  New procedure.
          (IsConstStringRequiresNul)  New procedure function.
	* gm2/gm2-gcc/m2decl.c:  (BuildCStringConstant) New function.
          (BuildStringConstant) no longer automatically creates a string
          with a trailing nul.
	* gm2/gm2-gcc/m2decl.def: (BuildCStringConstant) New function.
	* gm2/gm2-gcc/m2decl.h: (BuildCStringConstant) New function.

2019-03-25      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in: (selftest-gm2) added dummy rule.
	* gm2/gm2-gcc/gcc-consolidation.h: added headers (params, spellcheck
          opt-suggestions).
	* gm2/gm2-lang.c: (gm2_langhook_handle_option)
          corrected parameter (value) to HOST_WIDE_INT.
	* gm2/gm2spec.c: added headers (params, spellcheck, prefix, intl,
          opt-suggestions).  Only compile printOption is DEBUGGING is set.
	* gm2/config-lang.in: removed p2c Makefiles.
	* gm2/configure.in: removed warning about libpth.
	* gm2/gm2-gcc/gcc-consolidation.h: fixed comments as per GNU style.
	* gcc-versionno/gcc/gm2/Make-lang.in: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/dynamicstrings.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/init.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/init.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2assert.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2assert.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2block.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2block.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2builtins.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2builtins.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2convert.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2convert.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2decl.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2decl.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2except.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2except.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2expr.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2expr.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2linemap.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2linemap.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2misc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2misc.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2options.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2range.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2search.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2statement.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2statement.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2top.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2top.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2tree.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2tree.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2treelib.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2treelib.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2type.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-gcc/m2type.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-lang.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/SysExceptions.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/UnixArgs.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/choosetemp.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/dtoa.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/errno.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/getopt.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/host.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/ldtoa.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/termios.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/wrapc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-ch/xlibc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-iso/ChanConsts.mod: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-iso/MemStream.mod: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-min/libc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs-pim/Break.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs/Args.def: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs/Args.mod: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs/config-host: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs/config-host.in: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2-libs/gdbif.mod: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2.texi: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/gm2spec.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/m2pp.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/GBuiltins.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/GSYSTEM.applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/GSelective.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/GSysExceptions.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/GUnixArgs.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gcbuiltin.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gdtoa.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gerrno.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gldtoa.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Glibc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Glibm.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gmcrts.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gmcrts.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gnetwork.h: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gpth.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gtermios.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/Gwrapc.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/mc-boot-ch/network.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/tools-src/gensum.py: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/tools-src/mklink.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/tools-src/tidydates.py: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/gcc/gm2/version.c: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/libgm2/libpim/Makefile.am: applied gm2-1.8.2 formatting and bug fixes.
	* gcc-versionno/libgm2/libpim/Makefile.in: applied gm2-1.8.2
	formatting and bug fixes.
	* gm2/gm2-libs-ch/pthdummy.c: (New file).

2019-03-22      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/patches/gcc/trunk/01-patches:  New file.
	* gm2/patches/gcc/trunk/02-patches:  New file.
	* gm2/patches/gcc/trunk/03-patches:  New file.
	* gm2/patches/gcc/trunk/04-patches:  New file.
	* gm2/patches/gcc/trunk/05-patches:  New file.
	* gm2/patches/gcc/trunk/06-patches:  New file.
	* gm2/patches/gcc/trunk/07-patches:  New file.
	* gm2/patches/gcc/trunk/08-patches:  New file.
	* gm2/patches/gcc/trunk/09-patches:  New file.
	* gm2/patches/gcc/trunk/10-patches:  New file.
	* gm2/patches/gcc/trunk/11-patches:  New file.
`
2018-07-30      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2spec.c:  (fe_generate_option) do not duplicate the old
          argument.  free up a string after use.  (build_include_path)
          start the new string with a strcpy not strcat!
          (insert_option) create a new vector with an extra entry.
          (no_link) return a string which can be free'd.
	  (add_exec_name) return a string which can be free'd.

2018-07-18      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2spec.c: reformatted according to GNU coding standards.

2018-07-17      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/ObjectFiles.mod:  import ALLOCATE
          and DEALLOCATE from Storage.  Collect return results
          from close and KillIndex.
	* gm2/gm2spec.c:  reformatted and tidied up code.
	* gm2/gm2-libs/GetOpt.mod:  remove declaration of PtrToInteger.
	* gm2/gm2-libs/GetOpt.mod:  corrected record/pointer reference.

2018-07-16      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/bnf/gm2l.bnf:  reformatted to gnu standards.
	* gm2/el/gm2-mode.el:  minor formatting change.
	* gm2/gm2-libs/DynamicStrings.mod:  reformatted to gnu standards.
	* gm2/gm2-compiler/ObjectFiles.def:  (New file).

2018-07-14      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  remove the target configure scripts from
	  gm2/gm2-libs.
	* gm2/configure:  rebuilt.
	* gm2/examples/callingC/Makefile.in:  use multiple -I flags.
	* gm2/examples/hello/Makefile.in:  use multiple -I flags.
	* gm2/gm2-compiler/gm2lcc.mod:  reformatted.  Archive
	  all object files, all Modula-2 objects and check for duplication.
	* gm2/gm2-libs-ch/wrapc.c:  remove unconfigured test for fileinode.
	* gm2/gm2-libs/config-host:  rebuilt.
	* gm2/gm2-libs/config-target:  removed.
	* gm2/gm2-libs/gm2-libs-host.h.in:  rebuilt.
	* gm2/gm2-libs/gm2-libs-target.h.in:  removed.
	* gm2/gm2spec.c:  reformatted.  (add_env_option)  New function.
	  (lang_specific_driver)  call add_env_option.
	* gm2/lang-specs.h:  (lang_register_spec_functions) register
	  no_objects.
	* gm2/patches/gcc/trunc/01-patches:  rebuilt.
	* gm2/patches/gcc/trunc/02-patches:  rebuilt.
	* gm2/patches/gcc/trunc/03-patches:  rebuilt.
	* gm2/patches/gcc/trunc/04-patches:  rebuilt.
	* gm2/patches/gcc/trunc/05-patches:  rebuilt.
	* gm2/patches/gcc/trunc/06-patches:  rebuilt.
	* gm2/patches/gcc/trunc/07-patches:  rebuilt.
	* gm2/patches/gcc/trunc/08-patches:  rebuilt.
	* gm2/patches/gcc/trunc/09-patches:  rebuilt.
	* gm2/patches/gcc/trunc/10-patches:  rebuilt.
	* testsuite/gm2/pim/run/pass/testaddr2.mod:  reformatted.
	* gm2/gm2spec.c:  removed unused variable and reformatted.
	* gm2/tools-src/makeversion:  remove reference to config-target.in.

2018-07-10      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/ObjectFiles.def:  New file.
	* gm2/gm2-compiler/ObjectFiles.mod:  New file.
	* gm2/Make-lang.in:  added ObjectFiles to be built and linked
	into the compiler and tools.
	* gm2/gm2-compiler/gm2lcc.mod:  use ObjectFiles to remember each
	  object file so duplicates are not accidentally linked both in
	the Modula-2 link and command line list of objects.  Much code
	  was tidied up.
	* gm2/gm2-libs-ch/wrapc.c:  (fileinode) New function.
	* gm2/gm2-libs/libc.def:  corrected dates.
	* gm2/gm2-libs/wrapc.def:  (fileinode) New procedure function.
	* libgm2/libpim/wrapc.c:  (fileinode) New function.  Tidied up
	  formatting.

2018-07-07      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/bnf/gm2l.bnf:  import Verbose and use.  (RegisterImport)
          reformatted.  (ScanSources) display the module name if Verbose.
          (ScanArgs) handle long options and also concatenated arguments.
	  (-I, --verbose, --M2RTS).
	* gm2/gm2-compiler/M2DriverOptions.mod:  (CppArgument)  New procedure
	  function.  (ScanCppArgs) reformatted and also call CppArgument.
	* gm2/gm2-compiler/M2Options.mod:  updated dates.
	* gm2/gm2-compiler/M2Preprocess.mod:  reformatted and changed some of the
	  Verbose output.
	* gm2/gm2-libs-ch/getopt.c:  implement long options.
	* gm2/gm2-libs/GetOpt.def:  provide access to the long options in getopt.
	* gm2/gm2-libs/GetOpt.mod:  implement long option procedures necessary for getopt.
	* gm2/gm2-libs/Storage.def:  updated dates.
	* gm2/gm2-libs/getopt.def:  provide access to the long options in getopt.
	* gm2/gm2.texi:  corrected docuentation surrounding
	* gm2/gm2spec.c:  removed GM2IPATH and GM2OPATH temporarily and changed
          all include and object paths to avoid using the ":" separator.
          (which does not exist for -I).  In turn this forces a reimplementation
	  of the GM2IPATH and GM2OPATH.
	* gm2/lang-specs.h:  changed all references to gm2l to use the GM2L macro.
          Fixed many preprocessor invocation problems which occur when linking
	  an application which uses the preprocessor.

2018-07-02      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  changes to build stage2/gm2/gm2l
	* gm2/bnf/gm2l.bnf:  remove FORWARD references.
	* gm2/gm2-compiler/M2GenGCC.mod:  (GetAddressOfUnbounded)
          reformatted.  (BuildHighFromStaticArray) bug fixes
          and reformatted.
	* gm2/gm2-libs/GetOpt.def:  introduce long options.
	* gm2/iso/run/pass/constructor2.mod:  reformatted.

2018-06-27      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2GenGCC.mod:  (GetHighFromUnbounded)
          check to see if the unbounded array has static array
          data type and follow the dimension into the static array
          to obtain the correct HIGH value.
          (BuildHighFromStaticArray)  New procedure function.
	* gm2/gm2-compiler/M2Range.mod:  add missing case clause.

2018-06-23      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el: bug fixes to the m2-tag feature.
	* gm2/el/g-mode.el: allow . before a type, keyword,
	  function and const.

2018-06-22      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el: generate types and builtin functions
	  dependant upon the dialect chosen.

2018-06-21      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el: fixed m2-tag (find declaration
          understands the path and also works in algol keyword mode.
	* gm2/el/g-mode.el: fixed visual parenthesis balancing.
	* gm2/el/g-mode.el: removed some debugging statements.

2018-06-20      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  fixed traditional mode.  Both algol
	  mode and traditional are now usable and user selectable.

2018-06-13      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  added ability to turn on/off
          lowercase algol style keyword transformation.
          Fixed compile-command.
	* gm2/el/gm2-mode.el:  renamed from g-mode.el.
	  Changed internal variables from g-mode- to m2-auto-.

2018-06-11      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  added defcustom declarations
          and fixed some regexp bugs.  Applied some defcustom
          implementation features.
	* gm2/el/g-mode.el:  fixed electric END, ELSE and THEN.
          Added more defcustoms.
	* gm2/el/g-mode.el:  added many more defcustoms.  Also
          tidied up code and also tightened up types and introduced
          radio buttons for language choice.  Use inbuilt booleans
          for binary choices.  Fixed key binding for DEL and
	  Backspace.

2018-06-08      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  interim checkin, keyword editing
          complete (minus delete key).

2018-06-07      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  interim checkin.
	* gm2/el/g-mode.el:  another interim checkin in
	  the development of lowercase keywords.

2018-05-24      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-gcc/m2expr.c:  (BuildNotEqualToZero)
          new function.  (checkWholeNegateOverflow)
          re-implemented and in the process fixed bug
	  and the test
          testsuite/gm2/switches/check-all/run/fail/intrange5.mod
	  passes.
          (m2expr_Build4LogicalAnd)  New function.
	* gm2/gm2-gcc/m2expr.c:  renamed BuildLogicalAndIf
          to BuildTruthAndIf and renamed BuildLogicalOrIf
	  to BuildTruthOrIf.

2018-05-23      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* implement range checks on whole number multiply.
	* gm2/gm2-compiler/M2GenGCC.mod:  import BuildMultCheck.
          Call CodeMultCheck in quadruple case statement.
          (CodeMultChecked)  New procedure.  (CodeMultCheck)
          New procedure.
	* gm2/gm2-gcc/m2expr.c:  (checkWholeNegateOverflow)
          interm checkin.  (checkWholeSubOverflow) corrected
          comment.  (m2expr_Build3LogicalAnd)  New function.
          (m2expr_Build4LogicalOr)  New function.
          (checkWholeMultOverflow)  New function.
          (checkWholeOverflow)  New function.
          (m2expr_BuildMultCheck)  New function.
	* gm2/gm2-gcc/m2expr.def:  BuildMultCheck exported.
	* gm2/gm2-gcc/m2expr.h:  BuildMultCheck defined.
	* gm2/gm2-gcc/m2expr.c:  added missing semicolon.

2018-04-16      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  changed the plugin directory to
          plugin rather than gm2/plugin.  Corrected .so typeos.
	* gm2/gm2.texi:  Semantic checking (New section).
	* testsuite/gm2/iso/analysis/fail/gm2.exp:  New file.

2018-04-14      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  build plugin/m2rte.so and create
	  gm2/plugin directory.
	* gm2/gm2-compiler/CLexBuf.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2ALU.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2AsmUtil.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2BasicBlock.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2BasicBlock.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Batch.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Const.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Const.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Depth.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Lex.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2LexBuf.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2LexBuf.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2MetaError.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2MetaError.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Optimize.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/M2Swig.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/NameKey.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/PCSymBuild.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/SymbolKey.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/SymbolTable.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/gm2lcc.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-compiler/gm2lgen.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs-ch/libc.c:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs-coroutines/Debug.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs-coroutines/Debug.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs-min/libc.c:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/Args.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/Args.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/CmdArgs.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/Debug.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/DynamicStrings.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/DynamicStrings.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/FIO.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/NumberIO.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/PushBackInput.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/RTExceptions.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/Scan.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/StrIO.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/StrLib.mod:  removed FORWARD prototype
	  definitions.
	* gm2/gm2-libs/StringConvert.mod:  removed FORWARD prototype
	  definitions.
	* gm2/plugins/m2rte.c:  renamed to gm2/plugin/m2rte.c.
	* gm2/ulm-lib-gm2/std/RTExceptions.mod:  removed FORWARD prototype
	  definitions.

2018-04-10      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  build m2rte plugin, install m2rte plugin.
	* gm2/gm2-compiler/M2Base.def:  define new exception ExceptionReturn.
	* gm2/gm2-compiler/M2Base.mod:  implement new exception ExceptionReturn.
	* gm2/gm2-compiler/M2Quads.mod:  new call to InitReturnRangeCheck.
	* gm2/gm2-compiler/M2Range.def:  define InitReturnRangeCheck.
	* gm2/gm2-compiler/M2Range.mod:  (InitReturnRangeCheck),
	  (FoldReturn), (CodeReturn) New procedures.
	* gm2/gm2-lang.c:  detect -fno-m2-plugin option.
	* gm2/gm2-libs-iso/M2RTS.def:  ReturnException defined.
	* gm2/gm2-libs-iso/M2RTS.mod:  ReturnException implemented.
	* gm2/gm2-libs/M2RTS.def:  ReturnException defined.
	* gm2/gm2-libs/M2RTS.mod:  ReturnException implemented.
	* gm2/gm2spec.c:  detect -fno-m2-plugin and unset boolean if
          present.  Later insert the -fplugin=m2rte switch if plugins are true.
	* gm2/lang-options.h:  allow -fm2-plugin and -fno-m2-plugin.
	* gm2/lang-specs.h:  update dates.
	* gm2/lang.opt:  define -fm2-plugin and -fno-m2-plugin.
	* gm2/m2pp.c:  update dates.
	* gm2/tools-src/makeSystem:  use -fno-m2-plugin when creating system.
	* gm2/ulm-lib-gm2/std/M2RTS.mod:  ReturnException implemented.
	* plugins/m2rte.c:  New file.

2018-03-28      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/bnf/m2-2.bnf:  updated dates and trimmed end of
	  line spaces.
	* gm2/bnf/m2-c.bnf:  updated dates and trimmed end of
	  line spaces.
	* gm2/gm2-compiler/M2Comp.mod:  removed p2c forward
	  declarations.
	* gm2/gm2-compiler/M2Quads.mod:  (BuildRealFuncProcCall)
          corrected comment title.  Call SkipConst to skip over
          a constant assigned to a procedure.  Fixes a bug reported
          by Michael Riedl <udo-michael.riedl@t-online.de>.
	* gm2/gm2-compiler/P2SymBuild.mod:  remove p2c
	  forward declarations.
	* testsuite/gm2/iso/run/pass/constprocedure.mod:
          New regression test to stress the bug reported (above).
	* testsuite/gm2/iso/fail/constprocedure.mod:  New
          regression test to test standard functions are not
          allowed to be referenced in a const expression.
	  (But they can be called).

2018-03-27      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/el/g-mode.el:  corrected dates and changed name
          to help debugging.
	* gm2/gm2-compiler/Indexing.mod:  removed p2c related
	  comment.
	* gm2/gm2-compiler/M2Error.mod:  removed intemediate
          record type as we are no longer bootstrapping using
          p2c.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  removed intemediate
          record types as we are no longer bootstrapping using
          p2c.
	* gm2/gm2-compiler/M2Range.mod:  removed intemediate
          record type as we are no longer bootstrapping using
          p2c.
	* gm2/gm2-compiler/ppg.mod:  removed intemediate
          record types as we are no longer bootstrapping using
          p2c.

2018-03-26      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-lang.c:  (gm2_langhook_type_for_mode)  rewritten
          (borrowed code from go-lang.c).
	* gm2/gm2-compiler/M2Quads.mod:  (BuildAdrFunction)
          handle address of unbounded array and check the dimension
	  access.

2018-03-14      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/SymbolTable.mod:  (PutUnbounded)
          ensure that all dimensions prior to the requested dimension
	  has an entry in the array.  (NulSym is added).
	* gm2/gm2-compiler/M2GCCDeclare.mod:  (WalkFamilyOfUnbounded)
          check that unbounded is not NulSym before calling unboundedp.

	* gm2/gm2-compiler/M2Quads.mod:  (UnboundedVarLinkToArray)
          and (UnboundedNonVarLinkToArray) ensure that all
          parameters to BuildAdrFunction propagate the array
          and dimension operand stack.
          Fixes bugs exposed in
	  testsuite/gm2/iso/run/pass/adrunbounded3.mod

2018-02-19      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2Quads.mod:  (AssignHighField)
          check for ArraySym and use if actual parameter
          has different number of dimensions to formal
          parameter array.
	* gm2/gm2-compiler/M2Quads.mod:  (BuildConstHighFromSym)
          only access the single dimension when building high
          as the array will be referencing the desired dimension.
	  A temporary type will have been created.

2018-02-15      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2GenGCC.mod:  check and use lvalue op3
	  which points to the data for the unbounded quadruple.

2018-02-08      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/gm2-compiler/M2Quads.mod:  check open array actual
          parameter which is indexed and check the dimension against
	  formal parameters.

2018-02-07      Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2/Make-lang.in:  added LDFLAGS to the link of mc.

2018-01-28      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-5.bnf:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc/decl.def:  (addElseComments), (addIfEndComments),
          (addWhileDoComment), (addWhileEndComment), (addRepeatComment),
	  (addUntilComment)  defined and exported.
	* gm2/mc/decl.mod:  (commentPair)  New record.
          Used in funccallT, returnT, whileT, repeatT, ifT, elsifT,
          assignmentT.  (doAfterCommentC)  New procedure.
          (doReturnC)  Use (doAfterCommentC).
          (doAssignmentC) use (doAfterCommentC).  (doIfC)
          use (doAfterCommentC).  (doRepeatC) use (doAfterCommentC).
          (doWhileC) use (doAfterCommentC).  (doFuncCallC) use
          (doAfterCommentC).  (addGenericBody) rewritten.
          (addIfComments) rewritten.  (addElseComments)  New
          procedure.  (addIfEndComments)  New procedure.
          (addWhileDoComment) New procedure.  (addWhileEndComment)
          New procedure.  (initPair)  New procedure.
          (addRepeatComment)  New procedure.
	  (addUntilComment)  New procedure.
	* gm2/mc/mcLexBuf.mod:  fixed an infinite loop bug hunting
	  for the next token on a buffer boundary case.

2018-01-26      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added extra commented definition for
	bootstrapping under trunc.
	* gm2/bnf/mc-1.bnf:  changed comment interface.
	* gm2/bnf/mc-2.bnf:  removed unnecessary import.
	* gm2/bnf/mc-5.bnf:  rewritten the comment interface for
	  after and body comments.
	* gm2/mc-boot/GCmdArgs.c:  rebuilt.
	* gm2/mc-boot/GDebug.c:  rebuilt.
	* gm2/mc-boot/GDynamicStrings.c:  rebuilt.
	* gm2/mc-boot/GFIO.c:  rebuilt.
	* gm2/mc-boot/GFormatStrings.c:  rebuilt.
	* gm2/mc-boot/GFpuIO.c:  rebuilt.
	* gm2/mc-boot/GIO.c:  rebuilt.
	* gm2/mc-boot/GIndexing.c:  rebuilt.
	* gm2/mc-boot/GM2EXCEPTION.c:  rebuilt.
	* gm2/mc-boot/GM2RTS.c:  rebuilt.
	* gm2/mc-boot/GM2RTS.h:  rebuilt.
	* gm2/mc-boot/GNumberIO.c:  rebuilt.
	* gm2/mc-boot/GRTExceptions.c:  rebuilt.
	* gm2/mc-boot/GRTint.c:  rebuilt.
	* gm2/mc-boot/GSFIO.c:  rebuilt.
	* gm2/mc-boot/GStorage.c:  rebuilt.
	* gm2/mc-boot/GStrIO.c:  rebuilt.
	* gm2/mc-boot/GStrLib.c:  rebuilt.
	* gm2/mc-boot/GStringConvert.c:  rebuilt.
	* gm2/mc-boot/GSysStorage.c:  rebuilt.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc-boot/Gdecl.h:  rebuilt.
	* gm2/mc-boot/Gkeyc.c:  rebuilt.
	* gm2/mc-boot/Glibc.h:  rebuilt.
	* gm2/mc-boot/GmcComment.c:  rebuilt.
	* gm2/mc-boot/GmcComment.h:  rebuilt.
	* gm2/mc-boot/GmcComp.c:  rebuilt.
	* gm2/mc-boot/GmcComp.h:  rebuilt.
	* gm2/mc-boot/GmcError.c:  rebuilt.
	* gm2/mc-boot/GmcLexBuf.c:  rebuilt.
	* gm2/mc-boot/GmcLexBuf.h:  rebuilt.
	* gm2/mc-boot/GmcMetaError.c:  rebuilt.
	* gm2/mc-boot/GmcOptions.c:  rebuilt.
	* gm2/mc-boot/GmcPretty.c:  rebuilt.
	* gm2/mc-boot/GmcPrintf.c:  rebuilt.
	* gm2/mc-boot/GmcQuiet.c:  rebuilt.
	* gm2/mc-boot/GmcSearch.c:  rebuilt.
	* gm2/mc-boot/Gmcp1.c:  rebuilt.
	* gm2/mc-boot/Gmcp2.c:  rebuilt.
	* gm2/mc-boot/Gmcp3.c:  rebuilt.
	* gm2/mc-boot/Gmcp4.c:  rebuilt.
	* gm2/mc-boot/Gmcp5.c:  rebuilt.
	* gm2/mc-boot/GnameKey.c:  rebuilt.
	* gm2/mc-boot/GsymbolKey.c:  rebuilt.
	* gm2/mc-boot/Gvarargs.c:  rebuilt.
	* gm2/mc-boot/Gwrapc.h:  rebuilt.
	* gm2/mc/decl.def:  (addCommentBody)  New procedure.
          (addCommentAfter)  New procedure.  (addIfComments)
          New procedure.  (makeCommentS)  New procedure.
          (getCommentCharStar) New procedure function.
          (getContent) New procedure function.
	  (setProcedureComment) New procedure function.
          (getProcedureComment) New procedure function.
	  (getAfterStatementComment)  New procedure function.
          (getInbodyStatementComment)  New procedure function.
	  (isProcedureComment)  New procedure function.
          (isBodyComment)  New procedure function.
	  (isAfterComment)  New procedure function.
	* gm2/mc/decl.mod:  many alterations to allow per node
	  after and body comments.
	* gm2/mc/keyc.mod:  add free and malloc to the list of
	  names to avoid.
	* gm2/mc/mc.flex:  many alterations to allow per node
	  after and body comments.
	* gm2/mc/mcComment.def:  (commentDesc)  New datatype.
          (initComment)  New procedure function.  (addText)
          New procedure.  (getContent)  New procedure function.
	* gm2/mc/mcComment.h:  updated with new interface.
	* gm2/mc/mcComment.mod:  (commentDesc)  New datatype
	  implemented.
          (initComment)  New procedure function.  (addText)
          New procedure.  (getContent)  New procedure function.
	* gm2/mc/mcComp.def:  export getPassNo.
	* gm2/mc/mcComp.mod:  (getPassNo)  New procedure function.
	* gm2/mc/mcLexBuf.def:  (getProcedureComment)  New procedure
          function.  (getBodyComment)  New procedure function.
	  (getAfterComment)  New procedure function.
	* gm2/mc/mcLexBuf.h:  replicate .def functionality.
	* gm2/mc/mcLexBuf.mod:  (getProcedureComment)  Implement new
          procedure function.  (getBodyComment)  Implement new
	  procedure function.

2018-01-03      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  (BuildUnaryCheckProcedure)
          imported.  (BuildNegateCheck) imported.  (CodeStatement)
          use BuildNegateCheck.  (CodeUnaryCheck)  New procedure.
          (CodeNegateChecked)  New procedure.
	* gm2/gm2-gcc/m2expr.c:  (checkUnaryWholeOverflow)  New
          function.  (m2expr_build_unary_op_check)  New function.
          (BuildEqualToZero)  New function.
          (checkWholeNegateOverflow)  New function.
          (BuildNegateCheck)  New function.  (BuildNegate)
          reimplemented.
	* gm2/gm2-gcc/m2expr.def:  (BuildUnaryCheckProcedure)
          Defined.  (BuildNegateCheck) defined.
	* gm2/gm2-gcc/m2expr.h:  (BuildNegateCheck) added prototype.

2018-01-02      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  (CodeStatement) call
          CodeAddChecked and call CodeSubChecked.
          (CodeAddChecked)  New procedure.  (CodeSubChecked)
          New procedure.
	* gm2/gm2-compiler/M2Quads.mod:  (BuildEndFor) suppress
	  overflow checking in the addition
          of the loop variable.  The explicit for loop check will
          catch an overflow and this addition can overflow for
          unsigned types counting down.
	* gm2/gm2-gcc/m2expr.c:  (BuildAddCheck) corrected
	  comments and strip results.  (BuildSubCheck) corrected
          comments and strip results.
	* gm2/gm2-gcc/m2range.h:  (New file).
	* gm2/patches/gcc/trunc:  (Regenerated).

2018-01-01      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  (CodeAddCheck) New procedure.
          (CodeSubCheck) New procedure.  (CodeBinaryCheck) New procedure.
          Use CodeAddCheck and CodeSubCheck.
	* gm2/gm2-compiler/M2Range.def:  (GetMinMax) exported.
	* gm2/gm2-gcc/m2expr.c:  (BuildAddCheck) New function.
	  (BuildSubCheck) New function.  (checkWholeAddOverflow)
          parameters changed.  (checkWholeSubOverflow)  New function.
          (checkWholeOverflow) updated parameters to include subrange min
	  and max.  (build_binary_op_check)  New function.  (build_binary_op)
          call build_binary_op_check.
	* gm2/gm2-gcc/m2expr.def:  (BuildBinCheckProcedure) New
          definition.  (BuildSubCheck) New procedure function.
	  (BuildAddCheck) New procedure function.
	* gm2/gm2-gcc/m2expr.h:  (BuildAddCheck)  New prototype.
          (BuildSubCheck)  New prototype.
	* gm2/gm2-compiler/M2GenGCC.mod:  pass lowest into binop.
	* gm2/gm2-gcc/m2expr.c:  (BuildAddCheck) extra parameter lowest.
          (BuildSubCheck) extra parameter lowest.  Call build_binary_op
          with extra parameter lowest.  (BuildLessThanZero) New function.
          (BuildGreaterThanZero) New function.  (checkWholeAddOverflow)
          extra parameter and use BuildLessThanZero and
	  BuildGreaterThanZero.    (checkWholeSubOverflow)
          extra parameter and use BuildLessThanZero and
          BuildGreaterThanZero.  (checkWholeOverflow) call
          checkWholeAddOverflow and checkWholeSubOverflow with an extra
          parameter.
	* gm2/gm2-gcc/m2expr.def:  (BuildBinCheckProcedure) extra
          parameter.  (BuildSubCheck) extra parameter lowest.
          (BuildAddCheck) extra parameter lowest.
	* gm2/gm2-gcc/m2expr.h:  corrected prototype.

2017-12-31      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Base.def:  (ExceptionWholeValue) exported
	  and declared.  (ExceptionRealValue) exported and declared.
	* gm2/gm2-compiler/M2Base.mod:  ExceptionWholeValue initialised
          and set appropriately.  ExceptionRealValue initialised and
	  set appropriately.
	* gm2/gm2-compiler/M2Options.def:  (SetWholeValueCheck)
          exported and declared.  (GetWholeValueCheck) exported and
	  declared.
	* gm2/gm2-compiler/M2Options.mod:  (WholeValueChecking)
          initialised.  (SetFloatValueCheck) corrected declaration.
          (GetWholeValueCheck) New procedure function.
	  (SetWholeValueCheck) New procedure.
	* gm2/gm2-compiler/M2Range.def:  (BuildIfCallRealHandlerLoc)
          declared and exported.  (BuildIfCallWholeHandlerLoc)
	  declared and exported.
	* gm2/gm2-compiler/M2Range.mod:  (BuildStringParamLoc)
          New procedure.  (CodeErrorCheckLoc) New procedure.
          (IssueWarningLoc) New procedure.
          (BuildIfCallWholeHandlerLoc) New procedure.
          (BuildIfCallRealHandlerLoc) New procedure.
	  (BuildIfCallHandlerLoc) New procedure.
	* gm2/gm2-gcc/m2block.c:  (do_add_stmt) check to see if
	  a binding level exists.
	* gm2/gm2-gcc/m2builtins.def:  (BuiltInIsfinite) exported.
	* gm2/gm2-gcc/m2expr.c:  (checkWholeAddOverflow) New
          function.  (checkWholeOverflow) New function.
          (checkRealOverflow) correct option check.  Corrected
	  qualifier.  (build_binary_op) removed last parameter.
	* gm2/gm2-gcc/m2linemap.c:  (GetLineNoFromLocation)
          New function.  (GetColumnNoFromLocation) New function.
          (GetFilenameFromLocation) New function.  (ErrorAt)
	  New function.
	* gm2/gm2-gcc/m2linemap.def: (GetLineNoFromLocation)
          exported and declared.  (GetColumnNoFromLocation)
	  exported and declared.
          (GetFilenameFromLocation) exported and declared.
          (ErrorAt) exported and declared.
	* gm2/gm2-gcc/m2linemap.h:  (GetLineNoFromLocation)
          prototype.  (GetColumnNoFromLocation) prototype.
          (GetFilenameFromLocation) prototype.
          (ErrorAt) prototype.
	* gm2/gm2-gcc/m2options.h:  (GetWholeValueCheck)
	  prototype.
	* gm2/gm2-lang.c:  handle -fwholevalue.
	* gm2/gm2-libs-iso/M2RTS.def:  (WholeValueException)
	  and (RealValueException) declared.
	* gm2/gm2-libs-iso/M2RTS.mod:  (WholeValueException)
	  and (RealValueException) New procedures.
	* gm2/gm2-libs/M2RTS.def:  (WholeValueException)
	  and (RealValueException) declared.
	* gm2/gm2-libs/M2RTS.mod:  (WholeValueException)
	  and (RealValueException) New procedures.
	* gm2/lang-options.h:  -fwholevalue and -fno-wholevalue
	  new options added.
	* gm2/lang.opt:  -fwholevalue new option added.
	* gm2/ulm-lib-gm2/std/M2RTS.mod:  (WholeValueException)
	  and (RealValueException) New procedures.

2017-12-28      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Options.def:  (SetFloatValueCheck),
          (GetFloatValueCheck) exported.  (FloatValueChecking) New global
          variable.  (GetFloatValueCheck) New procedure function.
          (SetFloatValueCheck) New procedure.
	* gm2/gm2-compiler/M2Options.mod:  (FloatValueChecking)
          initialise and set accordingly.  (GetFloatValueCheck)
          New procedure function.  (SetFloatValueCheck)  New procedure.
	* gm2/gm2-compiler/M2Range.def:  (BuildIfCallHandlerLoc)  New
          procedure function.
	* gm2/gm2-compiler/M2Range.mod:  (BuildIfCallHandlerLoc)  New
          procedure function implemented.
	* gm2/gm2-gcc/m2expr.c:  (checkWholeOverflow)  New function.
          (checkRealOverflow)  New function.
	* gm2/gm2-gcc/m2options.h:  (SetFloatValueCheck)  New prototype.
          (GetFloatValueCheck)  New prototype.
	* gm2/gm2-lang.c:  handle -ffloatvalue option.
	* gm2/gm2-libs-ch/wrapc.c:  (isfinite)  New function.
          (isfinitel)  New function.  (isfinitef)  New function.
	* gm2/gm2-libs/Builtins.def:  (isfinitel)  New function.
	  (isfinitef)  New function.
	* gm2/gm2-libs/Builtins.mod:  (isfinitel)  New function
          implemented.  (isfinitef)  New function implemented.
	* gm2/gm2-libs/wrapc.def:  (isfinitel)  New function.
          (isfinitef)  New function.
	* gm2/lang-options.h:  update comment for -fsoft-check-all.
          Introduce -ffloatvalue.
	* gm2/lang.opt:  introduce -ffloatvalue.  Update comment for
	  -fsoft-check-all.

2017-12-27      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Range.mod:  remove unused variables from
          many procedures.  (RangeCheckReal)  New procedure.
          (RangeCheckOrdinal)  New procedure.  (DoCodeAssignmentExprType)
          call the appropriate check procedure.
	* gm2/gm2-gcc/gcc-consolidation.h:  update dates.
	* gm2/gm2-gcc/m2builtins.c:  (__builtin_isfinite)  New entry.
          (gm2_isfinite_node)  New variable.  (builtin_ftype_int_var)
          New variable.  (BuiltInIsfinite)  New function.
	  (DoBuiltinIsfinite)  New function.  (isgreater),
          (isgreaterequal), (isless), (islessequal), (islessgreater),
          (isunordered) new builtins defined.  Lookup gm2_isfinite_node.
	* gm2/gm2-gcc/m2builtins.def:  (BuiltInIsfinite)  New procedure
          function.  Define (BuiltInIsfinite).
	* gm2/gm2-gcc/m2expr.c:  (m2expr_checkWholeOverflow)  New
          function.  (m2expr_checkRealOverflow)  New function.
          (build_binary_op)  call the appropriate check function.
	* gm2/gm2-libs/Builtins.def:  remove nanf, nan, nanl,
          isinf_sign, isinf_sigf and isinf_signl.
	* gm2/gm2-libs/Builtins.mod:  reimplement isfinite.
          Remove nanf, nan, nanl, isinf_sign, isinf_sigf and
          isinf_signl.
	* gm2/gm2-libs/cbuiltin.def:  remove nan, nanf and nanl.
	* gm2/gm2-libs/wrapc.def:  define isfinite.
	* gm2/m2pp.c:  add includes to allow m2pp.c to be built for use
	  in cc1.

2017-12-20      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-libs/Builtins.def:  new function definitions
          for (nan), (nanf), (nanl), (isfinite), (isfinitef),
          (isfinitel), (isinf_sign), (isinf_signf), (isinf_signl).
	* gm2/gm2-libs/cbuiltin.def: new function definitions
          for (nan), (nanf), (nanl), (isfinite), (isfinitef),
          (isfinitel), (isinf_sign), (isinf_signf), (isinf_signl).
	* gm2/gm2builtins.c:  add definitions in the static structure
          for (nan), (nanf), (nanl), (isfinite), (isfinitef),
          (isfinitel), (isinf_sign), (isinf_signf), (isinf_signl).

2017-12-01      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Quads.mod:  (CheckBecomesMeta)
          check to see if GetDType(Des) and GetDType(Exp) are non
          nul before testing against unbounded.  Defends against
          undefined symbols being compared which might result in
	  a fatal error.  (see testsuite/gm2/iso/fail/bug8.mod).

2017-11-08      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removed Storage.c from GM2-LIBS-BOOT-C.
          made gm2.paranoid dependant upon mc.
	* gm2/gm2-libs-ch/Storage.c:  removed since it is built (in
	  the build directory) from Storage.mod via mc.
	* gm2/gm2-libs-ch/StdIO.c:  removed since it is built (in the
          build directory) from StdIO.mod via mc.
	* gm2/Make-lang.in:  added Storage.mod into GM2-LIBS-MODS.

2017-11-02      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removed duplicate and incorrect rule.
          Changed rule for building C files to the correct directory.

2017-11-01      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/gcc-consolidation.h:  #include "stringpool.h"
	* gm2/gm2-compiler/M2Base.mod:  removed unnecessary forward
          declarations.  (PushSizeOf)  does not assume the fixed
          fixed complex data types exist, uses constants instead.
	* gm2/gm2-gcc/m2type.c:  (build_m2_specific_size_type)
          checks to see if the REAL_TYPE with a desired precision
          exists.  NULL is returned if the target does not support
          the data type.
	* gm2/gm2-gcc/m2type.c:
          (m2type_BuildProcTypeParameterDeclaration) no longer
          layout the paramater type at this time (as it might be a
	  recursive usage of the proctype).

2017-10-30      Gaius Mulley <gaius@gnu.org>

	* gm2/m2.flex:  change linelen to int rather than
          unsigned int, a mismatch found when building for
	  cygwin.

2017-10-04      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-libs/GetOpt.def:  New file.
	* gm2/gm2-libs/GetOpt.mod:  New file.
	* gm2/gm2-libs/getopt.def:  New file.
	* gm2/gm2-libs-ch/getopt.c:  New file.
	* gm2/el/g-mode.el:  change the Modula-2 comment tag
          to (*!m2pim+gm2*)\n")
	* gm2/gm2-compiler/SymbolKey.def:  (ContainsSymKey)
          New procedure.
	* gm2/gm2-compiler/SymbolKey.mod:  (ContainsSymKey)
          New procedure.
	* gm2/gm2-compiler/ppg.mod:  removed unnecessary
          forward declaration prototypes.  (AddEntry)  New
          procedure.  Use SetOfStop rather than BITSET for
          small sets.  Fix off by one error with setsize.
	* gm2/gm2-libs-iso/RndFile.mod:  correct error message.
	* gm2/tools-src/buildpg:  changes to reflect changes to
	  ppg.mod

2017-07-24      Gaius Mulley <gaius@gnu.org>

	* patches/gcc/6.4.0:  01-patches (New file).
	* patches/gcc/6.4.0:  02-patches (New file).
	* patches/gcc/6.4.0:  03-patches (New file).
	* patches/gcc/6.4.0:  04-patches (New file).
	* patches/gcc/6.4.0:  05-patches (New file).
	* patches/gcc/6.4.0:  06-patches (New file).
	* patches/gcc/6.4.0:  07-patches (New file).
	* patches/gcc/6.4.0:  08-patches (New file).
	* patches/gcc/6.4.0:  09-patches (New file).
	* patches/gcc/6.4.0:  10-patches (New file).
	* patches/gcc/6.4.0:  11-patches (New file).

2017-07-21      Gaius Mulley <gaius@gnu.org>

	* gm2/el/g-mode.el:  updated to include the new SYSTEM data types.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  rename the new types
          CSIZE_T and CSSIZE_T.
	* gm2/gm2-compiler/M2System.def:  introduce the signed type
          CSSIZE_T.
	* gm2/gm2-compiler/M2System.mod:  assign type symbols CSIZE_T
          and CSSIZE_T to exported variables.
	* gm2/gm2-gcc/m2type.c:  GetCSSizeType (New procedure function).
	* gm2/gm2-gcc/m2type.def:  GetCSSizeType (New procedure function).
	* gm2/gm2-gcc/m2type.h:  GetCSSizeType (New procedure function).
	* gm2/gm2-libs-coroutines/SYSTEM.def:  export CSIZE_T, CSSIZE_T.
	* gm2/gm2-libs-iso/SYSTEM.def:  export CSIZE_T, CSSIZE_T.
	* gm2/gm2-libs-min/SYSTEM.def:  export CSIZE_T, CSSIZE_T.
	* gm2/gm2-libs/SYSTEM.def:  export CSIZE_T, CSSIZE_T.
	* gm2/gm2-libs/libc.def:  corrected dates and use new data types.
	* gm2/gm2.texi:  updated documentation about new data types.

2017-07-18      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  the pge build rules all rewritten to
          clean the build process.  All versions of pge have their
          own build directory.
	* gm2/gm2-compiler/M2System.mod:  (size_t)  new data type
          in SYSTEM.def to aid interface code between C and Modula-2.
	* gm2/gm2-gcc/m2type.c:  (GetCSizeTType) New procedure function.
	* gm2/gm2-gcc/m2type.def:  (GetCSizeTType) New procedure
          function.
	* gm2/gm2-gcc/m2type.h:  (GetCSizeTType) extern declaration.
	* gm2/tools-src/makeSystem:  corrected dates.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  declare CSizeT.
	* gm2/gm2-compiler/M2System.def:  export CSizeT.
	* gm2/gm2-compiler/M2System.mod:  declare CSizeT as a system
	  type.

2017-06-27      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/gm2m.bnf:  removed unnecessary spaces.
	* gm2/mc-boot/GStdIO.c:  rebuilt.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  (doEscapeC) removed.  (escapeContentsC)
          removed.  (replaceChar) fixed bug should the first character
          be replaced.  (toCstring) reimplemented with replaceChar.
          (toCchar) reimplemented with replaceChar.
	* fixes a bug caused when gm2m is bootstrapped via mc.
          -fmakeall failed as reported by Christoph Schlegel
	  and Georg Lokowandt.

2017-06-21      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/map/StoreCoord.mod:  spacing.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  handle large arrays.
          (BuildIndex) rewritten to check whether we need to use a large
          array.  Check for overflow and emit error if we exceed
	  implementation restriction.
	* gm2/gm2-compiler/M2GenGCC.mod:  (CodeArray) rewritten to
	  implement large arrays if necessary.
	* gm2/gm2-compiler/SymbolTable.def:  (PutArrayLarge) New procedure.
	  (IsArrayLarge) New function procedure.
	* gm2/gm2-compiler/SymbolTable.mod:  (Array) new field Large.
          (PutArrayLarge) New procedure.  (IsArrayLarge) New procedure
	  function.
	* gm2/gm2-gcc/m2convert.c:  corrected dates.
	* gm2/gm2-gcc/m2expr.c:  (BuildArray) convert low_indice and
	  use build4_loc rather than build4 to generate an array reference.
	* gm2/gm2-gcc/m2type.c:  (ValueInTypeRange)  New function.
          (ValueOutOfTypeRange)  New function.  (ExceedsTypeRange)
          New function.  (WithinTypeRange)  New function.
          (BuildArrayIndexType)  use integer type as the base index to an array
	  rather than the Z type.  GCC restriction.
	* gm2/gm2-gcc/m2type.def:  (ValueInTypeRange)  New function.
          (ValueOutOfTypeRange)  New function.  (ExceedsTypeRange)
          New function.  (WithinTypeRange)  New function.
	* gm2/gm2-gcc/m2type.h:  (ValueInTypeRange)  New function.
          (ValueOutOfTypeRange)  New function.  (ExceedsTypeRange)
          New function.  (WithinTypeRange)  New function.
	* gm2/gm2-libs/StdIO.mod:  initialise StackRPtr.
	* gm2/m2pp.c:  (m2pp_call_expr) use m2pp_expression
          rather than m2pp_identifier.
	* gm2/mc-boot/GAssertion.c:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GNumberIO.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/Make-lang.in:  pass the NO_PIE_CFLAGS into the
          mklink tool.
	* gm2/tools-src/mklink.c:  (args) new variable.  Append
          all gcc/g++ options (-f) to args.  Emit args in the
          link command.  Allows cc1gm2 to be linked with
          NO_PIE_CFLAGS.
	* patches/gcc/trunc/01-patches:  regenerated.
	* patches/gcc/trunc/02-patches:  regenerated.
	* patches/gcc/trunc/03-patches:  regenerated.
	* patches/gcc/trunc/04-patches:  regenerated.
	* patches/gcc/trunc/05-patches:  regenerated.
	* patches/gcc/trunc/06-patches:  regenerated.
	* patches/gcc/trunc/07-patches:  regenerated.
	* patches/gcc/trunc/08-patches:  regenerated.
	* patches/gcc/trunc/09-patches:  regenerated.
	* patches/gcc/trunc/10-patches:  regenerated.
	* patches/gcc/trunc/11-patches:  regenerated.

2017-06-13      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2expr.c:  more gnu coding standard changes.

2017-06-12      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  renamed target.c to host.c
          and changed appropriate rules.
	* gm2/gm2-libs-ch/host.c:  renamed from target.c
          corrected dates and formatting.  Include gm2-libs-host.h
          rather than p2c.h.
	* gm2/gm2-compiler/M2GenGCC.mod:  checkArrayElements,
          checkRecordTypes  remove first parameter, quad.
          checkIncorrectMeta (New procedure function).
          checkBecomes call checkIncorrectMeta.
          (CodeBecomes) call SubQuad.  Fixes a bug reported by
          John Dubery.
	* gm2/gm2-gcc/m2expr.c:  BuildModM2, BuildDivM2 fold and strip
	  no ops before asserting their type.

2017-06-09      Gaius Mulley <gaius@gnu.org>

 	* gm2/gm2-libs-ch/dtoa.c:  use memmove instead of memcpy.
          Fixes a bug reported by Ernst Bokkelkamp.
	* gm2/gm2-gcc/m2expr.c:  many formatting gnu coding standard
	  changes.

2017-06-08      Gaius Mulley <gaius@gnu.org>

	* Fixed pim4 and iso DIV and MOD bug reported by Ernst Bokkelkamp
          <ernst@bokkelkamp.de>, Benjamin Kowarsch and Xin Wang.
	* gm2/gm2-compiler/M2GenGCC.mod:  CodeDivM2, CodeModM2,
          FoldDivM2, FoldModM2, FoldDivCeil, CodeDivCeil, FoldModCeil
          CodeModCeil (New procedures).
	* gm2/gm2-compiler/M2Options.def:  GetISO, GetPIM, GetPIM2,
          GetPIM3, GetPIM4, GetPositiveModFloor (New procedure function
          definitions).
	* gm2/gm2-gcc/m2options.h:  define/export functions
	  GetISO, GetPIM, GetPIM2, GetPIM3, GetPIM4, GetPositiveModFloor.
	* gm2/gm2-compiler/M2Options.mod: ensure that the default pim4
          setting is turned off if pim2, pim3 is selected.  GetISO, GetPIM,
          GetPIM2, GetPIM3, GetPIM4, GetPositiveModFloor (New procedure
          functions).
	* gm2/gm2-compiler/M2Quads.def:  DivM2Op, ModM2Op, DivCeilOp
          ModCeilOp (New quad operators).
	* gm2/gm2-compiler/M2Quads.mod:  removed unnecessary prototypes.
          MakeOp returns ModM2Op or DivM2Op for a modulus or div operator.
          Added new quad operators to the case statement selections.
	* gm2/gm2-gcc/m2expr.c:  include m2options.h.  BuildDivCeil,
          BuildModCeil, BuildDivM2, BuildModM2 (New functions).
          Much gnu coding standard reformatting has occurred.
	* gm2/gm2-gcc/m2expr.def:  define BuildDivM2, BuildModM2,
          BuildDivCeil, BuildModCeil.
	* gm2/gm2-gcc/m2expr.h:  define BuildDivM2, BuildModM2,
          BuildDivCeil, BuildModCeil.
	* gm2/mc/mcError.mod:  corrected dates.
	* gm2/gm2-gcc/m2statement.c:  removed call to
          dump_function (TDI_generic, fndecl) as it is no longer
          supported.
	* gm2/tools-src/gensum.py:  filter out gm2/non-free results
	  from being displayed.

2017-06-06      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod: (CodeLengthFunction) Call
          InternalError if op1 is a constant.
          (FoldLengthFunction) if op1 is a constant fold the
	  result and remove the quadruple.
	* gm2/gm2-compiler/M2Quads.mod:  (BuildLengthFunction)
          check to see if parameter to length is a constant
          if so then use StandardFunctionOp otherwise
          call M2RTS_Length.  Fixes a bug reported by
	  Ernst Bokkelkamp <ernst@bokkelkamp.de>.
	* gm2/gm2-compiler/SymbolTable.mod:  correct end procedure
          name PutConstIntoTypeTree.
	* gm2/gm2-gcc/m2expr.c:  many gnu coding standard changes.
	* gm2/mc/mcStream.mod:  (createTemporaryFile) create a per
          process temporary file name.
	* (mc) regenerated.

2017-06-05      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  CodeArray add extra
          parameter to BuildArray.
	* gm2/gm2-compiler/M2Quads.mod:  PushOne (New procedure).
          PushZero (New procedure).  BuildPseudoBy call PushOne.
          BuildIncProcedure, BuildDecProcedure call PushOne.
          BuildForToByDo call PushZero.
	* gm2/gm2-compiler/SymbolTable.mod:  add ConstLitTree
          field to Pointer and Subrange types.  Allow
          GetConstFromTypeTree and PutConstIntoTypeTree to get and
          store constants into their respective ConstLitTree(s).
	* gm2/gm2-gcc/m2expr.c:  convert the array index into the
          array index type before accessing the array element.
	* gm2/gm2-gcc/m2expr.def:  introduce extra location parameter
          to BuildArray.
	* gm2/gm2-gcc/m2expr.h:  introduce extra location parameter
          to BuildArray.
	* gm2/gm2-lang.c:  corrected formatting.  Call write_globals.
          Rewrite m2_write_global_declarations.  Replace
          gm2_langhook_write_globals with write_globals.  Remove
          LANG_HOOKS_WRITE_GLOBALS.
	* gm2/gm2-libs/NumberIO.mod:  white spaces removed.
	* gm2/lang.opt:  corrected dates.  Allow Modula-2 to skip over
          the fobjc-std=objc1 option.
	* gm2/patches/gcc/trunc/11-patches:  remove assert.

2017-06-01      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removed M2Constants.def
          M2Constants.mod M2Entity.def M2Entity.mod.
	* gm2/gm2-compiler/M2ALU.mod:  import ZType and change all
          calls to MakeConstLit with a second type parameter.
	* gm2/gm2-compiler/M2Base.mod:  remove unused MaxCard
          and zero.
	* gm2/gm2-compiler/M2Bitset.mod:  change call
          to MakeConstLit to include a second type parameter.
	* gm2/gm2-compiler/M2GenGCC.mod:  change all calls
          to MakeConstLit to include a second type parameter.
	* gm2/gm2-compiler/M2Quads.mod:  change all calls
          to MakeConstLit to include a second type parameter.
          Also reduce BuildPseudoBy by removing special case
          of NulSym type.
	* gm2/gm2-compiler/M2Range.mod:  MakeAndDeclareConstLit
          (New procedure function).  FoldNonPosDiv, FoldNonPosMod,
          FoldZeroDiv, FoldZeroRem, CodeWholeNonPos, CodeWholeZero,
          use MakeAndDeclareConstLit to test against zero of the
          correct type.
	* gm2/gm2-compiler/P2SymBuild.mod:  change all calls
          to MakeConstLit to include a second type parameter.
	* gm2/gm2-compiler/SymbolTable.def:  add second parameter
	  to MakeConstLit.
	* gm2/gm2-compiler/SymbolTable.mod:  add second parameter
          to MakeConstLit.  Add ConstLitTree to the SymType.
          GetConstFromTypeTree, PutConstIntoTypeTree
          (New procedure functions).  GetConstLitType changed
          parameter from Sym to Name and implemented it accordingly.
	* gm2/gm2-gcc/init.c:  remove M2Entity, M2SubExp, M2Constants
          from the initialization sequence.
	* gm2/init/gm2-gccinit:  remove M2Entity, M2SubExp, M2Constants
          from the initialization sequence.
	* gm2/gm2-gcc/m2expr.c:  added test shortcut.

2017-05-31      Gaius Mulley <gaius@gnu.org>

	* gm2/tools-src/gensum.py:  improved summary using colours.

2017-05-30      Gaius Mulley <gaius@gnu.org>

	* patches/gcc/trunc/01-patches:  (New file).
	* patches/gcc/trunc/02-patches:  (New file).
	* patches/gcc/trunc/03-patches:  (New file).
	* patches/gcc/trunc/04-patches:  (New file).
	* patches/gcc/trunc/05-patches:  (New file).
	* patches/gcc/trunc/06-patches:  (New file).
	* patches/gcc/trunc/07-patches:  (New file).
	* patches/gcc/trunc/08-patches:  (New file).
	* patches/gcc/trunc/09-patches:  (New file).
	* patches/gcc/trunc/10-patches:  (New file).
	* patches/gcc/trunc/11-patches:  (New file).
	* gm2/tools-src/gensum.py:  tidied up spacing and changed Usage
          to take an exit code.
	* gm2/gm2-lang.c:  call build_common_tree_nodes with a single
          parameter.  Use late_global_decl callback instead of global_decl.
	* gm2-gcc/m2type.c:  use SET_TYPE_ALIGN instead of an assignment.
	* gm2/gm2-gcc/gcc-consolidation.h:  include backend.h,
          rtl.h, predict.h and df.h.
	* gm2/tools-src/gensum.py:  changed CVS url to the git url.
          Generate a summary at the top of the passes, failures and
	  unresolved tests.

2017-05-24      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  use separate procedure to
          declare variables depending whether -fm2-whole-program was
          specified.  (DeclareImportedVariablesWholeProgram)  New
          procedure.  (DeclareVariableWholeProgram)  New procedure.
          (DeclareGlobalVariablesWholeProgram)  New procedure.
          (DeclareImportedVariablesWholeProgram)  New procedure.
          (StartDeclareModuleScopeWholeProgram)  use
	  DeclareImportedVariablesWholeProgram.
	* gm2/gm2-gcc/m2decl.c:  corrected dates.

2017-05-23      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Code.mod:  removed unnecessary code.
          No longer need M2SubExp.mod.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  (IsRecordFieldDependants)
          check alignment value.  (WalkRecordFieldDependants)
          walk alignment value.  (WalkVarient) walk alignment value.
	* gm2/gm2-compiler/M2Quads.mod:  change comment as we no longer
          use M2SubExp.mod
	* gm2/gm2-gcc/m2convert.c:  use convert_loc instead of convert.
	* gm2/gm2.texi:  remove groff font change and use texinfo.
	* gm2/init/gm2-gccinit:  remove M2SubExp from the list.
	* updated web pages to reflect release of 1.2.0.

2017-05-11      Gaius Mulley <gaius@gnu.org>

	* gm2/NEWS:  updated to reflect release 1.2.0.
	* gm2/configure:  regenerated.
	* gm2/configure.in:  updated to reflect release 1.2.0.
	* gm2/gm2-libs/config-host.in:  updated to reflect
	  release 1.2.0.
	* gm2/gm2-libs/config-target.in:  updated to reflect
          release 1.2.0.
	* gm2/gm2.texi:  updated to reflect release 1.2.0.
	* gm2/version.c:  updated to reflect release 1.2.0.
	* gm2/gm2-compiler/M2GenGCC.mod:  added tests for type equivalence
          between operands in CodeIfSetEqu and CodeIfSetNotEqu.  Fixes a bug
          reported by Ernst Bokkelkamp.

2017-05-10      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2.texi:  document the -fm2-g option.
	* gm2/Make-lang.in:  removed old conditional.  Added
	-fm2-g flag.  Removed obsolete variables.  Removed
	  redundant flags in compilation builds.
	* gm2/bnf/m2-3.bnf:  removed BuildLineNote.  Introduced
	  BuildStmtNote.
	* gm2/bnf/m2-h.bnf:  removed BuildLineNote.
	* gm2/examples/map/RoomMap.mod:  removed WriteString, WriteLn.
	* gm2/examples/map/StoreCoords.mod:  changed error message.
	* gm2/gm2-compiler/M2Code.mod:  call DebugLineNumbers.
	* gm2/gm2-compiler/M2Comp.def:  changed spacing.
	* gm2/gm2-compiler/M2GCCDeclare.def:  add tokenno parameter to
	  many procedures.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  removed QuadToTokenNo,
	  use tokenno parameter instead.
	* gm2/gm2-compiler/M2GenGCC.mod:  import addStmtNote,
          removeStmtNote.  Implement CodeStatementNote, FoldStatementNote
          call them from the appropriate case statements.  Remove
	  all QuadToTokenNo calls and use CurrentQuadToken instead.
	* gm2/gm2-compiler/M2LexBuf.def:  export GetTokenName.
	* gm2/gm2-compiler/M2LexBuf.mod:  new procedure function
	  GetTokenName.
	* gm2/gm2-compiler/M2Optimize.mod:  removed spaces.
	* gm2/gm2-compiler/M2Options.def:  export GetCpp,
          SetM2g and GetM2g.
	* gm2/gm2-compiler/M2Options.mod:  implement GetCpp,
          SetM2g and GetM2g.
	* gm2/gm2-compiler/M2Quads.def:  define BuildStmtNote
	  and BuildStmtOp.  Removed spaces.
	* gm2/gm2-compiler/M2Quads.mod:  implement BuildStmtNote.
          Ensure BEGIN END tokens are accurate.  Use StatementNoteOp
	  instead of LineNumberOp.
	* gm2/gm2-compiler/M2Range.mod:  pass tokenno as a parameter to
	  DeclareConstructor.
	* gm2/gm2-compiler/M2Search.def:  improve comment.
	* gm2/gm2-compiler/SymbolTable.def:  DebugLineNumbers new
	  procedure.
	* gm2/gm2-compiler/SymbolTable.mod:  DebugLineNumbers implement
	  new procedure.
	* gm2/gm2-gcc/m2block.c:  do_add_stmt, flush_pending_note,
          addStmtNote, removeStmtNote new functions.
	* gm2/gm2-gcc/m2block.def:  export addStmtNote, removeStmtNote,
	  add_stmt.
	* gm2/gm2-gcc/m2block.h:  export addStmtNote, removeStmtNote,
	  add_stmt.
	* gm2/gm2-gcc/m2options.h:  export GetCpp, GetM2g, SetM2g.
	* gm2/gm2-gcc/m2statement.c:  use convert_loc instead of convert.
	* gm2/gm2-gcc/m2treelib.c:  call m2block_add_stmt.
	* gm2/gm2-gcc/m2treelib.h:  removed spaces.
	* gm2/gm2-lang.c:  introduce -fm2-g flag.
	* gm2/gm2-lang.h:  define convert_loc.
	* gm2/lang-options.h:  introduce -fm2-g flag.
	* gm2/lang.opt:  introduce -fm2-g flag.
	* gm2/m2.flex:  only run the assert if we are not invoking
	  the C preprocessor.

2017-04-27      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  many new rules to allow
          make gm2.verifystage12 to work.

2017-04-27      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  gm2/gm2-compiler/m2flex.o new rule
          for g++.   gm2/gm2-compiler/cflex.o new rule for g++.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  remove use of GetType
	  and GetLowestType.
          Import GetLType, GetSType, GetDType and use these instead.
	* gm2/gm2-compiler/M2Quads.mod:  remove use of GetType
	  and GetLowestType.
          Import GetLType, GetSType, GetDType and use these instead.
	* gm2/gm2-compiler/SymbolTable.def:  define GetSType,
	  GetLType and GetDType.
	* gm2/gm2-compiler/SymbolTable.mod:  implement GetSType,
	  GetLType and GetDType.

2017-04-26      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  import
          GetLowestType and use it during the declaration of
          parameters and variables.
	* gm2/gm2-compiler/M2GenGCC.mod:  (DoCopyString) improved
          comment.  (CodeXIndr)  call SkipType, renamed variables.
	* gm2/gm2-compiler/M2Options.def:  (DebugFunctionLineNumbers)
          new variable.  (SetDebugFunctionLineNumbers) new procedure.
	* gm2/gm2-compiler/M2Options.mod:  (SetDebugFunctionLineNumbers)
          new procedure.  (DebugFunctionLineNumbers) initialise.
	* gm2/gm2-compiler/M2Quads.mod:  (CheckAssignCompatible)
          reorder the list of if statements to detect set type checking.
	* gm2/gm2-compiler/SymbolTable.mod:  (GetLowestType)
          tidied up to remove deadcode and also correct a bug to ensure
          it does not skip over user specified alignment types.
	* gm2/gm2-gcc/m2expr.c:  (BuildAddr) use_generic parameter
          will cast the pointer to ADDRESS.
	* gm2/gm2-gcc/m2options.h:  (SetDebugFunctionLineNumbers) added.
	* gm2/gm2-gcc/m2tree.c:  (m2tree_skip_type_decl) skip_type_decl
          if necessary.
	* gm2/gm2-lang.c:  (OPT_fdebug_function_line_numbers) case added.
	* gm2/lang-options.h:  add entry for -fdebug-function-line-numbers.
	* gm2/lang.opt:  improved description.  Introduced
	  fdebug-function-line-numbers.

2017-04-21      Gaius Mulley <gaius@gnu.org>

	* Applied fixes to the testsuite reported by
          Ernst Bokkelkamp.
	* testsuite/gm2/exceptions/run/pass/gm2.exp:  look
          for xg++ rather than g++.
	* testsuite/gm2/extensions/run/pass/vararg3.mod:
          convert 11 into an INTEGER for a vararg parameter.
	* testsuite/gm2/switches/check-all/run/fail/gm2.exp:
          test for the source path and filename when avoiding
	  a testcase.

2017-03-29      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot-ch/Glibc.c:  return the result from
	  close.

2017-03-21      Gaius Mulley <gaius@gnu.org>

	* gm2/m2.flex:  match new cpp file start/end codes.

2017-03-21      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  detect circular
          dependency in AssertAllTypesDeclared and generate
          error message rather than abort.
	* corrected a number of regression test programs.

2017-03-18      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  many changes to the way the parser
          generator is built.  A number of cyclic dependancies
          have been removed and building times are much shorter.

2017-03-14      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2type.c:  get_unsigned (New function).
          BuildSubrangeType use get_unsigned.
	* gm2/gm2-libs-iso/SysClock.mod:  undo previous commit to restore
	source contents.
	* gm2/ulm-lib-gm2/std/Calendar.mod:  CDate changed to use
          temporary variables to avoid dangerous code which is exposed
          by overflow errors during gimplification.
	* gm2/patches/gcc/5.2.0/11-patches:  New file.
	* gm2/patches/gcc/5.2.0/12-patches:  New file.

2017-03-14      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  check range of type conversion
	  of constants.
	* gm2/gm2-compiler/M2GenGCC.mod:  BuildFunctValue now returns tree
          which must be added to the statement list.  GenerateCleanup
          (New procedure function).  CheckCleanup (New procedure function).
          CodeCall changed since CodeDirectCall and CodeIndirectCall now
	  return trees.
	* gm2/gm2-compiler/SymbolTable.def:  removed white space.
	* gm2/gm2-compiler/SymbolTable.mod:  HasVarParameters (New procedure
	  function).
	* gm2/gm2-gcc/m2block.def:  export begin_statement_list,
	  push_statement_list, pop_statement_list.
	* gm2/gm2-gcc/m2decl.c:  BuildParameterDeclaration set
	  the address of a VAR parameter to TREE_READONLY.
	* gm2/gm2-gcc/m2statement.c:  BuildIndirectProcedureCallTree returns
          a tree.  BuildFunctValue returns a tree.
          GetParamTree (New procedure function).  BuildTryFinally (New
	  procedure function).  BuildCleanUp (New procedure function).
	* gm2/gm2-gcc/m2statement.def:  BuildFunctValue returns a tree.
          Declare GetParamTree.  Declare BuildTryFinally.
	  Declare BuildCleanUp.
	* gm2/gm2-gcc/m2statement.h:  BuildFunctValue returns a tree.
          Declare GetParamTree.  Declare BuildTryFinally.
	  Declare BuildCleanUp.
	* gm2/gm2-gcc/m2type.c:  BuildProcTypeParameterDeclaration layout
	  the type at the end of the function.
	* gm2/gm2-libs-iso/SysClock.mod:  temporarily changed to hunt
	  down a bug.
	* gm2/m2pp.c:  improved type description for sized types.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc/decl.mod:  fixed bug in recordfield
	  (initialize scope to NIL).

2017-02-17      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GCCDeclare.mod:  removed
          procedure prototypes.
	* gm2/gm2-compiler/M2GenGCC.mod:
          CheckConvertCoerceParameter detect if
	  the OperandType = ParamType and return early.
	* gm2/gm2-gcc/m2type.c:  (finish_build_pointer_type)
          layout the type.
	* gm2/m2pp.c:  (m2pp_identifier) detect and handle
	  COMPONENT_REF.

2017-02-12      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Base.mod:  allow many more
          base types to be compatible with SYSTEM types
          WORD, BYTE and friends.
	* gm2/gm2-compiler/M2GenGCC.mod:  remove the convert
          in CodeAddr.
	* gm2/gm2-compiler/M2Quads.mod:  remove unnecessary
          white space.  ManipulateParam generate an LValue for
          any parameter passed by reference.
	* gm2/gm2-gcc/m2type.def:  export GetM2ComplexType.
	* gm2/gm2-lang.c:  introduce minor debugging.

2017-02-04      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  add location to
          BuildStartFunctionCode.  Add location to
          finishFunctionDecl.  Add location to
	  BuildEndFunctionCode.
	* gm2/gm2-gcc/m2decl.c:  add DECL_BY_REFERENCE
          to parameter which is passed by reference.
	* gm2/gm2-gcc/m2statement.c:  add location to
          BuildStartFunctionCode and BuildEndFunctionCode.
          Reset cfun and current_function_decl to NULL at
          the end of the BuildEndFunctionCode.
	* gm2/gm2-gcc/m2statement.def:  add location to
          BuildStartFunctionCode and BuildEndFunctionCode.
	* gm2/gm2-gcc/m2statement.h:  add location to
          BuildStartFunctionCode and BuildEndFunctionCode.
	* gm2/gm2-gcc/m2treelib.c:  m2treelib_get_set_field_des
          rewritten to obtain the address and then indirectly
          reference the value so that it can be placed on the lhs
          of an assignment.  (m2treelib_get_set_value) detect
          if lvalue is a POINTER_TYPE and if so then perform
          and indirection lookup before generation the component
          reference.
	* gm2/m2pp.c:  modified to include a bits boolean in
          the pretty state machine.  Which will be used to print
	  useful TREE boolean flags.

2017-02-01      Gaius Mulley <gaius@gnu.org>

	* gm2/m2pp.c:  modified to allow it to be built and
          included in the cc1 and cc1plus frontends.
	  Also fixed bugs to avoid crashing if bitfields
          are used and displayed from cc1plus.

2017-01-23      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/Gtop.c:  regenerated.
	* gm2/mc/decl.mod:  add CAP to the implementation of mc.
	* gm2/mc/mcError.mod:  set ExitOnHalt before calling InternalError.
	* gm2/mc/top.mod:  call ExitOnHalt before calling compile.

2017-01-19      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-libs-iso/wrapsock.c:  corrected a configure bug
          use HAVE_SIGNAL_H instead of HAVE_MALLOC_H.
	* gm2/mc-boot-ch/Gpth.c:  added dummy function calls to
          satisfy the linker.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc/decl.mod:  LENGTH implemented.  isAProcType
          new procedure function.  requiresUnpackProc (New
          procedure).  doAssignment use requiresUnpackProc.
	* gm2/mc/keyc.def:  useM2RTS, useStrlen, useCtype
          defined.
	* gm2/mc/keyc.mod:  useM2RTS, useStrlen, useCtype
	  implemented.
	* gm2/mc/decl.mod:  doLengthC (New procedure).
	  length is placed in the base symbol scope.

2017-01-16      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  add shortcomplex, longcomplex
          to the list of base datatypes in mc.

2017-01-15      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot-ch/Glibc.c:  process the \\n
          escapes before using vfprintf.  libc_getpid
          (New function).  libc_sleep (New function).
	* gm2/mc/decl.mod:  (doEscapeC) avoid escaping \\.

2017-01-12      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/Gdecl.c:  New file.
	* gm2/mc-boot/GmcComment.c:  New file.
	* gm2/mc-boot/GmcComment.h:  New file.
	* gm2/mc/mcComment.def:  New file.
	* gm2/mc/mcComment.mod:  New file.

2017-01-11      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  add a def to the done list.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc/decl.mod:  handle type COMPLEX and RE, IM.
          Tidy up formatting of h files.  Implement setvalue.
	  Fix proctype using an unbounded array parameter.
	* gm2/mc/keyc.def:  (useComplex) New procedure.
	* gm2/mc/keyc.mod:  detect type complex and complex related
	  intrinsics.
	* gm2/bnf/mc-4.bnf:  fix bug when created a typed const.
	* gm2/mc-boot-ch/Glibc.c:  regenerated.
	* gm2/mc-boot/GASCII.h:  regenerated.
	* gm2/mc-boot/GArgs.h:  regenerated.
	* gm2/mc-boot/GAssertion.h:  regenerated.
	* gm2/mc-boot/GBreak.h:  regenerated.
	* gm2/mc-boot/GCOROUTINES.h:  regenerated.
	* gm2/mc-boot/GCmdArgs.h:  regenerated.
	* gm2/mc-boot/GDebug.h:  regenerated.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated.
	* gm2/mc-boot/GEnvironment.h:  regenerated.
	* gm2/mc-boot/GFIO.h:  regenerated.
	* gm2/mc-boot/GFormatStrings.h:  regenerated.
	* gm2/mc-boot/GFpuIO.h:  regenerated.
	* gm2/mc-boot/GIO.h:  regenerated.
	* gm2/mc-boot/GIndexing.h:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.h:  regenerated.
	* gm2/mc-boot/GM2RTS.h:  regenerated.
	* gm2/mc-boot/GMemUtils.h:  regenerated.
	* gm2/mc-boot/GNumberIO.h:  regenerated.
	* gm2/mc-boot/GPushBackInput.h:  regenerated.
	* gm2/mc-boot/GRTExceptions.h:  regenerated.
	* gm2/mc-boot/GRTint.h:  regenerated.
	* gm2/mc-boot/GSArgs.h:  regenerated.
	* gm2/mc-boot/GSFIO.h:  regenerated.
	* gm2/mc-boot/GSYSTEM.h:  regenerated.
	* gm2/mc-boot/GSelective.h:  regenerated.
	* gm2/mc-boot/GStdIO.h:  regenerated.
	* gm2/mc-boot/GStorage.h:  regenerated.
	* gm2/mc-boot/GStrCase.h:  regenerated.
	* gm2/mc-boot/GStrIO.h:  regenerated.
	* gm2/mc-boot/GStrLib.h:  regenerated.
	* gm2/mc-boot/GStringConvert.h:  regenerated.
	* gm2/mc-boot/GSysExceptions.h:  regenerated.
	* gm2/mc-boot/GSysStorage.h:  regenerated.
	* gm2/mc-boot/GTimeString.h:  regenerated.
	* gm2/mc-boot/GUnixArgs.h:  regenerated.
	* gm2/mc-boot/Galists.h:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/Gdtoa.h:  regenerated.
	* gm2/mc-boot/Gerrno.h:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Gldtoa.h:  regenerated.
	* gm2/mc-boot/Glibc.h:  regenerated.
	* gm2/mc-boot/Glibm.h:  regenerated.
	* gm2/mc-boot/Glists.h:  regenerated.
	* gm2/mc-boot/GmcComp.h:  regenerated.
	* gm2/mc-boot/GmcDebug.h:  regenerated.
	* gm2/mc-boot/GmcError.h:  regenerated.
	* gm2/mc-boot/GmcFileName.h:  regenerated.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated.
	* gm2/mc-boot/GmcMetaError.h:  regenerated.
	* gm2/mc-boot/GmcOptions.h:  regenerated.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated.
	* gm2/mc-boot/GmcPretty.h:  regenerated.
	* gm2/mc-boot/GmcPrintf.h:  regenerated.
	* gm2/mc-boot/GmcQuiet.h:  regenerated.
	* gm2/mc-boot/GmcReserved.h:  regenerated.
	* gm2/mc-boot/GmcSearch.h:  regenerated.
	* gm2/mc-boot/GmcStack.h:  regenerated.
	* gm2/mc-boot/GmcStream.h:  regenerated.
	* gm2/mc-boot/Gmcflex.h:  regenerated.
	* gm2/mc-boot/Gmcp1.h:  regenerated.
	* gm2/mc-boot/Gmcp2.h:  regenerated.
	* gm2/mc-boot/Gmcp3.h:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp4.h:  regenerated.
	* gm2/mc-boot/Gmcp5.h:  regenerated.
	* gm2/mc-boot/GnameKey.h:  regenerated.
	* gm2/mc-boot/Gpth.h:  regenerated.
	* gm2/mc-boot/GsymbolKey.h:  regenerated.
	* gm2/mc-boot/Gtermios.h:  regenerated.
	* gm2/mc-boot/Gvarargs.h:  regenerated.
	* gm2/mc-boot/Gwlists.h:  regenerated.
	* gm2/mc-boot/Gwrapc.h:  regenerated.

2017-01-09      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  new rule to build mcComment.mod
	* gm2/bnf/mc-1.bnf:  import and call setProcedureComment.
	* gm2/init/mcinit:  mcComment added.
	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GArgs.h:  regenerated.
	* gm2/mc-boot/GAssertion.c:  regenerated.
	* gm2/mc-boot/GAssertion.h:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GCmdArgs.h:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDebug.h:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated.
	* gm2/mc-boot/GEnvironment.c:  regenerated.
	* gm2/mc-boot/GEnvironment.h:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFIO.h:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.h:  regenerated.
	* gm2/mc-boot/GFpuIO.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIO.h:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GIndexing.h:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GM2RTS.h:  regenerated.
	* gm2/mc-boot/GMemUtils.c:  regenerated.
	* gm2/mc-boot/GMemUtils.h:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.h:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.h:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GRTint.h:  regenerated.
	* gm2/mc-boot/GSArgs.c:  regenerated.
	* gm2/mc-boot/GSArgs.h:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/GSFIO.h:  regenerated.
	* gm2/mc-boot/GSYSTEM.h:  regenerated.
	* gm2/mc-boot/GSelective.h:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStdIO.h:  regenerated.
	* gm2/mc-boot/GStorage.h:  regenerated.
	* gm2/mc-boot/GStrCase.c:  regenerated.
	* gm2/mc-boot/GStrCase.h:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStrIO.h:  regenerated.
	* gm2/mc-boot/GStrLib.c:  regenerated.
	* gm2/mc-boot/GStrLib.h:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GStringConvert.h:  regenerated.
	* gm2/mc-boot/GSysStorage.c:  regenerated.
	* gm2/mc-boot/GSysStorage.h:  regenerated.
	* gm2/mc-boot/GTimeString.c:  regenerated.
	* gm2/mc-boot/GTimeString.h:  regenerated.
	* gm2/mc-boot/Galists.c:  regenerated.
	* gm2/mc-boot/Galists.h:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/Gdtoa.h:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Gldtoa.h:  regenerated.
	* gm2/mc-boot/Glibc.h:  regenerated.
	* gm2/mc-boot/Glists.c:  regenerated.
	* gm2/mc-boot/Glists.h:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcComp.h:  regenerated.
	* gm2/mc-boot/GmcDebug.c:  regenerated.
	* gm2/mc-boot/GmcDebug.h:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcError.h:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcFileName.h:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcOptions.h:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPretty.h:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.h:  regenerated.
	* gm2/mc-boot/GmcReserved.c:  regenerated.
	* gm2/mc-boot/GmcReserved.h:  regenerated.
	* gm2/mc-boot/GmcSearch.c:  regenerated.
	* gm2/mc-boot/GmcSearch.h:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStack.h:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/GmcStream.h:  regenerated.
	* gm2/mc-boot/Gmcflex.h:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp1.h:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp2.h:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp3.h:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp4.h:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/Gmcp5.h:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GnameKey.h:  regenerated.
	* gm2/mc-boot/GsymbolKey.c:  regenerated.
	* gm2/mc-boot/GsymbolKey.h:  regenerated.
	* gm2/mc-boot/Gtermios.h:  regenerated.
	* gm2/mc-boot/Gtop.c:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gvarargs.h:  regenerated.
	* gm2/mc-boot/Gwlists.c:  regenerated.
	* gm2/mc-boot/Gwlists.h:  regenerated.
	* gm2/mc-boot/Gwrapc.h:  regenerated.
	* gm2/mc/decl.def:  (putCommentDefProcedure) new procedure.
          (putCommentModProcedure) new procedure.
	* gm2/mc/decl.mod:  (doFuncParamC) correct bug by calling doCast.
          Add code to emit procedure heading comments for definition
          module and implementation/program modules.  (doProcedureComment)
          new procedure.  (doProcedureCommentText) new procedure.
          doParamC emit unbounded parameter for a proctype.
          (putCommentModProcedure) new procedure.  (putCommentDefProcedure)
          new procedure.  (makeProcedure)  initialises new fields
          defComment and modComment.  (procedureT) contains new
	  fields defComment and modComment.
	* gm2/mc/keyc.mod:  sin, cos, tan, main are all reserved function
	  names.
	* gm2/mc/mc.flex:  endOfComment call mcComment_endComment.
	  Updated to save the contents of a comment in mcComment.
	* gm2/mc/mcComp.mod:  call mcComment.newPass at the start of
	  a new pass.
	* gm2/mc/mcLexBuf.mod:  getToken modfied to call doGetToken until
          a commenttok is not seen.  doGetToken (New procedure) implemented
	  by using the old getToken.
	* gm2/mc/mcReserved.def:  added new token commenttok.
	* gm2/mc/mcReserved.h:  added new token commenttok.

2017-01-03      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/keyc.mod:  added main to the list of names to avoid.
	* gm2/Make-lang.in:  change sed commands for malloc/realloc to
	include preceeding space.
	* gm2/Make-lang.in:  call gm2_genericize for each function as it
	is ended.
	* gm2/gm2-lang.c:  gm2_genercize (New function).
	* gm2/gm2-lang.h:  gm2_genercize (New prototype).
	* gm2/mc/decl.mod:  bugfix for high field passed as a parameter
	  into another dynamic array.

2017-01-01      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2statement.c:  fixed nested procedure bug, use
          cgraph_node::get_create rather than cgraph_node::create.

2016-12-31      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2builtins.c:  removed trailing spaces.  define_builtin
          (New procedure).  m2builtins_init use define_builtin to define
          internal (gimple) builtin BUILT_IN_TRAP.
	* gm2/gm2-gcc/m2except.c:  reformatted slightly.  Bugfix to do_throw
          to ensure that gm2_eh_int_type which is declared globally is
          unshared for each and every use.
	* gm2/gm2-gcc/m2expr.c:  corrected dates and removed trailing space.
	* gm2/gm2-gcc/m2statement.c:  Bugfix to allow nested functions to
          compile.  If a nested function is complete create a cgraph_node
	  (and it will be finalized later), else finalize_function now.
	* gm2/gm2builtins.c:  file changed (it is unused and will be purged).
	* gm2/gm2except.c:  file changed (it is unused and will be purged).

2016-12-29      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2Code.mod:  remove spaces and use StartGlobalContext
          and EndGlobalContext instead of InitGlobalContext.
	* gm2/gm2-gcc/m2top.c:  implement dummy procedures StartGlobalContext
          and EndGlobalContext.
	* gm2/gm2-gcc/m2top.def:  declare StartGlobalContext and
	  EndGlobalContext.
	* gm2/gm2-gcc/m2top.h:  declare StartGlobalContext and EndGlobalContext
          in the header.
	* gm2/gm2-lang.c:  (gm2_langhook_write_globals)  write all global
	  declarations and call finalize_compilation_unit.

2016-12-24      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.def:  GetHighFromUnbounded add location
          as the first parameter.
	* gm2/gm2-compiler/M2GenGCC.mod:  removed all forward declarations.
          Changed AddStatement to include a location first parameter.
          Change GetHighFromUnbounded to include a location first parameter.
          Change GetParamAddress to include a location first parameter.
          Change GetAddressOfUnbounded to include a location first parameter.
          Change BuildComponentRef to include a location first parameter.
          Removed commented code.
	* gm2/gm2-compiler/M2Range.mod:  changed all calls to the above
          to include the location parameter.
	* gm2-gcc/m2type.def:  changed AddStatement to include a location
	  first parameter.

2016-12-23      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2statement.c:  remove make_decl_rtl and use
          allocate_struct_function instead, assign DECL_SAVED_TREE (fndecl)
          to NULL_TREE.  Fixes to allow functions to be declared.
	* gm2/mc-boot/GStrIO.c:  rebuilt.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  noIfElseChained (New procedure).  hasIfAndNoElse
	  use noIfElseChained to detect another dangling else bug.

2016-12-19      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  build and link gm2l, gm2lcc using g++.
	* gm2/gm2-lang.c:  updated to reflect gcc-5.2.0 garbage collection
          of trees.
	* gm2/gm2-lang.h:  removed garbage collection info (moved into
          gm2-lang.c).
	* gm2/Make-lang.in:  add MC_LIBS to the library list when linking
          gm2l, gm2lcc, gm2lgen, gm2lorder and gm2m.
	* gm2/gm2-gcc/gcc-consolidation.h:  add conditional compilation
          to stop inclusion of gcc compiler internals if we are building
          a gm2tool program.
	* gm2/Make-lang.in:  remove h2def from being built.

2016-12-18      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  create MC_LIBS and use them during link of
          cc1gm2.
 	* gm2/gm2-gcc/m2linemap.c:  use C style link symbols and correct
          prototype for StartFile.  Cast to char *.
	* gm2/gm2-gcc/m2linemap.h:  use __cplusplus rather than __GNUG__.
          move #include before defining EXTERN.
	* gm2/gm2-lang.c:  whitespace removal.
	* gm2/gm2-libs-ch/ldtoa.c:  removed #if surrounding _M2_ldtoa_init
          and _M2_ldtoa_finish.
	* gm2/m2.flex:  fixed to ensure external symbols are using C style.
          Use %option nounput to remove compiler warning.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  bugfix, ensure that variables are declared as extern
	  when we are using getExtendedOpaque and if the variable is external.

2016-12-17      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  fixed bug regarding the expression type of an
          indirect funccall.  mc now builds all gm2 modules.

2016-12-16      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  M2GCCDeclare.o dedicated rule.  mc-clean,
	  mc-maintainer mc-continue rules improved.
	* gm2/bnf/h2def.bnf:  removed usused import.
	* gm2/gm2-compiler/M2Base.mod:  remove unused global variables
	  and fixed typo (FloatS not SFloat).
	* gm2/gm2-compiler/M2GCCDeclare.mod:  changed none to norule.
	* gm2/gm2-compiler/P3SymBuild.mod:  remove unused local variables.
	* gm2/gm2-compiler/bnflex.mod:  EatChar new procedure.  Remove many
	  unused variables by using EatChar rather than ch := GetChar ().
	* gm2/mc-boot/Gdecl.c:
	* gm2/mc-boot/Gkeyc.c:
	* gm2/mc/decl.def:
	* gm2/mc/decl.mod:  write out subrange type, detect type address
          when emitting casts.  Work out arrayref type when more than
	  one dimension is used.
	* gm2/mc/keyc.mod:  avoid C++ keywords operator and complex.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  detect an variable of an enumeration
          type in the INC/DEC.  Ensure that arrays can only be
	  complete if the type of the array has been emitted.

2016-12-14      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  build cflex.c using the same rules as the
          m2flex.c.
	* gm2/c.flex:  include gm2-gcc/gcc-consolidation.h and use
          %option nounput to get a clean compilation with no warnings.
	  Declare linelen as unsigned int to avoid warnings.

2016-12-14      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  changed flags when compiling cflex.c and
          M2Version.c
	* gm2/bnf/gm2l.bnf:  removed unused variable.  (SyntaxCheck)
          Removed unused variable.
	* gm2/gm2-compiler/M2DebugStack.mod:  (doNameLength) remove
          unused variable.  (doMaxInt) remove unused procedure function.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc/decl.mod:  detect bitset in MAX/MIN and return ztype.
	  Add bitnumN to the list of completed types.

2016-12-12      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  changed scaffold building rules
	  to use g++.
	* gm2/gm2-libs-ch/SysExceptions.c:  regenerated.
	* gm2/init/ppginit:  regenerated.
	* gm2/mc-boot-ch/Gmcrts.c:  regenerated.
	* gm2/mc-boot-ch/Gmcrts.h:  regenerated.
	* gm2/mc-boot/GASCII.h:  regenerated.
	* gm2/mc-boot/GArgs.h:  regenerated.
	* gm2/mc-boot/GAssertion.h:  regenerated.
	* gm2/mc-boot/GBreak.h:  regenerated.
	* gm2/mc-boot/GCOROUTINES.h:  regenerated.
	* gm2/mc-boot/GCmdArgs.h:  regenerated.
	* gm2/mc-boot/GDebug.h:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.h:  regenerated.
	* gm2/mc-boot/GEnvironment.h:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFIO.h:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.h:  regenerated.
	* gm2/mc-boot/GFpuIO.h:  regenerated.
	* gm2/mc-boot/GIO.h:  regenerated.
	* gm2/mc-boot/GIndexing.h:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.h:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GM2RTS.h:  regenerated.
	* gm2/mc-boot/GMemUtils.h:  regenerated.
	* gm2/mc-boot/GNumberIO.h:  regenerated.
	* gm2/mc-boot/GPushBackInput.h:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.h:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GRTint.h:  regenerated.
	* gm2/mc-boot/GSArgs.h:  regenerated.
	* gm2/mc-boot/GSFIO.h:  regenerated.
	* gm2/mc-boot/GSYSTEM.h:  regenerated.
	* gm2/mc-boot/GSelective.h:  regenerated.
	* gm2/mc-boot/GStdIO.h:  regenerated.
	* gm2/mc-boot/GStorage.h:  regenerated.
	* gm2/mc-boot/GStrCase.h:  regenerated.
	* gm2/mc-boot/GStrIO.h:  regenerated.
	* gm2/mc-boot/GStrLib.h:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GStringConvert.h:  regenerated.
	* gm2/mc-boot/GSysExceptions.h:  regenerated.
	* gm2/mc-boot/GSysStorage.h:  regenerated.
	* gm2/mc-boot/GTimeString.h:  regenerated.
	* gm2/mc-boot/GUnixArgs.h:  regenerated.
	* gm2/mc-boot/Galists.h:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gdecl.h:  regenerated.
	* gm2/mc-boot/Gdtoa.h:  regenerated.
	* gm2/mc-boot/Gerrno.h:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Gldtoa.h:  regenerated.
	* gm2/mc-boot/Glibc.h:  regenerated.
	* gm2/mc-boot/Glibm.h:  regenerated.
	* gm2/mc-boot/Glists.h:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcComp.h:  regenerated.
	* gm2/mc-boot/GmcDebug.h:  regenerated.
	* gm2/mc-boot/GmcError.h:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcFileName.h:  regenerated.
	* gm2/mc-boot/GmcLexBuf.h:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcMetaError.h:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcOptions.h:  regenerated.
	* gm2/mc-boot/GmcPreprocess.h:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPretty.h:  regenerated.
	* gm2/mc-boot/GmcPrintf.h:  regenerated.
	* gm2/mc-boot/GmcQuiet.h:  regenerated.
	* gm2/mc-boot/GmcReserved.h:  regenerated.
	* gm2/mc-boot/GmcSearch.h:  regenerated.
	* gm2/mc-boot/GmcStack.h:  regenerated.
	* gm2/mc-boot/GmcStream.h:  regenerated.
	* gm2/mc-boot/Gmcflex.h:  regenerated.
	* gm2/mc-boot/Gmcp1.h:  regenerated.
	* gm2/mc-boot/Gmcp2.h:  regenerated.
	* gm2/mc-boot/Gmcp3.h:  regenerated.
	* gm2/mc-boot/Gmcp4.h:  regenerated.
	* gm2/mc-boot/Gmcp5.h:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GnameKey.h:  regenerated.
	* gm2/mc-boot/Gpth.h:  regenerated.
	* gm2/mc-boot/GsymbolKey.h:  regenerated.
	* gm2/mc-boot/Gtermios.h:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gvarargs.h:  regenerated.
	* gm2/mc-boot/Gwlists.h:  regenerated.
	* gm2/mc-boot/Gwrapc.h:  regenerated.
	* gm2/mc/decl.mod:  change all external declarations as being
	  C declarations to provide linkage compatibility with C/M2.
	* gm2/tools-src/mklink.c:  allow the scaffold to be compiled
          with g++.
	* gm2/Make-lang.in:  MC_ARGS no longer include gm2/mc.  Use
          COMPILER rather than CC to compile gm2 related sources.
	  m2link uses --g++ on compiler related scaffolds.
	* gm2/c.flex:  remove reference to p2c.
	* gm2/gm2-compiler/ppg.mod:  increase MaxCodeHunkLength.
	* gm2/mc-boot-ch/GSYSTEM.c:  implement _finish function.
	* gm2/mc-boot-ch/Gerrno.c:  implement _finish function.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc-boot/Gkeyc.c:  rebuilt.
	* gm2/mc/decl.mod:  detect and handle dangling else in an ELSIF.
	* gm2/mc/keyc.mod:  add try, catch and operator to the list of
	  unusable keywords.
	* gm2/tools-src/mklink.c:  New procedure (GenerateInitCalls),
          new procedure (GenerateFinishCalls) and new procedure
	  (GeneratePrototypes).

2016-12-06      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc/decl.mod:  fix bug in dangling else.
	* gm2/tools-src/mklink.c:  allow the link to occur with g++ and gcc.

2016-12-06      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  improved verify rule.
	* gm2/bnf/mc-2.bnf:  fixed bug declaring variables of an enumerated type.
	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GEnvironment.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GSArgs.c:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStorage.c:  regenerated.
	* gm2/mc-boot/GStrCase.c:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStrLib.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GSysStorage.c:  regenerated.
	* gm2/mc-boot/Galists.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Glists.c:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcSearch.c:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GsymbolKey.c:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gwlists.c:  regenerated.
	* gm2/mc/decl.mod:  fixed bugs in variables of enumerated type,
          multi-dimensional arrays and introduced runtime case
	  and return checking.

2016-12-02      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  changed rules to include mc-boot-ch.
	* gm2/mc-boot-ch/Gmcrts.c:  regenerated.
	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GEnvironment.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* gm2/mc-boot/GM2RTS.c:  regenerated.
	* gm2/mc-boot/GPushBackInput.c:  regenerated.
	* gm2/mc-boot/GRTExceptions.c:  regenerated.
	* gm2/mc-boot/GRTint.c:  regenerated.
	* gm2/mc-boot/GSArgs.c:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/GStdIO.c:  regenerated.
	* gm2/mc-boot/GStorage.c:  regenerated.
	* gm2/mc-boot/GStrCase.c:  regenerated.
	* gm2/mc-boot/GStrIO.c:  regenerated.
	* gm2/mc-boot/GStrLib.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/GSysStorage.c:  regenerated.
	* gm2/mc-boot/Galists.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/Gkeyc.c:  regenerated.
	* gm2/mc-boot/Gkeyc.h:  regenerated.
	* gm2/mc-boot/Glists.c:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcFileName.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcMetaError.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPretty.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcSearch.c:  regenerated.
	* gm2/mc-boot/GmcStack.c:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc-boot/GsymbolKey.c:  regenerated.
	* gm2/mc-boot/Gvarargs.c:  regenerated.
	* gm2/mc-boot/Gwlists.c:  regenerated.
	* gm2/mc/decl.mod:  introduced runtime checking
	  for missing RETURN statements.
	* gm2/mc/keyc.def:  allow "Gmcrts.h" to be included.
	* gm2/mc/keyc.mod:  include "Gmcrts.h" if required.

2016-11-30      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GIO.c:  regenerated.
	* gm2/mc-boot/GSFIO.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/GmcError.c:  regenerated.
	* gm2/mc-boot/GmcLexBuf.c:  regenerated.
	* gm2/mc-boot/GmcPreprocess.c:  regenerated.
	* gm2/mc-boot/GmcPrintf.c:  regenerated.
	* gm2/mc-boot/GmcStream.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc/decl.mod:  change empty statements from
	; to {} to avoid gcc compiler warning.  Fix parameter
	type cast for C++ parameter passing to type ADDRESS
	and other system types.

2016-11-29      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/GCmdArgs.c:  regenerated.
	* gm2/mc-boot/GDebug.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GDynamicStrings.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/GFormatStrings.c:  regenerated.
	* gm2/mc-boot/GIndexing.c:  regenerated.
	* gm2/mc-boot/GStringConvert.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc-boot/GmcComp.c:  regenerated.
	* gm2/mc-boot/GmcOptions.c:  regenerated.
	* gm2/mc-boot/Gmcp1.c:  regenerated.
	* gm2/mc-boot/Gmcp2.c:  regenerated.
	* gm2/mc-boot/Gmcp3.c:  regenerated.
	* gm2/mc-boot/Gmcp4.c:  regenerated.
	* gm2/mc-boot/Gmcp5.c:  regenerated.
	* gm2/mc-boot/GnameKey.c:  regenerated.
	* gm2/mc/decl.mod:  (noIfElse)  New procedure function.  (hasIfElse)
          New procedure function.  (doIfC)  changed to issue braces to avoid
          a gcc warning.
	* gm2/mc-boot-ch:  New directory and files containing handbuilt
	  C and header files.

2016-11-24      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  updated rules to build handbuilt modules to use
	  new path.  Attempt to build compiler using mc.
	* gm2/bnf/mc-3.bnf:  use putOptReturn rather than
	  putProcTypeOptReturn.
	* gm2/bnf/mc-4.bnf:  use putOptReturn rather than
	  putProcTypeOptReturn.
	* gm2/bnf/mc-5.bnf:  use putOptReturn rather than
	  putProcTypeOptReturn.
	* gm2/gm2-libs-ch/SysExceptions.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs-ch/dtoa.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs-ch/errno.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs-ch/ldtoa.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs-ch/termios.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs-ch/wrapc.c:  use header file gm2-libs-host.h.
	* gm2/gm2-libs/libc.def:  removed white space.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc-boot/Gdecl.h:  rebuilt.
	* gm2/mc-boot/Gkeyc.c:  rebuilt.
	* gm2/mc-boot/Gkeyc.h:  rebuilt.
	* gm2/mc-boot/Gmcp3.c:  rebuilt.
	* gm2/mc-boot/GsymbolKey.c:  rebuilt.
	* gm2/mc-boot/Gwlists.c:  rebuilt.
	* gm2/mc-boot/Gwlists.h:  rebuilt.
	* gm2/mc/decl.def:  replace putProcTypeOptReturn with putReturnType.
	  New procedure putOptReturn.
	* gm2/mc/decl.mod:  implement putReturnType and putOptReturn.
          Fix bug in parameter declaration to use safe C names.
	  Also ensure that all variables are also safe from C names.
	* gm2/mc/keyc.def:  cnamen (New procedure function).  cp
	  (New procedure).
	* gm2/mc/keyc.mod:  implement cnamen (New procedure function).  cp
	  (New procedure).
	* gm2/mc/symbolKey.mod:  getSymKey returns NulKey if the tree is NIL.
	* gm2/mc/wlists.def:  replaceItemInList (New procedure).
	* gm2/mc/wlists.mod:  implement replaceItemInList.

2016-11-16      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  New rules (mc-clean-libs) (mc-test)
          and (mc-help).
	* gm2/mc/decl.mod:  doInc, doDec, doIncDecCP (New procedures)
          which fix the pointer arithmetic in INC/DEC for C++.
	* gm2/mc-boot:  regenerated.

2016-11-15      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  changes to mc rules so we use less
	  aggresive warning options for g++.
	* gm2/mc/decl.mod:  changes to the cpp backend to
	  implement casts.
	* gm2/mc-boot/GArgs.c:  regenerated.
	* gm2/mc-boot/GFIO.c:  regenerated.
	* gm2/mc-boot/Gdecl.c:  regenerated.

2016-11-11      Gaius Mulley <gaius@gnu.org>

	* updates for the shared library example pge.
	* gm2/examples/pge/Fractions.mod:  removed unnecessary spaces.
	* gm2/examples/pge/history.def:  major changes to history of collision.
	* gm2/examples/pge/history.mod:  major changes to history of collision.
	* gm2/examples/pge/roots.def:  new procedure function nearCoord.
	* gm2/examples/pge/roots.mod:  new procedure function nearCoord.
	* gm2/examples/pge/twoDsim.mod:  huge changes to include interpenetration
          testing.

2016-11-02      Gaius Mulley <gaius@gnu.org>

	* gm2/mc-boot/Gdecl.c:  regenerated.
	* gm2/mc/decl.mod:  generate a static_cast.  This fixes a
	  bug in the translation of Args.mod.

2016-11-01      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-gcc/m2linemap.h:  changed prototype of StartFile to
          use void * rather than char *.
	* gm2/m2.flex:  do not include p2c/p2c.h and m2linemap.h.

2016-10-20      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/MemStream.mod:  many changes and bug fixes to
	  shared library example.
	* gm2/examples/pge/MemStream.mod:  ditto.
	* gm2/examples/pge/NetworkOrder.mod:  ditto.
	* gm2/examples/pge/deviceIf.mod:  ditto.
	* gm2/examples/pge/examples/triangle.py:  ditto.
	* gm2/examples/pge/history.def:  ditto.
	* gm2/examples/pge/history.mod:  ditto.
	* gm2/examples/pge/pgeif.def:  ditto.
	* gm2/examples/pge/pgeif.mod:  ditto.
	* gm2/examples/pge/roots.def:  ditto.
	* gm2/examples/pge/roots.mod:  ditto.
	* gm2/examples/pge/twoDsim.def:  ditto.
	* gm2/examples/pge/twoDsim.mod:  ditto.
	* gm2/examples/pge/buffers.c:  ditto.
	* gm2/examples/pge/max2code.py:  fixed options.
	* gm2/examples/pge/mxmmaxima.py:  removed debugging trace.
	* gm2/examples/pge/mxmparser.py:  removed debugging trace.
	* gm2/examples/pge/mxmtree.py:  removed debugging trace.
	* gm2/examples/pge/pge.py:  huge number of changes.
	* gm2/examples/pge/pgeif.i:  changes to the python interface.
	* gm2/examples/pge/pgeplayback.py:  many bug fixes to allow
          single stepping.
	* gm2/examples/pge/pgepygame.py:  minor changes and removal
	  of spacing.

2016-10-03      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  instruct mc to generate g++ compilient C code.
	* gm2/gm2-gcc/m2treelib.def:  remove multiple definition of
          get_set_field_rhs and import ADDRESS.
	* gm2/gm2.texi:  trimmed spaces.
	* gm2/m2.flex:  use __attribute__((unused)) in init/finish
	functions.
	* gm2/mc-boot:  rebuilt.
	* gm2/mc/decl.mod:  handle C char.  Strings of 1 character
          are encoded as C strings and also C chars.  (checkPtr)
          New procedure function.  (doExprCastC)  New procedure
          function.  init/finish functions all use __attribute__((unused)).
          (outCP) removed.
	* gm2/mc/mcOptions.mod:  fixed bug by rearranging order of option
	  processing.

2016-09-20      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removed all references to p2c.
          Use mc to build gm2 rather than p2c and replaced
          rules.  Also modified the list of the library modules
          required during bootstrapping gm2.  Many changes
	to all bootstrap rules.
	* gm2/gm2-libs-boot/SYSTEM.def:  removed file.
	* gm2/mc-boot/GAssertion.c:  rebuilt.
	* gm2/mc-boot/GDebug.c:  rebuilt.
	* gm2/mc-boot/GDynamicStrings.c:  rebuilt.
	* gm2/mc-boot/GDynamicStrings.c:  rebuilt.
	* gm2/mc-boot/GFIO.c:  rebuilt.
	* gm2/mc-boot/GFormatStrings.c:  rebuilt.
	* gm2/mc-boot/GIndexing.c:  rebuilt.
	* gm2/mc-boot/GNumberIO.c:  rebuilt.
	* gm2/mc-boot/GStdIO.c:  rebuilt.
	* gm2/mc-boot/Gdecl.c:  rebuilt.
	* gm2/mc-boot/Gkeyc.c:  rebuilt.
	* gm2/mc-boot/GmcComp.c:  rebuilt.
	* gm2/mc-boot/GmcError.c:  rebuilt.
	* gm2/mc-boot/GmcLexBuf.c:  rebuilt.
	* gm2/mc-boot/GmcMetaError.c:  rebuilt.
	* gm2/mc-boot/GmcPreprocess.c:  rebuilt.
	* gm2/mc-boot/GmcPrintf.c:  rebuilt.
	* gm2/mc-boot/GmcStack.c:  rebuilt.
	* gm2/mc-boot/GmcStream.c:  rebuilt.
	* gm2/mc-boot/Gmcp1.c:  rebuilt.
	* gm2/mc-boot/Gmcp2.c:  rebuilt.
	* gm2/mc-boot/Gmcp3.c:  rebuilt.
	* gm2/mc-boot/Gmcp4.c:  rebuilt.
	* gm2/mc-boot/Gmcp5.c:  rebuilt.
	* gm2/mc-boot/GnameKey.c:  rebuilt.
	* gm2/mc-boot/Gvarargs.c:  rebuilt.
	* gm2/mc/Indexing.mod:  added assert.
	* gm2/mc/decl.mod:  fixed bug to allow comparison
	  of proctypes.
	* gm2/mc/mcMetaError.mod:  fixed bug to allow nameless
	  symbols to unalter the error string.

2016-09-19      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  many new rules to deal with the
          bootstrapping of mc.
	* gm2/bnf/mc-3.bnf:  removed unnecessary imports.
	* gm2/bnf/mc-4.bnf:  implement NOT.
	* gm2/bnf/mc-5.bnf:  implement NOT and final body.

2016-09-05      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removal of Indexing.mod from
          the list of library files as it is included in the
          project files.  Many new rules to build the bootstrap
          version of mc.
	* gm2/gm2-libs-ch/Selective.c:  tidied up spacing.
	* gm2/gm2-libs-ch/UnixArgs.c:  tidied up spacing.
	* gm2/gm2-libs-ch/wrapc.c:  tidied up spacing.
	* gm2/mc-boot/libc.c:  deleted file.
	* gm2/mc-boot/Glibc.c:  new file.
	* gm2/mc-boot/GSelective.c:  new file.
	* gm2/mc-boot/Gmcrts.c:  new file.

2016-09-03      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  tidied up spacing.
	* gm2/bnf/mc-1.bnf:  handle DEFINITION FOR "C".
	* gm2/mc/decl.def:  (putDefForC)  New procedure.
	* gm2/mc/decl.mod:  (putDefForC)  New procedure
          implemented.  (isDefForC)  New procedure function.
          (doIncludeC)  include mc-<module>.h for DEFINITION
          FOR "C".  Do not qualify names if they were defined
          in DEFINITION FOR "C" modules.  Also disable high
          parameter.  Disabled handling of DEFINITION FOR "C".
	* gm2/mc/keyc.mod:  added write, read, exit, abs,
	  optarg, div to the list of names to avoid.

2016-09-02      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  (out1) use safe type conversion
          from pointer into cardinal.  (gen) use safe type
          conversion from pointer into cardinal.
          (topologicallyOut) use populateTodo to ensure that
          all enumeration and constants are declared prior to
          the datatypes which depend upon them.  (dbgSubrange)
	  New procedure.

2016-08-31      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  extra space introduced.
	* gm2/mc/decl.mod:  detect cyclic dependancy problem and
          issue appropriate error message and abort translation.
	* gm2/Make-lang.in:  specific rule to build
          gm2/mc-boot/$(SRC_PREFIX)decl.c
	* gm2/mc/decl.mod:  (doEnumerationField) use doFQDNameC
          instead of doFQNameC.  (doRecordNameC) New procedure.
          (doTypeNameC) use doRecordNameC.  (doPrototypeC) only
	  generate the prototype if the	procedure is not exported.
          (runIncludeDefConstType)  New procedure.
          (foreachModuleDo)  New procedure.  (walkArray) also walk
          the subr field.  (runSimplifyTypes)  New procedure.
          (runPrototypeExported)  New procedure.  (runPrototypeDefC)
          New procedure.  (outImpC) rewritten to fix bugs if
	  getExtendedOpaque was used.

2016-08-27      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  add cname field to enumerationfield.
          (makeEnumerationField)  Initialise cname field.
          (getFQDstring)  New procedure function.
          (doEnumC) use doFQDNameC.  (doFQDNameC)  New procedure
          function.  (topologicallyOut)  add debugging information.
	  57 out of 58 mc modules translate.

2016-08-25      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-3.bnf:  process enumeration types and fields
          (as per pass 2).
	* gm2/mc/decl.mod:  (getNextEnum) assert enumerationField
          or enumeration type is returned.  (doLiteralC) detect
          and handle octal integer literals.
          (isStatementSequenceEmpty)  New procedure function.
          (isSingleStatement) rewritten and bug fixed.
          (containsStatement)  New procedure function.
          (noElse)  handle dangling else.  Also ignore empty
          else statements.  (doNewC)  use ALLOCATE rather than
          malloc.  (doFreeC)  use DEALLOCATE rather than free.
          (needsCast)  returns FALSE if C base types are the same.
	* gm2/mc/keyc.def:  (useStorage)  New procedure function.
	* gm2/mc/keyc.mod:  (useStorage)  Implement new procedure
          function.  (checkStorage) New procedure.  (genDefs)
	  call checkStorage.

2016-08-23      Gaius Mulley <gaius@gnu.org>

	* gm2/el/g-mode.el:  updated dates and also introduced
          dialect comment after the module name.  Currently
          hard wired to (*!m2pim*).
	* gm2/mc/decl.def:  added dialect comment.
	* gm2/mc/decl.mod:  added dialect comment.  Fixed bug in
          case statements which use ranges.
          Self translation of 54 of the 58 modules occur.
	* gm2/mc/decl.mod:  introduce cnameT for declarations
          which might conflict with C keywords.  Currently only
	  record fields use cnames.  55 of the 58 module translate.

2016-08-19      Gaius Mulley <gaius@gnu.org>

	* gcc/gm2/Make-lang.in:  included mcStream.def and
          mcStream.mod to be compiled and linked to produce mc.
	* gm2/init/mcinit:  updated link and init list to include
          mcStream.
	* gm2/mc/decl.mod:  many, many bug fixes which now allow
	  self translation of 53 of the 58 modules.

2016-08-16      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added mcStream.def and mcStream.mod
	  to the build list for mc.

2016-08-16      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added wrapc.def pth.def COROUTINES.def
          Selective.def termios.def to be translated by mc as part
          of mc-autogen.  Added rules to translate iso libraries
	  from M2 to C using mc.
	* gm2/mc/decl.mod:  added halt node.  (doEscape) New procedure
          function.  (doStringC) add escape to the escape character if
          inside a string literal.  (addExported) corrected test prior
          to addToDo.  (includeDefVarProcedure)  include variables and
          types symbols if they are defined in definition modules.
          (doFuncUnbounded) include cast for parameter and use
          doFQNameC for the parameter name rather than call doExprC
          since doExprC will dereference a VAR paramater and we must
          pass it as declared.  (doAdrExprC)  New procedure function
          which is used to catch & (*p) and simply it to (p).  (doHalt)
	  New procedure.

2016-08-05      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  translate autogenerated modules without
	  the --extended-opaque option.
	* gm2/mc/decl.mod:  many changes which include the ability to
          visit all nodes and their dependents calling a call back
	  procedure.

2016-08-01      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  introduce rules to build new module keyc.
          New rules to attempt to build the C generated version of mc.
	* gm2/init/mcinit:  added keyc to the list of modules to be
          linked.
	* gm2/mc/decl.mod:  changed skipType to detect an opaque type
          and not skip to NIL if this is the case.  outNull, outTrue,
          outFalse, (New procedures).  doArrayC fixed bug in declaring
          static arrays.  doFuncUnbounded changed parameter names and
          fixed a static array being passed to an unbounded parameter.
          getNthParam (New procedure function).
	* gm2/mc/keyc.def:  New file.
	* gm2/mc/keyc.mod:  New file.

2016-07-25      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  removed SYSTEM.mod from the list of
	  modules to be converted by mc.
	* gm2/bnf/mc-3.bnf:  ConstExpression pushes a makeConstExp.
	* gm2/bnf/mc-4.bnf:  ConstExpression gets a constexp.
	  Reset constexp index for every new file.
          ConstSetOrQualidentOrFunction
          many asserts added and production statement order bug fixed.
          ConstActualParameters added assert.
	* gm2/bnf/mc-5.bnf:  implement LOOP END.  Fix bugs in the
	  construction of set values.
	* gm2/mc/decl.def:  makeExit, isExit, makeLoop, isLoop
	  (New procedure functions).
	* gm2/mc/decl.mod:  generate accurate error messages based
          on node declaration position.  Implement FLOAT and TRUNC.
          Fix MAX (enum) and MIN (enum).  Allow + to join two strings.
          Bugfix for pointer ref, deref combinations.  Fix type
          in makeArrayRef.  THROW implemented.  Fix string escape
          sequences.  Fix MAX/MIN (LONGINT/LONGCARD).  Fix ADR
          to spot & * cancel each other.  doExceptionC generate
	  line/file/column location from the node declaration.

2016-07-18      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-5.bnf:  duplicate the with expression before
          calling makeCompenentRef.  SubPointer (New production).
          CaseStatement (New production).  Case (New production).
          CaseLabelList (New production).  CaseLabels
	  (New production).
	* gm2/mc/decl.def:  makePointerRef (New procedure
          function).  isPointerRef (New procedure function).
          getLastOp (New procedure function).
          makeCase (New procedure function).
          isCase (New procedure function).
          putCaseExpression (New procedure function).
          makeCaseLabelList (New procedure function).
          isCaseLabelList (New procedure function).
          makeCaseList (New procedure function).
          isCaseList (New procedure function).
          putCaseRange (New procedure function).
          makeRange (New procedure function).
          isRange (New procedure function).
          dupExpr (New procedure function).
	* gm2/mc/decl.mod:  implement above.
          Case statements implemented.  With statements bug fixed
          by duplicating the with expression.  pointerref
          introduced and componentref is replaced by pointerref
          if it is preceeded by a deref.  Polymorphic + - / * binary
	  operators are implemented.
	* gm2/mc/mcOptions.mod:  added case, array, return
	  option variables.

2016-07-13      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-3.bnf:  ConstExpressionNop (New production).
          ConstFactor (use ConstSetOrQualidentOrFunction).
          ComponentElement (use ConstExpressionNop).
          ConstActualParameters (use ConstExpList).
          ConstExpList (use ConstExpressionNop).
          AlignmentExpression (use ConstExpressionNop).
          PragmaConstExpression (use ConstExpressionNop).
          AttributeExpression (use ConstExpressionNop).
          CaseLabels (use ConstExpressionNop).
          ForStatement (use ConstExpressionNop).
          Priority (use ConstExpressionNop).
	* gm2/bnf/mc-4.bnf:  ConstComponentValue (New production).
          ConstComponentElement (New production).
          ConstComponentValue (New production).
          ConstArraySetRecordValue (New production).
          ConstConstructor (New production).
          ConstActualParameters (New production).
          ConstExpList (New production).
          Constructor, ArraySetRecordValue, ComponentValue,
          ComponentElement (Productions now do nothing).
	* gm2/bnf/mc-5.bnf:  ConstExpressionNop (New production).
          ConstantDeclaration (use ConstExpressionNop).
          ConstExpression (use ConstExpressionNop).
          ConstComponentElement (new production).
          ConstArraySetRecordValue (new production).
          ConstConstructor (new production).
          ConstActualParameters (new production).
          ConstExpList (new production).
          AlignmentExpression (use ConstExpressionNop).
          SubrangeType (use ConstExpressionNop).
          AttributeExpression (use ConstExpressionNop).
          VarientCaseLabels (use ConstExpressionNop).
          VarIdent (use ConstExpressionNop).
          ComponentElement (new production).
          ComponentValue (new production).
          ArraySetRecordValue (new production).
          Constructor (new production).
          OptArg (new production).
          DefOptArg (new production).
          Priority (new production).
	* gm2/mc/decl.def:  makeSetValue (New procedure function).
          isSetValue (new procedure function).
          putSetValue (new procedure function).
          includeSetValue (new procedure function).
	* gm2/mc/decl.mod:  in (New node kind).
          setvalue (New node kind).
          makeSetValue (Implement procedure function).
          isSetValue (Implement procedure function).
          putSetValue (Implement procedure function).
          includeSetValue (Implement procedure function).
          isAnyType (New procedure function).
          makeCast (New procedure function).
          isUnary (New procedure function).
          isDeref (New procedure function).
          doSetExprType (New procedure function).
          getMaxMinType (New procedure function).
          doGetFuncType (New procedure function).
          getExprType (New procedure function).
          doGetLastOp (New procedure function).
          getLastOp (New procedure function).
          doComponentRefC (New procedure).
          doSetValueC (New procedure).
          doInC (New procedure).
          doNewC (completed).
          doDisposeC (completed).
          doAbsC (New procedure).
          doValC (New procedure).
          doMinC (New procedure).
          doMaxC (New procedure).

2016-07-06      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-5.bnf:  ConstExpList introduce more asserts.
          ArrayExpList introduce more asserts.  ExpList introduce more asserts.
          Term, Factor generate an expression.  ExitStatement introduce
          an assert.  Statement allow empty statements to be produced.
	  StatementSequence introduce assert.
	* gm2/mc/decl.mod:  introduce ABS intrinsic.  isVarDecl,
          identListLen, isArrayRef, isZero, doArrayRef, doProcedure,
          doStringC, outCard, doSubtractC, checkDeclareUnboundedParamCopyC,
          checkUnboundedParamCopyC, doUnboundedParamCopyC,
          addVariablesTodo, addTypesTodo, simplifyVar, doWhileC, doFuncHighC,
          doMultiplyBySize, doTotype, doFuncUnbounded, doFuncParamC,
          getNthParamType, doAdrC, doIncDecC, doInclC, doExclC, doNewC,
          doDisposeC, isIntrinsic, doIntrinsicC, getFuncFromExpr,
          doFuncExprC, doLocalVarC, addParamDone, includeParameters
	  (New procedure).
	* gm2/mc/mcPretty.def:  getseekpos, getcurline (New procedure functions).
	* gm2/mc/mcPretty.mod:  getseekpos, getcurline (implemented).

2016-06-22      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-3.bnf:  merged definition and module variable declaration
	  rules.  Always pop the return result from ConstExpression.
	* gm2/bnf/mc-4.bnf:  no longer declare variables in pass 4.
	* gm2/bnf/mc-5.bnf:  major changes which include generation of if/then/else/elsif
          for loops, while loops, repeat loops.  With statements handled.  Expressions are
          built and constant expressions retieved from a previous pass.  Debugging
	  aids also built.  Function/procedure call handled.  Return statement handled.
	* gm2/mc/decl.def:  New procedures: addOptParameter, isOptarg, makeComponentRef, makeDeRef,
          makeArrayRef, resetConstExpPos, makeStatementSequence, isStatementSequence,
          addStatement, makeReturn, isReturn, putReturn, makeWhile, putWhile,
          isWhile, makeAssignment, putBegin, makeExit, makeComment, makeIf,
          isIf, makeElsif, isElsif, putElse, makeFor, isFor, putFor, makeRepeat,
          isRepeat, putRepeat declared and exported.
	* gm2/mc/decl.mod:  new node types, exit, return, stmtseq, comment, new
          dispose, inc, dec, incl, excl, optarg, throw, deref added.
          New procedures:  isLocal, addProcedureToScope, addParameter, isOptarg,
          makeOptParameter, addOptParameter, makeFuncCall, isFuncCall, makeComponentRef,
          makeArrayRef, makeDeRef, makeBinaryTok, getFQstring, needsParen, doUnary,
          doUnary, doBinary, doBinary, doPreBinary, doPreBinary, doExprM2, doVar,
          doOptargC, doPrototypeC, doProcedureHeadingC, doPrototypeC,
          outDeclsDefC, outDeclsDefC, includeVar, joinProcedures, doStatementSequenceC,
          isSingleStatement, doCommentC, doExitC, doReturnC, doAssignmentC,
          doCompoundStmt, doElsifC, noElse, doIfC, doForC, doRepeatC,
          doFuncArgsC, doFuncCallC, doStatementsC, doLocalDeclsC, doProcedureC,
          outProceduresC, walkOptarg, outImpInitC, outModuleC, outModuleInitC,
          outModuleC, outC, dbgVar, dbgArray, makeStatementSequence,
          addStatement, isStatementSequence, makeReturn,
          isReturn, putReturn, makeWhile, putWhile,
          isWhile, makeAssignment, isAssignment, putBegin, makeExit,
          isExit, makeComment, isComment, makeIf, isIf, makeElsif,
          isElsif, putElse, makeFor, isFor, putFor, makeRepeat, isRepeat,
          putRepeat and makeM2rts added.
	* gm2/mc/mcComp.mod:  reintroduce pass 5.
	* gm2/mc/mcStack.def:  new procedure access declared.
	* gm2/mc/mcStack.mod:  new procedure access implemented.

2016-05-24      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-3.bnf:  integer, real no longer push a value to the stack.
          call setConstExpComplete at the end of the pass.  Remove result of the
	  constexpression.   Add many asserts to aid debugging.
	* gm2/bnf/mc-4.bnf:  remove calls to setEnumsComplete.  Call fixupConstExp
	  in ConstExpression.  Call makeFuncCall in ConstSetOrQualident.
          Remove all type generation building.  Remove import handling.
	* gm2/bnf/mc-5.bnf:  remove all references to resetFuncFixup.
	  Remove call to applyFuncFixup.
	* gm2/gm2-libs/DynamicStrings.mod:  trip whitespace.
	* gm2/mc/alists.mod:  correct indentation.
	* gm2/mc/decl.def:  remove resetFuncFixup, replace it with makeExpList.
          remove makeFuncFixup and replace with isExpList.  Remove isFuncFixup
          and replace with putExpList.  Remove makeExpList and replace with
          makeConstExp.  Remove isExpList and replace it with getNextConstExp.
	  Remove putExpList and replace with setConstExpComplete.
          fixupConstExp (new procedure function).  Remove applyFuncFixup
	  and replace with makeFuncCall.
	* gm2/mc/decl.mod:  added funccall, constexp and chr to nodeK.
          Also modified all associated procedure functions.  Replaced
          funcFixup with constFixup.  Added constsComplete to definition,
          implementation and program modules.  Only generate #include
          if the getExtendedOpaque switch is not set.  Initialise ord, chr
	  and val as base procedure functions.
	* gm2/mc/mcComp.mod:  always invoke pass4, temporarily short circuit
	  pass 5.

2016-05-23      Gaius Mulley <gaius@gnu.org>

	* interim checkin:

2016-05-21      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-2.bnf:  create enums for .mod files as well as .def files.
	* gm2/bnf/mc-3.bnf:  fixed bug, make empty varient leave the stack alone.
	* gm2/bnf/mc-4.bnf:  likewise applied to pass 4.  Create enums
          for .mod files.  DefQualident, DefTypeEquiv, DefEnumIdentList,
          DefEnumeration, DefSimpleType, new rules introduced and used.
	* gm2/examples/pge/twoDsim.mod:  right hand white space removed.
	* gm2/mc/decl.mod:  loc introduced.  Parameter building and
	variable shadowing introduced.
	* gm2/mc/mcComp.mod:  commented out p5.
	* gm2/mc/wlists.mod:  renamed maxNoOfElements and noOfElements.

2016-05-17      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-5.bnf:  introduce func fixups.  Removed all
          constant expression procedures.  Removed all type
          generation procedures.  Removed all import processing
          as this should be done in previous passes.
	* gm2/mc/decl.def:  (resetFuncFixup) new procedure.
          (makeExpList) new procedure function.  (putExpList) new
          procedure.  (applyFuncFixup) new procedure.
	* gm2/mc/decl.mod:  (explist) new kind.  (resetFuncFixup)
	  implemented new procedure.
          (makeExpList) implemented new procedure function.
          (putExpList) implemented new procedure.
          (applyFuncFixup) implemented new procedure.

2016-05-16      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added mcp5.mod to be built and linked into mc.
          Removed SysExceptions from being built as part of the bootstrap
          for mc.  mc does not need it as SysExceptions is a gm2 runtime
          library.  Removed reference to m2flex.def in MC-DEFS.  Removed
          mcflex.mod from MC-MODS.
	* gm2/init/mcinit:  added mcp5 to be linked and initialised.
	* gm2/mc/README:  corrected the pass description, now that pass 3
          is used by .def and .mod files.  Thus there is no need for pass 6.
          Pass 5 functionality now contains the old pass 6 description.
	* gm2/mc/decl.mod:  new kind funcfixup to allow fixups to be applied
          between constant functions and their parameters (possibly types).
          (eg. MAX(typename)).  Created a fixupInfo record which is used by
          enum fixups and constant function fixups.
	* gm2/mc/mcComp.mod:  enable pass 5.
	* At this point mc should handle constants, all data types and
          generate a tree of nodes representing them.  All procedure prototypes
          are known.  All that is left to do is build a tree of nodes
          representing the code and then walk the tree generating
	  C11 or C++ code.

2016-05-11      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added rules to bootstrap mc mod files.
	* gm2/bnf/mc-3.bnf:  use Expression rather than ConstExpression in
          ComponentElement.
	* gm2/mc/decl.mod:  added mult, throw nodes.  Fixed ord to be a unary
          operator.  doSetC (New procedure).  includeSyms renamed includeConstType.
          includeVarProcedure (New procedure).  includeDefConstType (New procedure).
          Export size from SYSTEM.  Attempt to declare const/types before
          var/procedures.

2016-05-10      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  write and writeln call FlushBuffer
	  as a debugging aid.  tempName returns a String.
          makeIntermediateType new procedure function.
          simplifyType call tempName and makeIntermediateType.
          doSimplifyNode also simplifies pointer types.
          outDeclsDefC outputs constants, types and then variables.
          walkPointer returns completed if the type is partial or done.
          walkVarientField returns partial if field type is on the partialQ.
          tryPartial moves pointer types.
          outputPartial moves over pointer types and issues '*' accordingly.

2016-05-09      Gaius Mulley <gaius@gnu.org>

	* gm2/mc/decl.mod:  many changes and bug fixes.  Modula-2 output
	  of data structures implemented and pretty printing of M2, C
          data structures implemented.
	* gm2/mc/mcOptions.mod:  corrected --olang= processing.
	* gm2/mc/mcPretty.def:  pushPretty and popPretty
          (New procedure functions) defined.
	* gm2/mc/mcPretty.mod:  pushPretty and popPretty
          (New procedure functions) implemented.

2016-04-27      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  force the mc-boot rule.
	* gm2/bnf/mc-3.bnf:  many bug fixes and finished implementing
          record/varient record handling.
	* gm2/mc/decl.def:  add second parameter to
          buildVarientFieldRecord.
	* gm2/mc/decl.mod:  min, max new nodes.  makeArray skip type.
          buildVarientFieldRecord add second parameter and use it.
          Many features added and code added.
	* gm2/mc/mcOptions.mod:  new option --ignore-fq.
	* gm2/mc/mcStack.def:  depth (New procedure function).
	* gm2/mc/mcStack.mod:  implemented depth.

2016-04-23      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  rewrite of mc-autogen which currently tests
	  the translation of the library modules required by mc.
	* gm2/bnf/mc-1.bnf:  bug fix to allow procedures to be declared
	  in both definition and implementation modules.
	* gm2/bnf/mc-3.bnf:  interim change prior to fixing a bug in
          the varient record handling.

2016-04-21      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-1.bnf:  distinguish between from module import and
          import module.  Call putTypeHidden for a hidden type.
	* gm2/bnf/mc-2.bnf:  distinguish between from module import and
          import module.  Follow scopes during procedures.  No longer
	  call registerImport.
	* gm2/bnf/mc-3.bnf:  remove registerImport.  Ensure that the
          definition module scope is visible below the implementation
          module.  Use Qualident rather than PushQualident for non
	  data structure based rules.
	* gm2/mc/decl.def:  hasHidden, foreachModModuleDo, paramEnter,
          paramLeave (new procedures).  addImportedModule changed to include
          and extra parameter.
	* gm2/mc/decl.mod:  added tsize node.  Many changes implementing
	  the above and bug fixing topological sort algorithm.
        * gm2/mc/mcComp.mod:  changes to allow --extended-opaque to take
          effect.  The implementation module for each definition module which
	  defines an opaque type will be parsed.
        * gm2/mc/mcOptions.def:  introduce --extended-opaque option.
	* gm2/mc/mcOptions.mod:  record --extended-opaque option.
	* gm2/Make-lang.in:  alter MCOPTIONS to include runtime checking.
	* gm2/gm2-libs/FormatStrings.mod:  implement %x as a format
          specifier.
	* gm2/gm2-libs/SFIO.mod:  WriteS check that s is not NIL.
	* gm2/mc/decl.mod:  topological sort bugfix.  Implemented
          data structure debugging which can be turned on via
          --debug-top.  Many bug fixes and tidying up.
	* gm2/mc/mcOptions.mod:  record --debug-top option.
	* gm2/mc/mcOptions.def:  getDebugTopological (new
          procedure function).
	* gm2/mc/decl.mod:  bug fix to allow proctypes and
	  parameters to be generated from partial declarations.a

2016-04-18      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  new rule mc-autogen.
	* gm2/bnf/mc-1.bnf:  fixed scope tracking for implementation module.
	  Use makeTypeImp during type declaration in implementation module.
	* gm2/bnf/mc-2.bnf:  fixed scope tracking for implementation module.
	* gm2/bnf/mc-3.bnf:  corrected grammar during type declaration.
	* gm2/mc/decl.def:   isVisited (new procedure function).  unsetVisited,
	  setVisited (new procedure).  makeTypeImp (new procedure function).
	* gm2/mc/decl.mod:  implement isVisited, unsetVisited, setVisited,
	  makeTypeImp.  Many bug fixes to topological output of declarations.
          All type declarations including recursive declarations are now
          implemented.
	* gm2/mc/mcComp.mod:  parse implementation module during pass 1
	  and pass 2.

2016-04-14      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  changed gm2-bootstrap test.
	* gm2/bnf/mc-1.bnf:  changed variable creation so that both
	def and mod declare variables.  Added epsilon instead of [].
	Added scope handling to procedures.  Allowed implementation and
	program modules to be passed.
	* gm2/bnf/mc-2.bnf:  Added epsilon instead of [].  Tidied up.
	* gm2/mc/decl.mod:  continued development and debugging.

2016-04-12      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  added mc-4.bnf to be built.
	* gm2/bnf/mc-3.bnf:  bug fixes so that return results are recorded from procedure functions.
	* gm2/init/mcinit:  added mcp4.
	* gm2/mc/decl.mod:  more development.
	* gm2/mc/mcComp.mod:  include pass 4.

2016-04-11      Gaius Mulley <gaius@gnu.org>

	* gm2/Make-lang.in:  new very simple rules for mc-devel and
          initial attempt at gm2-bootstrap using mc.
	* gm2/mc/decl.def:  implement variable declarations.
	* gm2/mc/decl.mod:  many changes to implement pass 3 and
	  the output of recursive data structures.
	* gm2/mc/mcError.def:  fixed parameter declarations so that they
	  match their implementation counterparts.
	* gm2/mc/mcError.mod:  consistant parameter declarations.
	* gm2/mc/mcLexBuf.def:  fixed parameter declarations so that they
	  match their implementation counterparts.
	* gm2/mc/mcMetaError.def:  fixed parameter declarations so that
          they match their implementation counterparts.
	* gm2/mc/mcPreprocess.mod:  use alists rather than lists.
	* gm2/mc/mcSearch.def:  consistant parameter declarations.
	* gm2/mc/mcSearch.mod:  consistant parameter declarations.
	* gm2/mc/nameKey.def:  consistant parameter declarations.
	* gm2/bnf/mc-3.bnf:  fix variable declarations in definition modules.
	* gm2/mc/mc.flex:  correct prototype.

2016-03-14      Gaius Mulley <gaius@gnu.org>

	* gm2/bnf/mc-1.bnf:  new file.
	* gm2/bnf/mc-2.bnf:  new file.
	* gm2/bnf/mc-3.bnf:  new file.
	* gm2/gm2-gcc/gcc-consolidation.h:  new file.
	* gm2/mc/Indexing.def:  new file.
	* gm2/mc/Indexing.mod:  new file.
	* gm2/mc/README:  new file.
	* gm2/mc/alists.def:  new file.
	* gm2/mc/alists.mod:  new file.
	* gm2/mc/decl.def:  new file.
	* gm2/mc/decl.mod:  new file.
	* gm2/mc/decl.mod-extra:  new file.
	* gm2/mc/lists.def:  new file.
	* gm2/mc/lists.mod:  new file.
	* gm2/mc/m2flex.def:  new file.
	* gm2/mc/mc.flex:  new file.
	* gm2/mc/mcComp.def:  new file.
	* gm2/mc/mcComp.mod:  new file.
	* gm2/mc/mcDebug.def:  new file.
	* gm2/mc/mcDebug.mod:  new file.
	* gm2/mc/mcError.def:  new file.
	* gm2/mc/mcError.mod:  new file.
	* gm2/mc/mcFileName.def:  new file.
	* gm2/mc/mcFileName.mod:  new file.
	* gm2/mc/mcLexBuf.def:  new file.
	* gm2/mc/mcLexBuf.h:  new file.
	* gm2/mc/mcLexBuf.mod:  new file.
	* gm2/mc/mcMetaError.def:  new file.
	* gm2/mc/mcMetaError.mod:  new file.
	* gm2/mc/mcOptions.def:  new file.
	* gm2/mc/mcOptions.mod:  new file.
	* gm2/mc/mcPreprocess.def:  new file.
	* gm2/mc/mcPreprocess.mod:  new file.
	* gm2/mc/mcPrintf.def:  new file.
	* gm2/mc/mcPrintf.mod:  new file.
	* gm2/mc/mcQuiet.def:  new file.
	* gm2/mc/mcQuiet.mod:  new file.
	* gm2/mc/mcReserved.def:  new file.
	* gm2/mc/mcReserved.h:  new file.
	* gm2/mc/mcReserved.mod:  new file.
	* gm2/mc/mcSearch.def:  new file.
	* gm2/mc/mcSearch.mod:  new file.
	* gm2/mc/mcStack.def:  new file.
	* gm2/mc/mcStack.mod:  new file.
	* gm2/mc/mcflex.def:  new file.
	* gm2/mc/mcp1.def:  new file.
	* gm2/mc/mcp2.def:  new file.
	* gm2/mc/mcp3.def:  new file.
	* gm2/mc/nameKey.def:  new file.
	* gm2/mc/nameKey.mod:  new file.
	* gm2/mc/symbolKey.def:  new file.
	* gm2/mc/symbolKey.mod:  new file.
	* gm2/mc/top.mod:  new file.
	* gm2/mc/varargs.def:  new file.
	* gm2/mc/varargs.mod:  new file.
	* gm2/mc/wlists.def:  new file.
	* gm2/mc/wlists.mod:  new file.
	* gm2/Make-lang.in:  generate cpp version stub.  Use $(COMPILER)
          rather than $(CC).  Removed all trailing whitespace.  Added
          rules for building mc.
	* gm2/configure.in:  corrected test (=) rather than (==).
	* gm2/configure:  rebuilt.
	* gm2/gm2-compiler/M2Comp.mod:  updated dates and removed trailing
          white space.
	* gm2/gm2-compiler/M2Error.mod:  updated dates and removed trailing
          white space.
	* gm2/gm2-compiler/M2LexBuf.mod:  corrected spacing at the end of
          a comment.
	* gm2/gm2-compiler/NameKey.mod:  corrected spacing at the end of
          a comment.
	* gm2/gm2-gcc/m2assert.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2block.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Change binding level code
          from C to C++.
	* gm2/gm2-gcc/m2builtins.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2convert.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Many changes to bring it
          up to gcc-5.2.0.
	* gm2/gm2-gcc/m2decl.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2except.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Minor changes to bring it into
	  line with gcc-5.2.0.
        * gm2/gm2-gcc/m2expr.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Minor changes to bring it into
          line with gcc-5.2.0.
	* gm2/gm2-gcc/m2linemap.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2misc.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2statement.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  C++ changes in gimplifiation
          of nested procedure functions.
	* gm2/gm2-gcc/m2top.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2tree.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.
	* gm2/gm2-gcc/m2treelib.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Many changes to convert C to C++
          and statement related data structure and methods have changed.
	* gm2/gm2-gcc/m2type.c:  use #include "gcc-consolidation.h" to
          hold all gcc related header files.  Many changes to convert C to C++
          and statement related data structure and methods have changed.
	* gm2/gm2-lang.c:  Many changes to convert C to C++
          and statement related data structure and methods have changed.
          Many changes to bring code into gcc-5.2.0.
	* gm2/gm2-lang.h:  changes to bring code into gcc-5.2.0.
	* gm2/gm2-libs/DynamicStrings.def:  additional dates.
	* gm2/gm2-libs/DynamicStrings.mod:  define desState and use it in
          descriptor.
	* gm2/gm2-libs/Indexing.def:  new procedure (DeleteIndice).
	* gm2/gm2-libs/Indexing.mod:  new field Used.  New procedure
          (DeleteIndice).
	* gm2/gm2-libs/SYSTEM.def:  additional dates.
	* gm2/gm2-libs/TimeString.def:  removed trailing white space.
	* gm2/gm2spec.c:  extra parameter to fe_save_switch  (used).
	* gm2/gm2version.h:  simplified conditional compilation.
	* gm2/lang.opt:  made options complient with gcc-5.2.0.
	* gm2/m2.flex:  use gm2-gcc/gcc-consolidation.h.  Fix int/unsigned int
          and cast of strings so that g++ will compile flex
	  generated output file.
	* gm2/m2pp.c:  use gm2-gcc/gcc-consolidation.h rather than
	  a list of include files.  Changed to make it gcc-5.2.0 complient.
	* gm2/tools-src/makeversion:  generate C++ gm2_version function if
	  the new option, -p, is used.  -p new option implemented.
	* gm2/tools-src/mklink.c:  fix typo.
	* testsuite/gm2/pim/pass/enum.mod:  new test code.

2016-03-03      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  checkRecordTypes new procedure
	function.  checkBecomes new procedure function.  CodeBecomes
	use checkBecomes.  This fixes a bug reported by
        <Georg.Lokowandt@t-online.de> (bug6.mod).

2016-02-25      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/gravity/Makefile.in:  fixed linewrap in
	  libtwoDsim.la.

2016-02-22      Gaius Mulley <gaius@gnu.org>

	* gm2/configure:  rebuilt.
	* gm2/configure.in:  version number change to 1.1.6.
	* gm2/gm2-libs/config-host.in:  version number change to 1.1.6.
	* gm2/gm2-libs/config-target.in:  version number change to 1.1.6.
	* gm2/version.c:  version number change to 1.1.6.

2016-02-19      Gaius Mulley <gaius@gnu.org>

	* gm2/gm2-compiler/M2GenGCC.mod:  CheckConvertCoerceParameter
          checks to see if an actual parameter is a constant string
          and if so calls BuildConvert.  This fixes a bug reported by
	  <Georg.Lokowandt@t-online.de> (bug5.mod).

2016-01-26      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/gravity/Makefile.in:  introduced LIBDIR which is
	  set dynamically to reflect the host architecture.

2016-01-19      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/gravity/Makefile.in:  rewritten to use libtool
	  when generating the shared library.

2016-01-14      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/gravity/Makefile.in:  converting Makefile.in
	to use libtool.
	* gm2/examples/gravity/twoDsim.mod:  removed tabs.
	* gm2/gm2-compiler/M2GCCDeclare.mod:  removed tabs.
	* gm2/gm2-gcc/m2decl.c:  set DECL_ARTIFICIAL and
          DECL_IGNORED_P for temporary variables.  (do_min_tree)
          (do_max_tree) new functions which are called by GetMinFrom
          and GetMaxFrom respectively.  This fixes a bug reported by
	  Michael Riedl.

2015-11-30      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/gravity/twoDsim.mod:  fixed syntax error.
	* gm2/examples/pge/bounce3.mod:  use groff device.
	* gm2/examples/pge/bounce4.mod:  use groff device.
	* gm2/examples/pge/slope.mod:  use groff device.
	* gm2/examples/pge/stairs.mod:  use groff device and increase
          simulated time.
	* gm2/gm2-compiler/ppg.mod:  removed white space and fixed
          bug with emitting source line preprocessor symbols.
	* gm2/m2.flex:  fixed floating point constant bug reported
          by Michael Riedl (to allow 1.E10 etc).
	* testsuite/gm2/iso/constreal.mod:  new file.
	* gm2/el/g-mode.el:  fixed comment spacing at end of sentance
          in the automatically generated header and updated the dates.

2015-10-07      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/twoDsim.mod:  tided up debugging.
	* gm2/examples/pge/elc2.mod:  New file.
	* gm2/examples/pge/rboxes.mod:  New file.

2015-10-06      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/Makefile.in:  build rotating-circles.m.
	* gm2/examples/pge/mxmparser.py:  formatting change.
	* gm2/examples/pge/mxmtree.py:  add terms and call pent, hex,
	  sept, oct for powers 5..8.
	* gm2/examples/pge/roots.def:  findOctic new procedure function.
	* gm2/examples/pge/roots.mod:  findOctic new procedure function
	  wrapper implemented.
	* gm2/examples/pge/rotating-circles.mxm:  corrected terms and
	  renamed some of the variables.
	* gm2/examples/pge/rotating-line.mxm:  tidied up comments.
	* gm2/examples/pge/twoDsim.mod:  new procedure functions,
	  pent, hex, sept, oct.  New procedure getObjectOrbitingValues.
	  New procedure maximaCircleCollisionOrbiting.  New procedure
	  function earlierCircleCollisionOrbiting.  New procedure
	  findCollisionCircleLineOrbiting.  Removed
	  findCollisionCircleRLine.  findCollisionCirclePolygon call
	  appropriate routine depending upon whether the polygon is
	  orbiting.  New procedure function, isOrbiting.
	  findCollisionLineLine call appropriate routine depending
	  upon whether polygon is orbiting.  New procedure
	  findCollisionLineLineOrbiting.

2015-10-05      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/Makefile.in:  added new rule for elc2.mod
	* gm2/examples/pge/coord.mod:  tidied up formatting.
	* gm2/examples/pge/twoDsim.mod:  added Elasticity constant,
	  angularMomentum for objects.  New procedure function (reflect).
          collidePolygonAgainstMovingPolygon (rewritten).
	  Interim checkin.

2015-09-28      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/Makefile.in:  new example circle added.
	* gm2/examples/pge/coord.def:  new procedure function
	  perpendicular.
	* gm2/examples/pge/coord.mod:  implemented new procedure
	  function perpendicular.
	* gm2/examples/pge/polar.mod:  cosmetic spaces added.
	* gm2/examples/pge/popWorld.mod:  cosmetic spaces added.
	* gm2/examples/pge/twoDsim.mod:  many cosmetic changes
	  and also more explicit parameters which determine if
	  edge or corner was in collision.  First cut of the polygon
	  collision reaction implemented.
	* gm2/gm2.texi:  removed duplication switch.
	* gm2/gm2-gcc/m2linemap.c:  use xstrdup to preserve filename
	  from being garbage collected.  This fixes a critical bug
	  in the debugging output of large source files when -fcpp
	  was used.

2015-09-14      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/Makefile.in:  add boxes.raw and removed
	  dependancy output.raw from playback.
	* gm2/examples/pge/bounce.mod:  remove rotate.
	* gm2/examples/pge/boxes.mod:  changed output device.
	* gm2/examples/pge/examples/exampleBoxes.py:  changed sound
	  file examples.  Changed crate example.
	* gm2/examples/pge/pge.py:  added poly3 method.
	* gm2/examples/pge/pgeif.mod:  check_range attempts to prevent
	  round off errors and changed to provide a better descriptive
	  error message.
	* gm2/examples/pge/pgeplayback.py:  changes to allow generation
	  of a movie with appropriate sounds effects.
	* gm2/examples/pge/polar.def:  new procedure function rotatePolar.
	* gm2/examples/pge/polar.mod:  implement new procedure function
	  rotatePolar.
	* gm2/examples/pge/twoDsim.def:  define new procedure function
	  rvel.
	* gm2/examples/pge/twoDsim.mod:  major changes to the definition
	  of the polygon data structures, now use a c of g and polar
	  coordinates to describe polygon.  Removed rpolygon.

2015-09-09      Gaius Mulley <gaius@gnu.org>

	* gm2/examples/pge/examples/exampleBoxes.py:  interim checkin.
	* gm2/examples/pge/pge.py:  get_xvel, get_yvel, get_xaccel,
	  get_yaccel, process_event new methods.
	* gm2/examples/pge/pgeif.def:  get_xvel, get_yvel, get_xaccel,
	  get_yaccel (New procedure functions).
	* gm2/examples/pge/pgeif.i:  get_xvel, get_yvel, get_xaccel,
	  get_yaccel (New functions).
	* gm2/examples/pge/pgeif.mod:  get_xvel, get_yvel, get_xaccel,
